<?php
require_once("lib-tk/shield.php");
require_once("lib-api-action/apiaction.php");
require_once("lib-mbapi/include/mail/emailTemplates/passwordNotificationEmail.php");

class ForgotPassword extends MB_AdminAPIAction
{
    public function __construct()
    {
        parent::__construct(1);
    }

    public function execute()
    {
        parent::execute();

        if (is_null($email = bgpc("email"))) {
            throw new Exception("Missing parameter 'email'");
        }

        $clientContact = Factory()->ClientContact($email, "contact_email");
        if (1 != $clientContact->contact_active) {
            throw new Exception("Client is not active");
        }

        $newPassword = getRandomPassword(12);

        $clientContact->contact_password = getPasswordHash($newPassword);
        require_once("object_managers/ClientContactManager.php");
        ClientContactManager::update($clientContact, $newPassword);

        $email = new PasswordNotificationEmail( $newPassword, $clientContact->id );
        if (!$email->execute()) {
            throw new Exception("Failed to send email");
        }

        return $this->output();
    }
}