<?php
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditConfigParams
 * action and modifies an existing config param record if data is valid; else redirects
 * back to EditConfigParams.
 *
 * @author  Michael Fountain
 */
class EditConfigParamsResponse extends MB_Action {

	function EditConfigParamsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditConfigParamsResponse";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$updateConfigParams = array();
		$configGroupID = 0;

		$invoice_logo = Factory()->ConfigGroup(0)->getChild("billing")->getChild("pdfInvoice")->getConfigParam("invoice_logo");
		foreach($_REQUEST["configParams"] as $configParam) {
			// find the configGroupID for these params
			if (!$configGroupID) {
				$configGroupID = getConfigParamGroupID($configParam["configParamID"]);
			}
			$configParamID = ((int) $configParam["configParamID"]);
			if ($configParamID != $invoice_logo->config_param_id) {
				$configParamValue = (!is_array($configParam["configParamValue"])) ?
				$configParam["configParamValue"] : $configParam["configParamValue"][0];
			} else {
				$file = $_FILES[$invoice_logo->config_param_name];
				if ("" == $file["name"]){
					continue;
				}

				require_once('FileDownloadClass.php');
				$ext = FileDownloadClass::getFileExt($invoice_logo->config_param_name);
				$default_logo_name = "logo.".$ext;
				require_once('object_managers/InvoiceManager.php');
				if (!in_array($ext, InvoiceManager::getPdfImageTypes()))	{
					$this->addError(blmsg("TRANS_ACTIONERROR"), blmsg("TRANS_INCORRECT_IMAGE_FILE_TYPE", array("IMAGE_TYPE" => $ext)));
					$this->addErrorTemplates();
					return $this->hasExecutedSuccessfully();
				}
				FileDownloadClass::downloadFile(Config()->invoiceLogoDirectory, $invoice_logo->config_param_name, $default_logo_name);
				$configParamValue = $default_logo_name;
				if ($configParamValue != $invoice_logo->config_param_value) {
					unlink(Config()->invoiceLogoDirectory."/".$invoice_logo->config_param_value);
				}
			}

			$updateConfigParams[] =
				 "<configParam>\n"
				."  <configParamID>".$configParamID."</configParamID>\n"
				."  <configParamValue>".$configParamValue."</configParamValue>\n"
				."</configParam>\n";
		}

		if (count($updateConfigParams)==0 || $configGroupID==0) {
			$this->addError(TRANS_ACTIONERROR, "No config params given.");
		} else {

			$xmlParams = array
			(
				"configGroupID" => $configGroupID,
				"configParams"  => implode("\n",$updateConfigParams)
			);
			$query = getMBAPIQuery("SetConfigs", "update", $xmlParams);
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

                // more logic should be here to determine if the save was good or bad
                // assumption now is that the save is ALWAYS good - MF
                $args = "&saved=1";

				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"].$args);
				} else {
					redirect("configs.php",getActionID("ShowConfigs"), array("parentConfigGroupID"=>0));
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // MB_Action
?>