<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class FirstTimeDisplayStep extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		if ($_REQUEST["a"]=="sharedip"){
			$param = oneOf(":configParams", array(
				"configParamName" => "ip",
				"configParamValue" => "UNKNOWN",
			));
			// we don't want to mess with the shared ip from here if they don't need it
			if (!(int)$param["configParamID"]){
				$_REQUEST["a"] = "gateway";
			}
		} elseif ($_REQUEST["a"]=="encryption"){
			require_once("object_managers/CryptManager.php");
			if ( CryptManager::isEncryptionEnabled() ) {
				// we don't want to mess with encryption if they have already done it
				$_REQUEST["a"] = "fraudguardian";
			}
		}

		if ($_REQUEST["a"]=="" || $_REQUEST["a"]=="registrar" || !$_REQUEST["a"]){

			if (licRawData!="FREE"){
				$ama = $_MB_ALIASES["admin"] ? $_MB_ALIASES["admin"] : "admin";
				$returnURL = (($CONF["secureURLProtocol"]=="http")?"http://".$CONF["standardURL"]:"https://".$CONF["secureURL"])."/".$ama."/configs.php?action=".getActionID("FirstTimeDisplayStep")."&sid=".$_REQUEST["sid"]."&a=registrar&enomUsername=USERNAME&enomPassword=PASSWORD";
				$securityCode = getPasswordHash(Crypt::ENCRYPTION_KEY.$returnURL);
				$this->smartyVars["returnURL"] = base64_encode($returnURL);
				$this->smartyVars["securityCode"] = $securityCode;
				$this->smartyVars["adminInfo"] = oneByID(":admins", $CONF["user"]["id"]);
				$this->smartyVars["companyInfo"] = oneByID(":companies", 1);
				$country = oneByID(":countries", $this->smartyVars["companyInfo"]["countriesID"]);
				$this->smartyVars["companyInfo"]["countriesISO2"] = $country["countriesISO2"];
			}

			$registrars = getAvailableModules("registrar");

			loadConfigs("server");
			loadConfigs("domain");
			if (!is_array($CONF["domain"]["registrar"])){
				$CONF["domain"]["registrar"] = array();
			}
			$p = $this->getMBAPIQuery("GetConfigGroups", "", array("configGroupName" => "registrar"));
			require_once mb_path("/lib-mbapi/mbapi.php");
			$parent = grabSimpleMBAPIResults(dispatchMBAPI($p, 1));
			$parentID = $parent[0]["configGroupID"];

			foreach ($registrars as $regName){
				$regName = basename($regName, ".php");
				if ($regName=="generic") continue;
				if (!$CONF["domain"]["registrar"][$regName]){
					$addNew = new MBQuery("SetConfigGroups", "insert", array(
						"parentConfigGroupID" => $parentID,
						"addRegistrar" => $regName,
					));
					$addNew->getResult();
				} else {
					$CONF["domain"]["registrar"][$regName]["modulePassword"] = getStuff($CONF["domain"]["registrar"][$regName]["modulePassword"]);
				}
			}
			// again to refresh
			loadConfigs("domain");

			if ($_REQUEST["enomUsername"]){
				$cpu = oneOf(":configParams", array(
					"configParamName" => "moduleUsername",
					"configGroupID" => $CONF["domain"]["registrar"]["enom"]["configGroupID"],
				));
				updateForKey(":configParams", $cpu["configParamID"], array(
					"configParamValue" => $_REQUEST["enomUsername"],
				));
				$cpp = oneOf(":configParams", array(
					"configParamName" => "modulePassword",
					"configGroupID" => $CONF["domain"]["registrar"]["enom"]["configGroupID"],
				));
				updateForKey(":configParams", $cpp["configParamID"], array(
					"configParamValue" => getEncryptedText($_REQUEST["enomPassword"]),
				));
			}

			unset($CONF["domain"]["registrar"]["generic"]);

			foreach ($CONF["domain"]["registrar"] as $r=>$d){
				////////////
				$configGroupID = $d["configGroupID"];
				$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
				$data = dispatchMBAPI($xml, 1);

				$configParamDataResults =& $data["mbapi"][0]["results"][0]["configs"][0]["config"];
				$configParamDataResults = collapseArrayElements($configParamDataResults);

				$parentConfigGroupID = $configParamDataResults[0]["parentConfigGroupID"];

				$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
				$data = dispatchMBAPI($xml, 1);
				$CONF["debug"]->add("MBAPI Results (EditRegistrarConfig)", $data, __FILE__, __LINE__);

				$configParamValueResults =& $data["mbapi"][0]["results"][0];
				// fix child config param values structure when only 1 child config param value exists
				$numParams = $data["mbapi"][0]["header"][0]["numResults"][0];

				// loop through all params to test for param values
				require_once mb_path("/lib-tk/include/translations/debugTranslations.php");
				for($i=0;$i<$numParams;$i++) {
					debugTranslations::checkTransKey($configParamDataResults[$i]["configParamTransKey"], __FILE__, __LINE__);

					$p =& $configParamValueResults["configs"][0]["config"][$i]["paramValues"][0]["paramValue"];
					// loop through param values if they exist
					$numParamValues = count($p);
					for($j=0;$j<$numParamValues;$j++) {
						// define the translation key or display it raw if not defined
						debugTranslations::checkTransKey($p[$j]["configParamValueTransKey"][0], __FILE__, __LINE__);
						if (defined($p[$j]["configParamValueTransKey"][0]) && $p[$j]["configParamValueTransKey"][0] != constant($p[$j]["configParamValueTransKey"][0])) {
							$translatedName = constant($p[$j]["configParamValueTransKey"][0]);
						} else {
							$translatedName = $p[$j]["configParamValueTransKey"][0];
						}
						// shorten the ID
						$configParamID = $configParamValueResults["configs"][0]["config"][$i]["configParamID"][0];
						// create a new smooshed array for html_options in smarty
						$configParamValueName = $p[$j]["configParamValueName"][0];
						$configParamValues[$configParamID][$configParamValueName] = $translatedName;
					}
				}

				foreach($configParamDataResults as $key => $value) {
					if($value["configParamName"] == "modulePassword") {
						$configParamDataResults[$key]["configParamValue"] = getStuff($value["configParamValue"]);
					}
				}

				$CONF["domain"]["registrar"][$r]["configParams"] = $configParamDataResults;
				$CONF["domain"]["registrar"][$r]["configParamValues"] = $configParamValues;
				$CONF["domain"]["registrar"][$r]["parentConfigGroupID"] = $parentConfigGroupID;
				////////////
			}

			$this->smartyVars["registrars"] =& $CONF["domain"]["registrar"];

			$this->smartyVars["step"] = "registrar";

		} elseif ($_REQUEST["a"]=="sharedip"){
			$this->smartyVars["step"] = "sharedip";
			$this->smartyVars["configParamID"] = $param["configParamID"];
		} elseif ($_REQUEST["a"]=="gateway"){
			require_once("object_managers/OrderFormManager.php");
			$default_form = OrderFormManager::getDefaultForm();
			$enabled_gateways = array();
			if ( !is_null($default_form->PrimaryGateway) ) {
				$enabled_gateways["{$default_form->PrimaryGateway->payment_gateway_module}{$default_form->PrimaryGateway->id}"] = 1;
			}
			foreach ( $default_form->ThirdPartyGatewaysList() as $gateway ) {
				$enabled_gateways["{$gateway->payment_gateway_module}{$gateway->id}"] = 1;
			}

			require_once("objects/PaymentGateway.php");
			require_once("object_managers/PaymentGatewayManager.php");
			$this->smartyVars["primaryGateways"] = $this->getPaymentGatewaysVars(
				PaymentGatewayManager::getModules(PaymentGateway::TYPE_PRIMARY)
			);
			$this->smartyVars["thirdPartyGateways"] = $this->getPaymentGatewaysVars(
				PaymentGatewayManager::getModules(PaymentGateway::TYPE_THIRD_PARTY)
			);
			$this->smartyVars["enabledGateways"] = $enabled_gateways;
			$this->smartyVars["step"] = "gateway";
		} elseif ($_REQUEST["a"]=="taxes"){
			// lets do some taxes
			require_once("object_managers/CompanyManager.php");
			$company = CompanyManager::getProviderCompany();
			$country = Factory()->Country($company->countries_id);
			$this->smartyVars["defaultGrossPriceDisplay"] = $country->default_gross_price_display;

			require_once("object_managers/OrderFormManager.php");
			$order_form = OrderFormManager::getDefaultForm();
			$this->smartyVars["requestTaxVatID"] = $order_form->request_tax_vat_id;
			$this->smartyVars["orderFormVerifyVat"] =  $order_form->order_form_verify_vat;
			if ( OrderFormManager::isVatCountry($country->countries_iso_2) ) {
				$this->smartyVars["requestTaxVatID"] = $this->smartyVars["orderFormVerifyVat"] =  1;
			}
			$taxZoneGroups = arrayFor(":taxZoneGroups");

			if ($taxZoneGroups[0]['taxZoneGroupID']){
				$this->smartyVars["taxZoneGroupID"] = $taxZoneGroups[0]['taxZoneGroupID'];
				$this->smartyVars["taxZone"] = oneOf(":taxZones", array(
					"taxZoneGroupID" => $taxZoneGroups[0]['taxZoneGroupID'],
				));
			}


			$this->smartyVars["products"] = optionsFor(":products");
			$productVariants = arrayFor(":productVariants", array(
				"productVariantActive" => 1,
			));

			$this->smartyVars["taxesEnabled"] = 0;
			$this->smartyVars["productVariants"] = array();
			foreach ($productVariants as $v){
				if ($v["taxZoneGroupID"]==$this->smartyVars["taxZoneGroupID"]){
					$this->smartyVars["taxesEnabled"] = 1;
				}
				$this->smartyVars["productVariants"][$v["productID"]][] = $v;
			}

			$this->smartyVars["step"] = "taxes";
		} else if ( "encryption" == $_REQUEST["a"] ) {
			$this->smartyVars["encryption"]["encryption_agree"] = "agree";
			$this->smartyVars["step"] = "encryption";
		} elseif ($_REQUEST["a"]=="fraudguardian"){

			loadConfigs("other", "fraud");

			$this->smartyVars["fraudguardian"] =& $CONF["other"]["fraud"]["fraudguardian"];

			$this->smartyVars["step"] = "fraudguardian";
		} elseif ($_REQUEST["a"]=="finished"){

			$this->smartyVars["step"] = "finished";

		}

		$this->addTemplate("configs/FirstTimeDisplayStep");
		return $this->hasExecutedSuccessfully();
	}

	private function getPaymentGatewaysVars($modules)
	{
		$gateways_vars = array();
		foreach ( $modules as $module_name ) {
			// add item for new payment gateway
			$gateways_vars[$module_name] = $this->getPaymentGatewayVars($module_name);

			// add items for exisiting payment gateways
			foreach ( Factory()->PaymentGatewayList(array("payment_gateway_module" => $module_name)) as $gateway ) {
				$gateways_vars["{$module_name}{$gateway->id}"] = $this->getPaymentGatewayVars($module_name, $gateway);
			}
		}
		if ( false === uasort($gateways_vars, array($this, "comparePaymentGatewayDisplayName")) ) {
			global $php_errormsg;
			throw new Exception("usort() failed: {$php_errormsg}");
		}
		return $gateways_vars;
	}

	private function getPaymentGatewayVars($module_name, $gateway = null)
	{
		require_once("object_managers/PaymentGatewayManager.php");
		$module_info = PaymentGatewayManager::getModuleInfo($module_name);
		$gateway_vars["name"] = "{$module_info['displayName']} (".blmsg($module_info["status"]).")";
		if ( !is_null($gateway) ) {
			$gateway_vars["name"] .= " - {$gateway->payment_gateway_name}";
		}
		$config_name = (is_null($gateway) ? "{$module_name}" : "{$module_name}{$gateway->id}");
		$input_gateway_name = UIFactory()->InputString("{$config_name}_payment_gateway_name", blmsg("TRANS_GATEWAY_NAME"), true);
		$input_gateway_name->value = (is_null($gateway) ? $module_info["displayName"] : $gateway->payment_gateway_name);
		$gateway_vars["inputControls"][] = array("control" => $input_gateway_name, "group" => "");
		require_once("ModuleTool.php");
		foreach ( ModuleTool::getModuleControls("gateway", $module_name) as $control ) {
			if ( !is_null($gateway) ) {
				require_once("DataObject.php");
				$control->initFromArray(DataObject::getMapOf($gateway->PaymentGatewayParams, "name", "value"));
			}
			foreach ( $control->getInputControls() as $input_control ) {
				$input_control->name = "{$config_name}_{$input_control->name}";
				$gateway_vars["inputControls"][] = array("control" => $input_control, "group" => "");
			}
		}
		return $gateway_vars;
	}

	private function comparePaymentGatewayDisplayName($left_gateway_vars, $right_gateway_vars)
    {
		return strcmp($left_gateway_vars["name"], $right_gateway_vars["name"]);
    }
}
