<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class FirstTimePerformAction extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		dbg($_REQUEST);

		if ($_REQUEST["a"]=="registrar"){
			foreach ($_REQUEST["configParams"] as $configParamID=>$configParamValue){
				if ((int)$configParamID){
					updateForKey(":configParams", $configParamID, array(
						"configParamValue" => $configParamValue,
					));
				}
			}
			$registrars = bgpc("registrars", array());
			foreach ($registrars as $registrar)	{
				foreach ($registrar as $configParamID=>$configParamValue){
					updateForKey(":configParams", $configParamID, array(
						"configParamValue" => $configParamValue,
					));
				}
			}
			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "sharedip",
			));
			exit;
		} elseif ($_REQUEST["a"]=="sharedip"){
			updateForKey(":configParams", $_REQUEST["configParamID"], array(
				"configParamValue" => $_REQUEST["sharedip"],
			));
			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "gateway",
			));
			exit;
		} elseif ($_REQUEST["a"]=="gateway"){
			// do the gateway save
			$configured_gateways = array();
			foreach ( Factory()->PaymentGatewayList() as $gateway ) {
				$configured_gateways["{$gateway->payment_gateway_module}{$gateway->id}"] = $gateway;
			}

			try {
				$primary_gateway_id = null;
				$primary_gateways = bgpc("pgateways_e");
				if ( !empty($primary_gateways) ) {
					$primary_gateway = $this->updatePaymentGateway($primary_gateways[0], $configured_gateways);
					$primary_gateway_id = $primary_gateway->id;
				}

				$third_party_gateway_ids = array();
				foreach ( bgpc("sgateways_e", array()) as $config_name ) {
					$third_party_gateway = $this->updatePaymentGateway($config_name, $configured_gateways);
					$third_party_gateway_ids[] = $third_party_gateway->id;
				}

				require_once("object_managers/OrderFormManager.php");
				$default_form = OrderFormManager::getDefaultForm();
				$default_form->payment_gateway_id = $primary_gateway_id;
				$default_form->thirdPartyGatewayIDs = $third_party_gateway_ids;
				OrderFormManager::update($default_form);
				redirect("configs.php", "FirstTimeDisplayStep", array("a" => "taxes"));
			} catch (ProductException $e) {
				$this->addOperationErrors($e);
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}
		} elseif ($_REQUEST["a"]=="taxes"){

			$taxZoneGroupID = bgpc("taxZoneGroupID");
			$taxZoneID = bgpc("taxZoneID");

			if ("" == $taxZoneGroupID){
				$taxZoneGroupID = insertFor(":taxZoneGroups", array(
					"taxZoneGroupName" => "Products",
					"taxZoneGroupActive" => 1,
				));
			}

			require_once("object_managers/CompanyManager.php");
			if ("" == $taxZoneID){
				require_once mb_path("/lib-billing/include/accounting/Accounting.php");
				$taxZoneID = insertFor(":taxZones", array(
					"countriesISO2" => CompanyManager::getProviderCompany()->Country->countries_iso_2,
					"taxZoneName" => "*",
					"taxZoneAmountType" => 0,
					"taxZoneAmount" => $_REQUEST["taxZoneAmount"],
					"taxZoneDescription" => $_REQUEST["taxZoneDescription"],
					"taxZoneActive" => 1,
					"ledgerAccountID" => getGeneralLedgerAccountID("taxes_payable"),
				));

				DatabaseManager::getConnection()->exec("
					INSERT INTO tax_zone_group_zone_rel (tax_zone_group_id, tax_zone_id)
					VALUES ($taxZoneGroupID, $taxZoneID)
				");
			} else {
				updateForKey(":taxZones", $taxZoneID, array(
					"taxZoneAmount" => $_REQUEST["taxZoneAmount"],
				));
			}

			$variants = arrayFor(":productVariants", array(
				"taxZoneGroupID" => $taxZoneGroupID,
			));

			foreach ((array)$variants as $variant){
				updateForKey(":productVariants", $variant["productVariantID"], array(
					"taxZoneGroupID" => 0,
				));
			}

			if ((int)$_REQUEST["enableTaxes"]){
				foreach ((array)$_REQUEST["taxableProducts"] as $variantID){
					updateForKey(":productVariants", $variantID, array(
						"taxZoneGroupID" => $taxZoneGroupID,
					));
				}
			}

			require_once("object_managers/OrderFormManager.php");
			try {
				$order_form = OrderFormManager::getDefaultForm();
				$order_form->default_tax_zone_id = is_null(bgpc("defaultGrossPriceDisplay")) ? NULL : $taxZoneID;
				$order_form->request_tax_vat_id = is_null(bgpc("requestTaxVatID")) ? 0 : 1 ;
				$order_form->order_form_verify_vat = is_null(bgpc("orderFormVerifyVat")) ? 0 : 1 ;
				OrderFormManager::update($order_form);
				redirect("configs.php", "FirstTimeDisplayStep", array(
					"a" => "encryption",
				));
			} catch (ProductException $e) {
				$this->addOperationErrors($e);
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}
			exit;
		} elseif ($_REQUEST["a"]=="encryption"){
			try {
				$encryption_settings = array();
				$encryption_settings["encryption_agree"] = ($encryption_agree = bgpc("enableEncryption"));
				require_once("object_managers/CryptManager.php");
				if ( "agree" == $encryption_agree ) {
					$lek_pin = bgpc("lek_pin");
					if($lek_pin != bgpc("lek_pin_confirm")) {
						throw new InvalidAttributes(array("lek_pin", "lek_pin_confirm"));
					}
					$encryption_hash = CryptManager::generateEncryptionHash($lek_pin);
					$encryption_settings["lek_pin"] = $lek_pin;
					$encryption_settings["encryption_hash"] = $encryption_hash;
				}
				CryptManager::update($encryption_settings);
				redirect("configs.php", "FirstTimeDisplayStep", array("a" => "fraudguardian"));
			} catch (ProductException $e) {
				$this->addOperationErrors($e);
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}
		} elseif ($_REQUEST["a"]=="fraudguardian"){

			$enableFG = oneOf(":configParams", array(
				"configParamName" => "enableFraudGuardian"
			));
			updateForKey(":configParams", $enableFG['configParamID'], array(
				"configParamValue" => $_REQUEST['enableFraudGuardian'],
			));

			$userFG = oneOf(":configParams", array(
				"configParamName" => "usernameFraudGuardian"
			));
			updateForKey(":configParams", $userFG['configParamID'], array(
				"configParamValue" => $_REQUEST['usernameFraudGuardian'],
			));

			$passFG = oneOf(":configParams", array(
				"configParamName" => "passwordFraudGuardian"
			));
			updateForKey(":configParams", $passFG['configParamID'], array(
				"configParamValue" => $_REQUEST['passwordFraudGuardian'],
			));

			$threshold = oneOf(":fraudCountryThresholds");

			if (!(int)$threshold["thresholdID"]){
				$thresholdID = insertFor(":fraudCountryThresholds", array(
					'thresholdName' => 'default',
					'countryType' => '0',
					'countriesID' => '225',
					'regionsID' => '002',
					'levelOneScore' => '1.0',
					'levelTwoScore' => '3.0',
					'levelThreeScore' => '5.0',
					'levelOneAction' => '0',
					'levelTwoAction' => '2',
					'levelThreeAction' => '3',
					'catchAllAction' => '5',
					'overrideOneAmount' => '0.00',
					'overrideTwoAmount' => '0.00',
					'overrideThreeAmount' => '0.00',
					'overrideOneAction' => '0',
					'overrideTwoAction' => '0',
					'overrideThreeAction' => '0',
					'primaryScoreToUse' => '0',
					'freeEmailWeight' => '2.5',
					'countryMatchWeight' => '2.5',
					'anonProxyWeight' => '5.0',
					'countryRiskWeight' => '5.0',
					'ipDistanceWeight' => '10.0',
					'binMatchWeight' => '2.0',
					'binBankMatchWeight' => '1.0',
					'highRiskEmailWeight' => '5.0',
					'highRiskShippingWeight' => '5.0',
					'openProxyWeight' => '2.5',
					'fraudSoftRejectMessage' => '',
					'fraudHardRejectMessage' => '',
				));

				$fraudSetID = insertFor(":fraudSets", array(
					"fraudSetName" => "Default",
					"fraudSetEmail" => $CONF["user"]["adminData"]["adminEmail"],
				));

				insertFor(":fraudSetThresholdRels", array(
					"thresholdID" => $thresholdID,
					"fraudSetID" => $fraudSetID,
				));

				$orderForm = oneOf(":orderForms");
				$orderFormID = $orderForm["orderFormID"];

				insertFor(":fraudSetOrderFormRels", array(
					"fraudSetID" => $fraudSetID,
					"orderFormID" => $orderFormID,
				));

			}

			$CONF["system"]["internal"]["suppressFirstTimeWizard"] = 1;
			storeConfigs("system", "internal");

			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "finished",
			));
			exit;
		}

		redirect("configs.php", "FirstTimeDisplayStep");
		return $this->hasExecutedSuccessfully();
	}

	private function updatePaymentGateway($config_name, $configured_gateways)
	{
		$module_name = isset($configured_gateways[$config_name]) ? $configured_gateways[$config_name]->payment_gateway_module : $config_name;
		$input_form = UIFactory()->Form();
		$input_panel = UIFactory()->InputPanel("");
		require_once("object_managers/PaymentGatewayManager.php");
		$input_gateway_name = UIFactory()->InputString("{$config_name}_payment_gateway_name", blmsg("TRANS_GATEWAY_NAME"), true,
			array("PaymentGatewayManager", "checkName", isset($configured_gateways[$config_name]) ? $configured_gateways[$config_name]->id : null)
		);
		$input_panel->addInputControl($input_gateway_name);
		$input_form->addInputPanel($input_panel);
		$module_input_controls = array();
		require_once("ModuleTool.php");
		$module_controls = ModuleTool::getModuleControls("gateway", $module_name);
		foreach ( $module_controls as $control ) {
			foreach ( $control->getInputControls() as $input_control ) {
				$input_control->name = "{$config_name}_{$input_control->name}";
				$module_input_controls[] = $input_control;
			}
			$input_form->addInputPanel($control);
		}

		$input_form->initFromRequest();
		$error_messages = array();
		if ( !$input_form->validate($error_messages) ) {
			$module_info = PaymentGatewayManager::getModuleInfo($module_name);
			throw new ProductException(ProductException::E_OBJECT_HAS_INVALID_ATTRS, "Invalid input for '{$module_info['displayName']}' module:<br>".implode("<br>", $error_messages));
		}

		if ( !isset($configured_gateways[$config_name]) ) {
			$module_info = PaymentGatewayManager::getModuleInfo($module_name);
			$gateway = Factory()->PaymentGateway();
			$gateway->payment_gateway_module = $module_name;
			$gateway->payment_gateway_type = $module_info["gatewaytype"];
		} else {
			$gateway = $configured_gateways[$config_name];
		}
		$gateway->payment_gateway_name = $input_gateway_name->value;

		$gateway->PaymentGatewayParams->clear();
		foreach ( $module_input_controls as $input_control ) {
			$param_name = substr($input_control->name, strlen($config_name) + 1);
			$gateway->PaymentGatewayParams[$param_name]->value = $input_control->value;
		}

		PaymentGatewayManager::update($gateway);
		return $gateway;
	}
}
