<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class AddSingleInvoiceResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if(!(int)$_REQUEST["clientID"]) {
			$this->addError( TRANS_ACTIONERROR, "Client ID not found." );
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}
		$clientID = (int)$_REQUEST["clientID"];

		$params = array(
			"clientID" => $clientID,
			"packageName" => $_REQUEST["packageName"],
			"packageDescription" => $_REQUEST["packageDescription"],
			"amount" => $this->getNumberFromInput($_REQUEST["amount"]),
			"invoiceDate" => getMBDateFromRequest("invoiceDate"),
			"cycleID" => $_REQUEST["cycleID"],
			"orderFormID" => $_REQUEST["orderFormID"],
			"enableInvoiceEmail" => $_REQUEST["enableInvoiceEmail"],

			"amountPaid" => $this->getNumberFromInput($_REQUEST["amountPaid"]),
			"paymentComments" => $_REQUEST["paymentComments"],
			"transactionDateCreated" => getMBDateFromRequest("transactionDateCreated"),
			"enablePaymentEmail" => $_REQUEST["enablePaymentEmail"],
			"billingAccountID" => $_REQUEST["billingAccountID"],
		);

		if (!(int)$_REQUEST["applyPaymentAsWell"]){
			unset($params["amountPaid"]);
			unset($params["paymentComments"]);
			unset($params["transactionDateCreated"]);
			unset($params["enablePaymentEmail"]);
			unset($params["billingAccountID"]);
		}

		$results = dispatchMBAPI(array(
			"mbapi" => array(
				"command" => "ProcessSingleInvoice",
				"params" => $params,
			),
		), 1);

		$invoiceID = $results["mbapi"][0]["results"][0]["invoiceID"];
		$invoiceID = is_array($invoiceID) ? (int)$invoiceID[0] : 0;

		if ($invoiceID){
			redirect("invoices.php", "ShowInvoiceDetails", array("invoiceID"=>$invoiceID));
		} else {
			$this->addError( TRANS_ACTIONERROR, "Error generating invoice." );
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

	}
}
