<?php

/**
 * This action walks a user through the GoDaddy certification process
 */
class CertifyGoDaddyAccount extends MB_Action {

	function __construct() {
		parent::MB_Action();
		$this->stringRep = get_class($this);
	}

	function execute() {
		if ((int)$_REQUEST['certifyAccount']){
			$configParams = arrayFor(':configParams', array(
				'configGroupID' => $_REQUEST['configGroupID'],
			));
			$registrarConfig = array();
			foreach ((array)$configParams as $param){
				if ($param['configParamName']=='moduleCertified'){
					$certifiedParamID = $param['configParamID'];
				}
				$registrarConfig[$param['configParamName']] = $param['configParamValue'];
			}
			
			$registrarConfig['modulePassword'] = getStuff($registrarConfig['modulePassword']);
			// password has to be at least 1 character, I believe GoDaddy requires more too...
			if (!$registrarConfig['moduleUsername'] || strlen($registrarConfig['modulePassword'])<1){
				$this->smartyVars['error'] = TRANS_YOU_MUST_SAVE_YOUR_GODADDY_USERNAME_AND_PASSWORD;
			} else {
				require_once mb_path('/lib-mbapi/include/modules/registrar/core/godaddy/WWDAPI.php');
				$wwd = new WWDAPI($registrarConfig['moduleUsername'], $registrarConfig['modulePassword']);
				$passed = $wwd->certifyAccount();
				if ($passed){
					$this->smartyVars['success'] = 1;
					updateForKey(':configParams', $certifiedParamID, array(
						'configParamValue' => 'yes',
					));
				} else {
					$this->smartyVars['error'] = @implode('<br />', $wwd->getErrors());
				}
			}
		} else {
			$this->smartyVars['displayInstructions'] = 1;
		}
		$this->addTemplate("modules/CertifyGoDaddyAccount", $this->smartyVars, 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
