<?php
require_once mb_path("/lib-action/action.php");

class EditOrderFormResponse extends MB_Action
{
	public $params = array(
		"orderFormID",
		"orderFormName",
		"currencyID",
		"paymentGatewayID",
		"hspcBankTransferGatewayID",
		"companyID",
		"languageID",
		"countriesID",
		"orderFormVerifyVat",
		"orderFormDisableCharging",
		"defaultWidgetTemplate",
		"isDefault",
		"requestTaxVatID",
		"defaultTaxZoneID",
		"enableIndividualEnterpreneurType",
		"useTermsUrl",
	);

	public function execute()
	{
		parent::execute();

		$updateOrderFormParams = array();
		$_REQUEST["requestTaxVatID"] = bgpc("requestTaxVatID", 0);
		$_REQUEST["enableIndividualEnterpreneurType"] = bgpc("enableIndividualEnterpreneurType", 0);
		$_REQUEST["orderFormVerifyVat"] = ((int)$_REQUEST["orderFormVerifyVat"])?1:0;
		$_REQUEST["orderFormDisableCharging"] = ((int)$_REQUEST["orderFormDisableCharging"])?1:0;
		$_REQUEST["paymentGatewayID"] = bgpc("paymentGatewayID", "");
		$_REQUEST["defaultTaxZoneID"] = bgpc("defaultTaxZoneID", "");
		$_REQUEST["hspcBankTransferGatewayID"] = bgpc("hspcBankTransferGatewayID", "");

		foreach($_REQUEST["orderFormParams"] as $orderFormParam) {
			// find the orderFormID for these params

			$orderFormParamID = ((int) $orderFormParam["orderFormParamID"]);
			$orderFormParamValue = (!is_array($orderFormParam["orderFormParamValue"])) ?
				$orderFormParam["orderFormParamValue"] : serialize($orderFormParam["orderFormParamValue"]);

			$updateOrderFormParams[] =
				 "<orderFormParam>\n"
				."  <orderFormParamID>".$orderFormParamID."</orderFormParamID>\n"
				."  <orderFormParamValue>".$orderFormParamValue."</orderFormParamValue>\n"
				."</orderFormParam>\n";
		}

		if ( 0 == count($updateOrderFormParams) ) {
			$this->addError(blmsg("TRANS_ACTIONERROR"), "No order form params given.");
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}
		$orderFormParams = bgpc("orderFormParams");
		if("1" == bgpc("useTermsUrl") && "" == $orderFormParams['terms_url']['orderFormParamValue'])
		{
			$this->addError(blmsg("TRANS_ACTIONERROR"), blmsg("TRANS_ORDERFORM_TERMS_URL_REQUIRED_MSG"));
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		$getOptions = array(
			"getOrderFormItems" => 1,
			"getCouponData" => 1,
			"orderFormID" => $_REQUEST["orderFormID"]
		);
		require_once mb_path("/lib-mbapi/mbapi.php");
		$getquery = getMBAPIQuery("GetOrderForms", "", $getOptions);
		$getdata = dispatchMBAPI($getquery, 1);
		$ofdata =& $getdata["mbapi"][0]["results"][0]["orderForms"][0]["orderForm"][0];

		$ofitemsdata =& $ofdata["orderFormItems"][0]["orderFormItem"];
		$ofcoupondata =& $ofdata["coupons"][0]["coupon"];

		$allproductIDs = $alladdonIDs = $allcouponIDs = $ofProductIDs = $ofProductAddonIDs = $addCouponIDs =
		$updateOrderFormItems = $removeItems = $addCoupons = $removeCoupons = $addProductAddons
		= array();


		//Get the order form inputs assigned to variables
		if(is_array($_REQUEST["addProductIDs"])){
			$ofProductIDs =& $_REQUEST["addProductIDs"];
		}else{
			$ofProductIDs = array();
		}

		if(is_array($_REQUEST["addCouponIDs"])){
			$ofCouponIDs =& $_REQUEST["addCouponIDs"];
		}else{
			$ofCouponIDs = array();
		}

		// Get existing items
		if (is_array($ofitemsdata)){
			foreach($ofitemsdata as $formitem) {
				$allproductIDs[$formitem["orderFormItemID"][0]] = $formitem["productID"][0];
			}
		}


		// Get the product data for all coupons in the system. This is needed so that we don't add coupons that have
		// no products associated with the order form.
		$getOptions = array(
			"getProductData" => 1
		);

		$cquery = getMBAPIQuery("GetCoupons", "", $getOptions);

		$cdata = dispatchMBAPI($cquery, 1);
		$couponData =& $cdata["mbapi"][0]["results"][0]["coupons"][0]["coupon"];

		if(is_array($couponData)){
			foreach ($couponData as $coupprod){
				if(is_array($coupprod["products"][0]["product"])){
					foreach($coupprod["products"][0]["product"] as $relprod){
						$possibleCouponProducts[$coupprod["couponID"][0]][] = $relprod["productID"][0];
					}
				}
			}
		}

		// Get existing coupons that are related to this OF
		if (is_array($ofcoupondata)){
			foreach($ofcoupondata as $coupon) {
				$allcouponIDs[] = $coupon["couponID"][0];
			}
		}


		// Update and remove products
		$updateitem = NULL;
		foreach ($ofProductIDs as $key=>$id){
			if (in_array($id, $allproductIDs)){
				$ofitemids = array_flip($allproductIDs);
				$updateitem ="  <orderFormItemID>".$ofitemids[$id]."</orderFormItemID>\n";
			}
			$updateOrderFormItems[] =
				 "<orderFormItem>\n"
				.$updateitem
				."  <productID>".$id."</productID>\n"
				."  <orderFormItemOrder>".$key."</orderFormItemOrder>\n"
				."</orderFormItem>\n";
			$updateitem = NULL;
		}

		foreach (array_diff($allproductIDs, $ofProductIDs) as $key=>$id){
			$removeItems[] = "  <productID>".$id."</productID>\n";
		}

		// Add and remove coupons - check to see if the coupon to be added relates to any of the products on the form first
		foreach (array_diff($ofCouponIDs, $allcouponIDs) as $key=>$id){
			if(in_array($id, array_keys($possibleCouponProducts)) && count(array_intersect($possibleCouponProducts[$id], $ofProductIDs))){
				$addCoupons[] = "  <couponID>".$id."</couponID>\n";
			}
		}

		foreach (array_diff($allcouponIDs, $ofCouponIDs) as $key=>$id){
			$removeCoupons[] = "  <couponID>".$id."</couponID>\n";
		}

		$thirdPartyGatewayIDs = "";
		foreach ( bgpc("addThirdPartyGatewayIDs", array()) as $third_party_gateway_id ) {
			$thirdPartyGatewayIDs .= "<paymentGatewayID>{$third_party_gateway_id}</paymentGatewayID>";
		}

		// Generate the XML for the SetOrderForms call
		$xmlParams = array (
			"thirdPartyGatewayIDs"  => $thirdPartyGatewayIDs,
			"orderFormParams"  => implode("\n",$updateOrderFormParams),
			"orderFormItems"  => implode("\n",$updateOrderFormItems),
			"removeOrderFormItems"  => implode("\n",$removeItems),
			"couponIDs"  => implode("\n",$addCoupons),
			"removeCouponIDs"  => implode("\n",$removeCoupons),
			"productAddons"  => implode("\n",$addProductAddons),
		);

		$query = $this->getMBAPIQuery("SetOrderForms", "update", $xmlParams);

		dbg("update order form query:");
		dbg($query);
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"]).
				"&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("orderforms.php", getActionID("ShowOrderForms"));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
