<?php
require_once(dirname(__FILE__)."/../../../../lib-action/action.php");
require_once("UI/Page.php");

class SelectProductTypePage extends UIPage
{
	public function createControls()
	{
		require_once("UI/PageController.php");

		$input_type = UIFactory()->InputDropDown("productType",	blmsg("TRANS_TYPE"), false, NULL, blmsg("TRANS_ADD_PRODUCT_TYPE_DESC"));
		$input_type->value = $this->getValue("productType");
		$product_types = getTypes("products");
		foreach ( $product_types as $key => $type )
			$input_type->addOption(	$key, $type	);

		$input_panel = UIFactory()->InputPanel(blmsg("TRANS_PRODUCT_TYPE_CHOOSING"));
		$input_panel->addInputControl($input_type);

		$this->addInputPanel($input_panel);
	}

	public function processInput()
	{
		dispatchAction("products", getActionID("AddProductResponse"));
	}
}


class AddProduct extends MB_Action
{
	public function execute()
	{
		parent::execute();
		$product_list_url = action_url("products", "ShowProducts");

		$controller  = UIFactory()->WizardController($product_list_url);

		$page1 = new SelectProductTypePage($controller);

		$page1->title = blmsg("TRANS_CREATE_NEW_PRODUCT");
		$page1->parent_title = blmsg("TRANS_SHOW_PRODUCTS");
		$page1->parent_url = $product_list_url;

		$controller->addPage($page1);
		$controller->processRequest();

		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}