<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-billing/include/config/internal/cycles.php");

class AddProductResponse extends SourceAction
{
	public function execute()
	{
		$skeleton = array(
			"productComments" => "",
			"productStopNumCycles" => 0,
			"productActive" => 1,
			"productProratable" => 0,
			"productDomainRequired" => getAPIStatusID("productdependencyrules", "cannot"),
			"productAddonRequired" => getAPIStatusID("productdependencyrules", "can"),
			"productDateCreated" => mktime(),
		);

		switch($type = getAPITypeName("products", (int) $_REQUEST["productType"])) {
			case "hosting":
				$skeleton["productDomainRequired"] = getAPIStatusID("productdependencyrules", "must");
				$skeleton["productProratable"] = 1;
				break;
			case "non-hosting":
				$skeleton["productProratable"] = 1;
				break;
			case "domain":
				$skeleton["productDomainRequired"] = getAPIStatusID("productdependencyrules", "must");
				$skeleton["productAddonRequired"] = getAPIStatusID("productdependencyrules", "cannot");
				break;
			case "cert":
				break;
			case "license":
				break;
			case "software":
				break;
			case "usage":
				break;
			case "contract":
				$skeleton["productStopNumCycles"] = 1;
				break;
			case "fee":
				$skeleton["productStopNumCycles"] = 1;
				break;
			case "nonrecurring":
				$skeleton["productStopNumCycles"] = 1;
				break;
			case "ssl-cert":
				$skeleton["productDomainRequired"] = getAPIStatusID("productdependencyrules", "cannot");
				$skeleton["productAddonRequired"] = getAPIStatusID("productdependencyrules", "cannot");
				break;
			case "undefined":
			default:
				$skeleton["productProratable"] = 1;
				break;
		}
		$skeleton["productType"] = getAPITypeID("products", $type);
		$skeleton["productName"] = getTypeName("products", $skeleton["productType"]);

		if($productID = insertFor("products", $skeleton)) {
			if ($skeleton["productStopNumCycles"]==1){
				$this->addSmallestCycle($productID);
			}
			$this->syncProductVariants($productID);
			redirect("products.php", "ShowProductDetails", array("productID" => $productID));
		}

		$this->addError(blmsg("TRANS_ACTIONERROR"), "Failure adding product.");
		$this->addErrorTemplates();
	}

	private function addSmallestCycle($productID)
	{
		$cycles = getAllCycleIDs();
		$smallest = false;
		foreach ($cycles as $c){
			if ($smallest===false){
				$smallest = array($c, getNextBillingTimestamp(0, $c));
			} elseif ($smallest[1]>($t = getNextBillingTimestamp(0, $c))){
				$smallest = array($c, $t);
			}
		}
		if ($smallest[0]){
			insertFor(":productCycleGhostRels", array(
				"productID" => $productID,
				"cycleID" => $smallest[0],
			));
		}
	}
}
