<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/admin/include/lib-action/reports/ShowReportAction.php");
require_once mb_path("/lib-mbapi/mbapi.php");

class ShowReportDetails extends ShowReportAction {
	/**
	 * The constructor for a ShowReports action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowReportDetails() {
		parent::ShowReportAction();
		$this->stringRep = "ShowReportDetails";
	}

	/**
	 * The main method of this class that executes the ShowReportDetails action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$_REQUEST = $_REQUEST + (array)unserialize(base64_decode($_REQUEST["tunnelVars"]));
		$this->smartyVars["tunnelVars"] = $_REQUEST["tunnelVars"];

		$this->mergeReportsData();
		list($category, $name, $fullName) = $this->getNamePieces($_REQUEST["reportName"]);
		$this->smartyVars["reportInfo"] = (array)$this->reportData[$fullName]+array("reportName" => $fullName);

		$rn = "MB_Report_".$name;
		$report = new $rn();

		$this->smartyVars = $this->smartyVars + (array)$report->getData($_REQUEST);

		dbg($this->smartyVars);

		$this->smartyVars["print"] = ($_REQUEST["print"])?1:0;

		$this->addTemplate("reports/ShowReportDetails");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute
} // ShowReportDetails
?>