<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class EditWebsiteWidget extends MB_Action
{
	public $params = array("websiteWidgetID");

	public function execute()
	{
		parent::execute();

		$websiteWidgetID = bgpc("websiteWidgetID");
		if ( is_null($websiteWidgetID) ) {
			throw new Exception("Missing parameter 'websiteWidgetID'");
		}

		require_once("object_managers/OrderFormManager.php");
		$this->smartyVars["wwTemplates"] = OrderFormManager::getWidgetTemplates();

		require_once mb_path("/lib-mbapi/mbapi.php");
		require_once mb_path("/lib-tk/include/xml/xml.php");
		$this->smartyVars["websiteWidgetInfo"] = grabSimpleMBAPIResults(dispatchMBAPI("
			<mbapi>
				<command>GetWebsiteWidgets</command>
				<params>
					<websiteWidgetID>{$websiteWidgetID}</websiteWidgetID>
					<getProductInformation>1</getProductInformation>
				</params>
			</mbapi>", 1
		));
		$this->smartyVars["websiteWidgetInfo"] = $this->smartyVars["websiteWidgetInfo"][0];

        $this->smartyVars["selectedProducts"] = grabHTMLOpsFromArray($this->smartyVars["websiteWidgetInfo"]["products"][0]["product"], "productID", "productName");

		$orderFormID = $this->smartyVars["websiteWidgetInfo"]["orderFormID"];
		$products = grabSimpleMBAPIResults(dispatchMBAPI("
			<mbapi>
				<command>GetProducts</command>
				<params>
					<orderFormID>{$orderFormID}</orderFormID>
					<getNonAddons>1</getNonAddons>
					<productActive>1</productActive>
				</params>
			</mbapi>", 1
		));
		$this->smartyVars["selectableProducts"] = grabHTMLOpsFromArray($products, "productID", "productName", array_keys($this->smartyVars["selectedProducts"]));

		$this->smartyVars["orderFormInfo"] = grabSimpleMBAPIResults(dispatchMBAPI("
			<mbapi>
				<command>GetOrderForms</command>
				<params>
					<orderFormID>{$orderFormID}</orderFormID>
				</params>
			</mbapi>", 1
		));
		$this->smartyVars["orderFormInfo"] = $this->smartyVars["orderFormInfo"][0];

		$this->smartyVars["noProducts"] = (count($this->smartyVars["selectedProducts"]) || count($this->smartyVars["selectableProducts"]))?0:1;

		$this->addTemplate("websitewidgets/EditWebsiteWidget", $this->smartyVars);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
