<?php

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

class EditDomainDNS extends MB_Action {
	
	function EditDomainDNS() {
		parent::MB_Action();
		$this->stringRep = "EditDomainDNS";
		$this->params = array("domainID");
	}
	
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = (int)$_REQUEST["domainID"];
		if (!$domainID || !$this->confirmClientPermission("GetDomains", "domainID", $domainID, $CONF["user"]["id"])) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {

		 	// fetch this domains information
			$query = $this->getMBAPIQuery("GetDomains", "", array("packageType" => getTypeID("products",TRANS_DOMAIN_PRODUCT)));
			$mbapiData = dispatchMBAPI($query, 1);
			
			// is the domainID valid?
			if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain ID.");
			} else {
				
				$domain = correctArray($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
				$domainSLD = $domain["domainSLD"];
				$domainTLD = $domain["domainTLD"];
				$domainID = $domain["domainID"];
				
				$x = "
				<mbapi>
					<command>ProcessRegistrar</command>
					<subCommand>getDomainDNS</subCommand>
					<params>
						<configID>0</configID>
						<domainSLD>".$domainSLD."</domainSLD>
						<domainTLD>".$domainTLD."</domainTLD>
						<domainID>".$domainID."</domainID>
					</params>
				</mbapi>";

				$registrarData = dispatchMBAPI($x,1);
				$registrarResults =& $registrarData["mbapi"][0]["results"][0];

				if ($this->addMBAPIErrors($registrarData) === 0) {
					$smartyVars = array();
					$smartyVars["domain"] = correctArray($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
					$smartyVars["dnsCount"] = count($registrarResults["listDNS"]);
					//This is an experimental way to show 8 fields per domain.
					if(count($registrarResults["listDNS"]) < 8) {
						$smartyVars["dnsShowExtra"] = 8 - count($registrarResults["listDNS"]);
					} else {
						$smartyVars["dnsShowExtra"] = 0;
					}
					$smartyVars["listDNS"] = $registrarResults["listDNS"];
					
					if (!is_array($smartyVars["listDNS"]))
						$smartyVars["listDNS"] = array($smartyVars["listDNS"]);
					
					$smartyVars["useDNS"] = collapseArrayElements($registrarResults["UseDNS"]);
					$smartyVars["host"] = correctArray($registrarResults["host"]);
					$smartyVars["domainServices"] = correctArray($registrarResults["DomainServices"][0]);
					//This is an array to loop over, a smarty helper
					$smartyVars["hostLoop"] = array("","","","","","","","","","");
					while ((count($smartyVars["host"])+4)>count($smartyVars["hostLoop"])) {
						$smartyVars["hostLoop"][] = '';
					}
					$smartyVars["dnsOptions"] = array_merge(array('0' => 'None'), correctArray($registrarResults["dnsOptions"][0]));
					$this->addTemplate("domains/EditDomainDNS", $smartyVars);
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
