<?php

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

class EditDomainDNSResponse extends MB_Action {
	
	function EditDomainDNSResponse() {
		parent::MB_Action();
		$this->stringRep = "EditDomainDNSResponse";
		$this->params = array
		(
			"domainID",
			"domainDNS",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$domainID = (int)$_REQUEST["domainID"];
		$useDNSOld = (int)$_REQUEST["useDNSOld"];
		$useDNS = (int)$_REQUEST["useDNS"];
		$nameServers = array();
		$commandXML = "";

		if (!$domainID || !$this->confirmClientPermission("GetDomains", "domainID", $domainID, $CONF["user"]["id"])) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {

		 	// fetch this domains information
			$query = $this->getMBAPIQuery("GetDomains", "", array("packageType" => getTypeID("products",TRANS_DOMAIN_PRODUCT)));
			$mbapiData = dispatchMBAPI($query, 1);

			// is the domainID valid?
			if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain ID.");
			} else {

				$domain = correctArray($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
				$domainSLD = $domain["domainSLD"];
				$domainTLD = $domain["domainTLD"];
				$domainID = $domain["domainID"];

				//If useDNS has changed from yes to no, pass that along with the new servers
				if (!$useDNS && $useDNSOld) {
					$commandXML = "<domainDNS>0</domainDNS>";
					$nameServers = (array) $_REQUEST["domainDNS"];
					foreach($nameServers as $key => $value) {
						//if($value) { //Let the blank go through so that servers can be removed
							$commandXML .= "<domainNameserver>".$value."</domainNameserver>\n";
						//}
					}
				}

				// Pull the host items
				$hostDNSHostname = $hostDNSType = $hostDNSAddress = array();
				if ($useDNS) {
					$hostDNSHostname = $_REQUEST["hostDNSHostname"];
					$hostDNSType = $_REQUEST["hostDNSType"];
					$hostDNSAddress = $_REQUEST["hostDNSAddress"];

					$hostXML = "";
					foreach ($hostDNSType as $k => $value) {
						if ($value != '0') {
							$hostXML .= "<host>\n";
							$hostXML .= "  <HostName>".$hostDNSHostname[$k]."</HostName>\n";
							$hostXML .= "  <RecordType>".$value."</RecordType>\n";
							$hostXML .= "  <Address>".$hostDNSAddress[$k]."</Address>\n";
							$hostXML .= "</host>\n";
						}
					}
				}
				
				//if useDNS has changed from no to yes, just pass that and look for host fields
				if ($useDNS) {
					$commandXML = "<domainDNS>1</domainDNS>";
				}
				//if no and no pass the servers
				if (!$useDNS && !$useDNSOld) {
					$nameServers = (array) $_REQUEST["domainDNS"];
					foreach ($nameServers as $key => $value) {
						$commandXML .= "<domainNameserver>".$value."</domainNameserver>";
					}
				}

				$xml = "
				<mbapi>
					<command>ProcessRegistrar</command>
					<subCommand>setDomainDNS</subCommand>
					<params>
						<configID>0</configID>
						<domainSLD>$domainSLD</domainSLD>
						<domainTLD>$domainTLD</domainTLD>
						<domainID>$domainID</domainID>
						$commandXML
						$hostXML
					</params>
				</mbapi>";

				$data = dispatchMBAPI($xml,1);

				if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					redirect("domains.php",getActionID("ShowDomainDetails"), array("domainID"=>$domainID));
				} else {
					//Try to use the warining class
					$warningMessage = new Warning($this->errors[0][0][0],$this->errors[0][1][0]);
					$warningMessage->addButton(getActionID("EditDomainDNS"), "domains.php", "go back", array(
						"domainID" => $domainID,
						"sid" => $_REQUEST["sid"],
					));
					$this->addWarning($warningMessage);
					$this->addWarningTemplates();
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}