<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class PayInvoicesResponse extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();
		dbg($_REQUEST);

		// get client data
		$clientID = ((int) $CONF["user"]["id"]);
		if(!$clientID) {
			$this->addError(blmsg("TRANS_ACTIONERROR"), "You must not be logged in because you don't have an ID.");
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		require_once mb_path("/lib-mbapi/mbapi.php");
		$clientInfo = dispatchMBAPI("<mbapi>
										<command>GetClients</command>
										<params>
											<clientID>".$clientID."</clientID>
											<getContactData>3</getContactData>
										</params>
									</mbapi>", 1);
		if ($clientInfo["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]["contact"][0]){
			$mainContact = correctArray($clientInfo["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
		}

		$invoiceIDs = $_REQUEST["invoiceIDs"];
		$billingAccountID = (int)$_REQUEST["billingAccountID"];
		$paymentAmount = doubleval($_REQUEST["payTotal"]);

		$oid = ((int)$_REQUEST["invoiceID"]) ? "<invoiceID>".(int)$_REQUEST["invoiceID"]."</invoiceID>":"";

		$invoiceXML = "
			<mbapi>
				<command>GetInvoices</command>
				<params>
					<clientID>".$clientID."</clientID>
					<getDueInovicesOnly>1</getDueInovicesOnly>
					<getInvoiceLineItemsData>1</getInvoiceLineItemsData>
					".$oid."
					<orderFormID>".((int)$_REQUEST["orderFormID"])."</orderFormID>
				</params>
			</mbapi>
		";
		$invoices = dispatchMBAPI($invoiceXML, 1);
		$invoices = $invoices["mbapi"][0]["results"][0];
		if (isset($invoices["invoices"][0]["invoice"])){
			$invoices = correctArray($invoices["invoices"][0]["invoice"]);
		}
		$validInvoiceIDs = array();
		foreach ($invoices as $invoice){
			$validInvoiceIDs[] = $invoice["invoiceID"];
		}
		$newInvoiceIDs = array();
		if (isset($invoiceIDs)){
			foreach ($invoiceIDs as $v){
				if (in_array($v, $validInvoiceIDs)){
					$newInvoiceIDs[] = $v;
				}
			}
			$invoiceIDs = $newInvoiceIDs;
		} else {
			dbg("redirected prematurely");
			redirect("invoices.php?action=".getActionID("PayInvoices")."&sid=".secureInput($_REQUEST["sid"]));
			return 1;
		}

		$newInvoices = array();
		foreach ($invoices as $invoice){
			if (@in_array($invoice["invoiceID"], $invoiceIDs)){
				$newInvoices[] = $invoice;
				$lastInvoiceID = $invoice["invoiceID"];
			}
		}
		$invoices = $newInvoices;

		if ( 0 == count($invoices) ) {
			return $this->paymentError(blmsg("TRANS_INVOICES_ALREADY_PAID_FOR"));
		}

		if ( 0 == $billingAccountID ) {
			$cardCVV2 = ereg_replace("[^0-9]", "", $_REQUEST["cardCVV2"]);
			$cardNum = ereg_replace("[^0-9]", "", $_REQUEST["billingCardNum"]);
			$cardExpMonth = ereg_replace("[^0-9]", "", $_REQUEST["billingCardExpMonth"]);
			$cardExpYear = ereg_replace("[^0-9]", "", $_REQUEST["billingCardExpYear"]);
			$nameOnCard = $_REQUEST["billingCardNameOnCard"];
			$accountType = (int)$_REQUEST["billingAccountType"];
			$cardType = (int)$_REQUEST["billingCardType"];
			$cardStartDate = $_REQUEST["billingCardStartDate"];
			$cardIssueNum = $_REQUEST["billingCardIssueNum"];

			$billingAccountID = insertFor("billingAccounts", array(
				"clientContactID" => $mainContact["clientContactID"],
				"billingAccountType" => getAPITypeID("billingAccount", "card"),
				"billingCardNameOnCard" => $nameOnCard,
				"billingCardType" => $cardType,
				"billingCardNum" => $cardNum,
				"billingCardExpMonth" => $cardExpMonth,
				"billingCardExpYear" => $cardExpYear,
				"billingCardIssueNum" => $cardIssueNum,
				"billingCardStartDate" => $cardStartDate,
			));
		}

		if ( !isset($_REQUEST["orderFormID"]) ) {
			return $this->paymentError(blmsg("TRANS_PAYMENT_ERROR_MESSAGE", array("MESSAGE" => "Missing parameter 'orderFormID'")));
		}
		$order_form = Factory()->OrderForm($_REQUEST["orderFormID"]);
		if ( is_null($order_form->PrimaryGateway) && (is_null($order_form->HSPCBankTransferGateway))) {
			return $this->paymentError(blmsg("TRANS_PAYMENT_ERROR_MESSAGE",
				array("MESSAGE" => "Order form #{$order_form->id} '{$order_form->order_form_name} has not primary and Bank Transfer payment gateway assigned'"))
			);
		}

		require_once("objects/ClientBillingAccount.php");
		require_once("objects/Transaction.php");

		$billing_account = Factory()->ClientBillingAccount($billingAccountID);
		if ($hspc_bank_transfer = ClientBillingAccount::TYPE_HSPC_BANK_TRANSFER == $billing_account->billing_account_type)
		{
			$chargeData = array(
				"status" => Transaction::STATUS_PROCESSING,
				"message" => blmsg("TRANS_HSPC_BATCH_FILE_TRANSACTION_INPROGRESS"),
			);
			$gateway = $billing_account->PaymentGateway;
			$paymentMethod = Transaction::PAYMENT_HSPCBANKTRANSFER;
		} else {
			$gateway = $order_form->PrimaryGateway;
			$paymentMethod = Transaction::PAYMENT_CCSINGLE;

			$chargeXML = "  <mbapi>
								<command>ProcessGateway</command>
								<params>
									<paymentGatewayID>".$gateway->id."</paymentGatewayID>
									<currencyID>".$order_form->currency_id."</currencyID>
									<subCommand>charge</subCommand>
									<invoiceName>".@implode(", ", $invoiceIDs)."</invoiceName>
									<paymentDescription>".TRANS_PAYMENT_FOR_INVOICES.": ".@implode(", ", $invoiceIDs)."</paymentDescription>
									<paymentAmount>".$paymentAmount."</paymentAmount>
									<paymentMethod>CC</paymentMethod>
									<billingAccountID>".$billingAccountID."</billingAccountID>
									".(($cardCVV2>0)?"<cardCVV2>".$cardCVV2."</cardCVV2>":"<isRecurring>1</isRecurring>")."
									".(($cardNum>0)?"<cardNum>".$cardNum."</cardNum>":"")."
								</params>
							</mbapi>";
			dbg($chargeXML);
			// run the charge.
			$chargeResults = dispatchMBAPI($chargeXML, 1);
			dbg($chargeResults);

			if ($chargeResults["mbapi"][0]["results"] && $chargeResults["mbapi"][0]["results"][0]["transactions"] && $chargeResults["mbapi"][0]["results"][0]["transactions"][0]["transaction"]){
				$chargeResults = correctArray($chargeResults["mbapi"][0]["results"][0]["transactions"][0]["transaction"][0]);
			}
			$chargeData = $chargeResults;
			dbg($chargeData);
		}
		$this->smartyVars["currencyID"] = $invoices[0]["currencyID"];
		$this->smartyVars["payTotal"] = $paymentAmount;
		$this->smartyVars["invoices"] = $invoices;
		$this->smartyVars["authorizationCode"] = $chargeData["authorizationCode"];

		dbg($invoices);

		///////////// create the transaction
		$transXML = "
					<mbapi>
					<command>SetTransaction</command>
					<subCommand>insert</subCommand>
					<params>
						<transactionPaymentMethod>{$paymentMethod}</transactionPaymentMethod>
						<authReturn>".$chargeData["status"]."</authReturn>
						<transactionCode>".$chargeData["transactionID"]."</transactionCode>
						<transactionNotes>".$chargeData["message"]."</transactionNotes>
						<transactionDateCreated>".time()."</transactionDateCreated>
						<authCode>".$chargeData["authorizationCode"]."</authCode>
						<avsCode>".$chargeData["AVSCode"]."</avsCode>
						<transactionAmount>".$paymentAmount."</transactionAmount>
						<currencyID>".$invoices[0]["currencyID"]."</currencyID>
						<paymentGatewayID>".$gateway->id."</paymentGatewayID>
						<billingAccountID>".$billingAccountID."</billingAccountID>
						<invoiceIDs>
							<invoiceID>".@implode("</invoiceID>\n<invoiceID>", $invoiceIDs)."</invoiceID>
						</invoiceIDs>
					</params>
					</mbapi>";

		$transResponse = dispatchMBAPI($transXML, 1);
		$transactionID = $transResponse["mbapi"][0]["header"][0]["lastInsertID"][0];

		$this->smartyVars["transactionID"] = $transactionID;

		if ($hspc_bank_transfer)
		{
			require_once("object_managers/BatchFileManager.php");
			BatchFileManager::createTransaction($transactionID);

			$this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars);
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		switch ($chargeData["status"]){
			case GATEWAY_SUCCESS:
				$transactionAmount = $paymentAmount;
				$overage = $paymentAmount;
				foreach ($invoices as $invoice){
					$invoiceID = $invoice["invoiceID"];
					$this->invoiceInfo = $invoice;
					$this->lineItems = correctArray($this->invoiceInfo["lineItems"]);
					foreach ($this->lineItems as $k=>$v){
						$this->lineItems[$k]["lineItemAmountDue"] = $v["lineItemTotalAmount"]-$v["lineItemPaymentAmount"];
					}

					// apply the overage, or just the amount they listed, to line items in order.
					foreach ($this->lineItems as $k=>$v){
						if ($overage>0){
							if ($v["lineItemApplyAmount"]<$v["lineItemAmountDue"]){
								$diff = $v["lineItemAmountDue"]-$v["lineItemApplyAmount"];
								if ($overage<$diff){
									$diff = $overage;
									$overage = 0;
								} else {
									$overage -= $diff;
								}
								$this->lineItems[$k]["lineItemApplyAmount"] += $diff;
							}
						} else {
							break;
						}
					}

					// do success rel
					foreach ($this->lineItems as $k=>$v){
						if ($v["lineItemApplyAmount"]>0){
							$successRelXML = "
									<mbapi>
										<command>SetTransactionSuccessRel</command>
										<subCommand>insert</subCommand>
										<params>
											<transactionID>$transactionID</transactionID>
											<billingAccountShareID>0</billingAccountShareID>
											<lineItemID>".$v["lineItemID"]."</lineItemID>
											<lineItemPaymentAmount>".$v["lineItemApplyAmount"]."</lineItemPaymentAmount>
										</params>
									</mbapi>
									";
							$successRel = dispatchMBAPI($successRelXML, 1);
						} else {
							$CONF["debug"]->debugMessage("had a blank amount: $transactionID");
						}
					}

					// update the invoice
					$amount = 0;
					$paidtotal = $invoice["invoiceAmountPaid"];
					foreach ($this->lineItems as $k=>$v){
						$amount += $v["lineItemApplyAmount"];
						$paidtotal += $v["lineItemApplyAmount"]+$v["lineItemPaymentAmount"];
					}

					$updateXML = "
								<mbapi>
									<command>SetInvoices</command>
									<subCommand>update</subCommand>
									<showXMLHeader>0</showXMLHeader>
									<params>
									<invoiceID>".$invoiceID."</invoiceID>
									<invoiceAmountPaid>".$paidtotal."</invoiceAmountPaid>
									<invoiceDatePaid>".time()."</invoiceDatePaid>
								".((round($paidtotal,2)==round($this->invoiceInfo["invoiceAmount"],2))?"<invoiceStatus>1</invoiceStatus>":"")."
									</params>
								</mbapi>";

					$updateResponse = dispatchMBAPI($updateXML, 1);

					if ($invoiceID==$lastInvoiceID){
						dbg("the last one");
						if ($overage>0){
							$credit = round($overage, 3);
						}
					} else {
						dbg("not the last one");
						$credit = 0;
					}

					dbg("overage: ".$credit);

					require_once mb_path("/lib-billing/include/accounting/Payment.php");
					$receipt = new Payment();
					$receipt->setClientID($clientID);
					$receipt->setInvoiceID($invoiceID);
					$receipt->setTransactionID($transactionID);
					$receipt->setDescription(TRANS_PAYMENT_FOR_INVOICE.": ".@constant(getTypeName("payment", 2)));
					$receipt->setPaymentAmount($amount+$credit);
					if ($credit>0){
						$receipt->setClientCreditAmount($credit);
					}
					$receipt->setCurrencyID($this->invoiceInfo["currencyID"]);
					$receipt->execute();

				}
				$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
				break;
			case GATEWAY_DECLINE:
				dbg($chargeData);
				return $this->paymentError(blmsg("TRANS_PAYMENT_DECLINED"));
			case GATEWAY_PARAM_FAILURE:
			case GATEWAY_FAILURE:
			default:
				dbg($chargeData);
				return $this->paymentError(blmsg("TRANS_GATEWAY_FAILURE"));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function paymentError($error_text)
	{
		$this->smartyVars["paymentError"] = 1;
		$this->smartyVars["paymentErrorText"] = $error_text;
		$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
