<?php
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class AddBillingAccount extends AddAction
{
	public function __construct()
	{
		global $CONF;
		$clientContactID = $CONF["user"]["clientContactID"];
		$_REQUEST["clientContactID"] = $clientContactID;
		require_once("object_managers/ClientBillingAccountManager.php");
		$allowed_types = ClientBillingAccountManager::getAllowedBillingAccountTypes();
		if (empty($allowed_types))
		{
			$this->addError(blmsg("TRANS_ACTIONERROR"), blmsg("TRANS_NO_ALLOWED_BILLING_TYPES_FOR_ADD"));
			$this->addErrorTemplates();
			exit;
		}

		$this->d = new DataSource("billingAccounts", array("clientContactID" => $clientContactID));
		$description = $this->d->getDescription();
		$description["names"]["file"] = "profile";
		$description["display"]["addTemplate"] = "profile/AddBillingAccount";
		$this->d->setDescription($description);
		parent::AddAction();
	}

	function addHandler()
	{

		global $CONF;
		$clientID = $CONF["user"]["id"];
		$contact = oneByID(":contacts", $CONF["user"]["clientContactID"]);
		$this->smartyVars['isPrimary'] = $contact['contactPrimary'];

		$this->smartyVars['client'] = oneByID(":clients", $CONF['user']['id']);

		loadConfigs("payment");

		$this->smartyVars["billingAccountTypes"] = getTypes("billingAccount");
		// remove account types that the admin wants to restrict from the client.
		foreach( (array)$this->smartyVars["billingAccountTypes"] as $k => $v ) {
			if ($CONF["payment"]["clientSidePaymentOptions"][ getAPITypeName( "billingAccount", $k ) ] != 1) {
				unset( $this->smartyVars["billingAccountTypes"][ $k ] );
			}
		}	unset( $k, $v );
		unset($this->smartyVars["billingAccountTypes"][getAPITypeID("billingAccount", "hspcbanktransfer")]);

		$this->smartyVars["bankAccountTypes"] = getTypes("bankAccount");
		$this->smartyVars["cardExtraTypes"] = getTypes("cardExtraIDs");

        require_once("object_managers/PaymentGatewayManager.php");
        $this->smartyVars["cardTypes"] = PaymentGatewayManager::getAcceptedCardTypes(Factory()->PaymentGatewayList());

		$this->smartyVars["selectablePackages"] = optionsFor("packages", array("clientID" => $clientID));

		return true;
	}
}
