<?php
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

require_once mb_path("/lib-mbapi/include/modules/gateway/gateway.php");

$className = "CyoGate";
$GLOBALS["moduleInfo"][$className] = array
(
    "type" => "gateway",
    "status" => "TRANS_TESTING",
    "version" => "1.0.0",
    "gatewaytype" => "1",
    "displayName" => "CyoGate",
    "author" => "CyoGate",
    "capabilities" => array(GATEWAY_CHARGE, GATEWAY_AUTHORIZE, GATEWAY_PRIOR_AUTH_CHARGE, GATEWAY_REFUND, GATEWAY_PARTIAL_REFUND, GATEWAY_VOID)
);

class CyoGate extends Gateway {

	/**
	 */
    function getModuleInfo() {
        return $GLOBALS["moduleInfo"]["CyoGate"];
    }

	/**
	 */
	 function CyoGate($params){
	 $this->stringRep = "cyogate";
	 	parent::Gateway($params);

        $moduleInfo = $this->getModuleInfo();

        foreach ($moduleInfo["capabilities"] as $cap){
            $this->capabilities[$cap] = 1;
        }
		$this->version = "1.0.0";
		$this->liveURL = "https://secure.CyoGate.net/gateway/transact.dll";
		$this->testURL = "https://test.CyoGate.net/gateway/transact.dll";
	 }
	 
	/**
	 */
	function addDefaultConfigParams() {
		static $defaultConfigParams = array(
			array(NULL, NULL, "Login_ID", "testdrive", "", "TRANS_CYOGATE_LOGINID", "TRANS_CYOGATE_LOGINID_DESC", "t", 1, 1, 0, null),
			array(NULL, NULL, "Password", "testdrive", "", "TRANS_CYOGATE_PASSWORD", "TRANS_CYOGATE_PASSWORD_DESC", "p", 1, 2, 0, null),
			array(NULL, NULL, "Version", "3.1", "", "TRANS_CYOGATE_VERSION","TRANS_CYOGATE_VERSION_DESC", "t", 1, 3, 0, null),
			array(NULL, NULL, "Invoice_Description", "", "", "TRANS_INVOICE_DESCRIPTION", "TRANS_INVOICE_DESCRIPTION_DESC", "t", 0, 4, 0, null),
			array(NULL, NULL, "Generic_Emails", "0", "", "TRANS_GATEWAY_GEN_EMAIL","TRANS_GATEWAY_GEN_EMAIL_DESC", "b", 0, 5, 0, NULL),
			array(NULL, NULL, "Batch_Recurring", "1", "", "TRANS_BATCH_RECURRING","TRANS_BATCH_RECURRING_DESC", "b", 1, 6, 0, NULL),
            array(NULL, NULL, "Testing", "1", "", "TRANS_GATEWAY_TESTING", "TRANS_GATEWAY_TESTING_DESC", "b", 1, 7, 0, NULL),
            array(NULL, NULL, "Gateway_URL", "1", "", "TRANS_GATEWAY_URL", "TRANS_GATEWAY_URL_DESC", "b", 1, 7, 0, NULL),
            array(NULL, NULL, "card_accept_0", "1", "", "TRANS_ACCEPT_VISA", "TRANS_ACCEPT_VISA_DESC", "b", 1, 8, 0, NULL),
            array(NULL, NULL, "card_accept_1", "1", "", "TRANS_ACCEPT_MASTERCARD", "TRANS_ACCEPT_MASTERCARD_DESC", "b", 1, 9, 0, NULL),
            array(NULL, NULL, "card_accept_2", "1", "", "TRANS_ACCEPT_AMEX", "TRANS_ACCEPT_AMEX_DESC", "b", 1, 10, 0, NULL),
            array(NULL, NULL, "card_accept_3", "1", "", "TRANS_ACCEPT_DISCOVER", "TRANS_ACCEPT_DISCOVER_DESC", "b", 1, 11, 0, NULL),
            array(NULL, NULL, "card_accept_4", "1", "", "TRANS_ACCEPT_JCB", "TRANS_ACCEPT_JCB_DESC", "b", 1, 12, 0, NULL),
            array(NULL, NULL, 'card_accept_6', '1', '', 'TRANS_ACCEPT_DINERS', 'TRANS_ACCEPT_DINERS_DESC', 'b', 1, 13, 0, NULL),
            array(NULL, NULL, "accept_echeck", "1", "", "TRANS_ACCEPT_ECHECK", "TRANS_ACCEPT_ECHECK_DESC", "b", 1, 13, 0, NULL),
            );
		return $defaultConfigParams;
	}

	 /**
	  *
	  * From a child module this function must do the following:
	  *   - Maintain $this->hasExecuted, $this->hasExecutedSuccessfully, $this->timestamp,
	  *     $this->status, $this->accountID
	  *   - Add any queries to the debug list with addDebug()
	  *   - Add any errors to the error list with addError()
	  *   - Return $this->returnData, or the appropriate error constant
	  *
	  * @return  Returns feedback from execution of this Gateway object, or an error constant defined
	  *          at the top of this file.
	  */
	function execute(){
		$this->simulateRefundsForTestURL = 1;
		return $this->runAuthNETProtocol();
	} //execute
	 
}
