<?php
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

require_once mb_path("/lib-mbapi/include/modules/gateway/gateway.php");

/**
 * This class is an instantion of the Gateway class, that executes a command pertaining
 * to comunicating with a payment gateway, in the default case from the database. Pass in
 * only the array parameters that are set.
 *
 * @package modernbill
 * @subpackage mbapi
 */

if (!$gatewayReturnsCache){
    $gatewayReturnsCache = array();
}
if (!$gatewayReturnsCache["securepayus"]){
    $gatewayReturnsCache["securepayus"] = array();
}

$className = "SecurePayUS";
$GLOBALS["moduleInfo"][$className] = array
(
    "type" => "gateway",
    "status" => "TRANS_TESTING",
    "version" => "1.0.2",
    "gatewaytype" => "1",
    "displayName" => "SecurePayUS",
    "author" => "Parallels",
    "capabilities" => array(GATEWAY_CHARGE, GATEWAY_AUTHORIZE, GATEWAY_PRIOR_AUTH_CHARGE, GATEWAY_REFUND, GATEWAY_ECHECK)
);

class SecurePayUS extends Gateway {

	/**
	 * Returns the module display for the SecurePayUS module. This includes version number and display name.
	 * the columns in config_params. This array will be looped by SetConfigGroups.
	 *
	 * @return	An array of arrays containing all the display info for the module.
	 */
    function getModuleInfo() {
        return $GLOBALS["moduleInfo"]["SecurePayUS"];
    }

	/**
	 * Instantiates the BluePay module and also the parent Gateway class. Sets capabilities and gateway URLs.
	 *
	 */
	function SecurePayUS($input) {
		$this->stringRep = "securepayusdf";
		parent::Gateway($input);

        $moduleInfo = $this->getModuleInfo();

        foreach ($moduleInfo["capabilities"] as $cap){
            $this->capabilities[$cap] = 1;
        }

		$this->liveURL = "https://www.securepay.com/AuthSpayAdapter/process.aspx";
		$this->testURL = "https://www.securepay.com/AuthSpayAdapter/process.aspx";
	}

	/**
	 * Returns the default configuration parameters for the BluePay module. The number of elements in each array must me identical to 
	 * the columns in config_params. This array will be looped by SetConfigGroups.
	 * 
	 * @return	An array of arrays containing all the parameters the module uses. 
	 */
    function addDefaultConfigParams() {
        static $defaultConfigParams = array(
            array(NULL, NULL, "Account_ID", "", "", "TRANS_SECURE_PAY_ACCOUNTID", "TRANS_SECURE_PAY_ACCOUNTID_DESC", "t", 1, 1, 0, NULL),
            array(NULL, NULL, "Secret_Key", "", "", "TRANS_SECURE_PAY_TRANS_KEY", "TRANS_SECURE_PAY_TRANS_KEY_DESC", "t", 1, 2, 0, NULL),
            array(NULL, NULL, "Testing", "1", "", "TRANS_GATEWAY_TESTING", "TRANS_GATEWAY_TESTING_DESC", "b", 1, 4, 0, NULL),
            array(NULL, NULL, "Invoice_Description", "", "", "TRANS_INVOICE_DESCRIPTION", "TRANS_INVOICE_DESCRIPTION_DESC", "a", 0, 5, 0, NULL),
            array(NULL, NULL, "card_accept_0", "1", "", "TRANS_ACCEPT_VISA", "TRANS_ACCEPT_VISA_DESC", "b", 1, 8, 0, NULL),
            array(NULL, NULL, "card_accept_1", "1", "", "TRANS_ACCEPT_MASTERCARD", "TRANS_ACCEPT_MASTERCARD_DESC", "b", 1, 9, 0, NULL),
            array(NULL, NULL, "card_accept_2", "1", "", "TRANS_ACCEPT_AMEX", "TRANS_ACCEPT_AMEX_DESC", "b", 1, 10, 0, NULL),
            array(NULL, NULL, "card_accept_3", "1", "", "TRANS_ACCEPT_DISCOVER", "TRANS_ACCEPT_DISCOVER_DESC", "b", 1, 11, 0, NULL),
            array(NULL, NULL, "card_accept_4", "1", "", "TRANS_ACCEPT_JCB", "TRANS_ACCEPT_JCB_DESC", "b", 1, 12, 0,NULL),
            array(NULL, NULL, "card_accept_5", "1", "", "TRANS_ACCEPT_ENROUTE", "TRANS_ACCEPT_ENROUTE_DESC", "b", 1, 13, 0, NULL),
            array(NULL, NULL, "card_accept_6", "1", "", "TRANS_ACCEPT_DINERS", "TRANS_ACCEPT_DINERS_DESC", "b", 1, 14, 0, NULL),
            array(NULL, NULL, "card_accept_7", "1", "", "TRANS_ACCEPT_SOLO", "TRANS_ACCEPT_SOLO_DESC", "b", 1, 15, 0, NULL),
            array(NULL, NULL, "card_accept_8", "1", "", "TRANS_ACCEPT_MAESTRO", "TRANS_ACCEPT_MAESTRO_DESC", "b", 1, 16, 0, NULL),
            array(NULL, NULL, "card_accept_9", "1", "", "TRANS_ACCEPT_DELTA", "TRANS_ACCEPT_DELTA_DESC", "b", 1, 17, 0, NULL),
            array(NULL, NULL, "card_accept_10", "1", "", "TRANS_ACCEPT_BANKCARD", "TRANS_ACCEPT_BANKCARD_DESC", "b", 1, 18, 0, NULL),
            array(NULL, NULL, "card_accept_11", "1", "", "TRANS_ACCEPT_ELECTRON", "TRANS_ACCEPT_ELECTRON_DESC", "b", 1, 19, 0, NULL),
            array(NULL, NULL, "accept_echeck", "1", "", "TRANS_ACCEPT_ECHECK", "TRANS_ACCEPT_ECHECK_DESC", "b", 1, 20, 0, NULL),
            );
        return $defaultConfigParams;
    }

	/**
	 *
	 * From a child module this function must do the following:
	 *   - Maintain $this->hasExecuted, $this->hasExecutedSuccessfully, $this->timestamp,
	 *     $this->status, $this->accountID
	 *   - Add any queries to the debug list with addDebug()
	 *   - Add any errors to the error list with addError()
	 *   - Return $this->returnData, or the appropriate error constant
	 *
	 * @return  Returns feedback from execution of this Gateway object, or an error constant defined
	 *          at the top of this file.
	 */
	function execute() {
		$overrides = array();
		$overrides["x_tran_key"] = $this->config["Secret_Key"];
		$overrides["x_Login"] = $this->config["Account_ID"];
		$this->runAuthNETProtocol($overrides);
	} //execute	
} // SecurePayUS

