<?php
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

require_once mb_path("/lib-tk/include/config/internal/states.php");
require_once mb_path("/lib-tk/include/config/internal/countries.php");
require_once mb_path("/lib-mbapi/include/modules/module.php");
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
require_once mb_path("/lib-tk/functions.php");
require_once mb_path("/lib-billing/include/config/registrar.php");

$i = 0;
/**
 * The constant to represent a successful registrar execution.
 */
define("REGISTRAR_SUCCESS", $i);
$i++;

/**
 * The constant to represent a failed registrar execution.
 */
define("REGISTRAR_FAILURE", $i);
$i++;

/**
 * The constant to represent a failed connection to a physical registrar during execution.
 */
define("REGISTRAR_CONNECTION_FAILURE", $i);
$i++;

/**
 * The constant to represent a failed requirement during parameter validation.
 */
define("REGISTRAR_PARAM_FAILURE", $i);
$i++;

/**
 * The constant to identify a registrar's charge capability.
 */
define("REGISTRAR_REGISTERDOMAIN", $i);
$i++;

/**
 * The constant to identify a registrar's transfer capability.
 */
define("REGISTRAR_TRANSFERDOMAIN", $i);
$i++;

/**
 * The constant to identify a registrar's renew domains capability.
 */
define("REGISTRAR_RENEWDOMAIN", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return contact info.
 */
define("REGISTRAR_GETDOMAINCONTACTDATA", $i);
$i++;

/**
 * The constant to identify a registrar's capability to update contact info.
 */
define("REGISTRAR_SETDOMAINCONTACTDATA", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return domain auto-renewal options.
 */
define("REGISTRAR_GETdomainRenewTypeOPTIONS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to update domain auto-renewal options.
 */
define("REGISTRAR_SETdomainRenewTypeOPTIONS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return domain registrar-lock options.
 */
define("REGISTRAR_GETDOMAINREGISTRARLOCKOPTIONS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to update domain registrar-lock options.
 */
define("REGISTRAR_SETDOMAINREGISTRARLOCKOPTIONS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's access password.
 */
define("REGISTRAR_GETDOMAINACCESSPASSWORD", $i);
$i++;

/**
 * The constant to identify a registrar's capability to update a domain's access password.
 */
define("REGISTRAR_SETDOMAINACCESSPASSWORD", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's expiration date.
 */
define("REGISTRAR_GETDOMAINEXPDATE", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's extended information.
 */
define("REGISTRAR_GETDOMAINEXTENDEDINFO", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's availability for registration.
 */
define("REGISTRAR_CHECKDOMAINAVAILABILITY", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's registrar info.
 */
define("REGISTRAR_CHECKDOMAINTRANSFERAVAILABILITY", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's renew type (manual or auto).
 */
define("REGISTRAR_GETDOMAINRENEWTYPEOPTIONS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to set a domain's renew type (manual or auto).
 */
define("REGISTRAR_SETDOMAINRENEWTYPEOPTIONS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's DNS info.
 */
define("REGISTRAR_GETDOMAINDNS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to set a domain's DNS info.
 */
define("REGISTRAR_SETDOMAINDNS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a reseller's account balance.
 */
define("REGISTRAR_CHECKACCOUNTBALANCE", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a list of TLDs with prices.
 */
define("REGISTRAR_GETTLDPRICING", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a domain's transfer status.
 */
define("REGISTRAR_GETTRANSFERSTATUS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to return a list of TLDs.
 */
define("REGISTRAR_GETTLDLIST", $i);
$i++;

/**
 * The constant to identify a registrar's supported TLDs.
 */
define("REGISTRAR_TLDS", $i);
$i++;

/**
 * The constant to identify a registrar's capability to retrun a domain's renew date.
 */
define("REGISTRAR_GETDOMAINRENEWDATE", $i);
$i++;

/**
 * The constant to identify a registrar's capability to do a live renewal using our system instead of the queue.
 */
define("REGISTRAR_LIVERENEW", $i);
$i++;

/**
 * The constant to identify a registrar's capability to fetch all domains in the account.
 */
define("REGISTRAR_GETDOMAINS", $i);
$i++;

/**
 * An interface for all Registrar modules to implement. If a Registrar module does not follow this interface
 * exactly, it is not portable among the application, and may fail at some points.  This interface
 * was written using a PHP4 implementation, but later should be changed for PHP5 implementation in order
 * to create truly abstract methods.
 *
 * @author  Vic Fryzel
 */
abstract class Registrar extends MB_Module
{
	/**
	 * The status returned by the last execution of this Registrar.
	 */
	public $status;

	/**
	 * The account id or call status code returned by the last execution of this Registrar.
	 */
	public $successCode;

	/**
	 * The capabilities provided by this Registrar object. The only required capability for a
	 * registrar is the "charge" capability.
	 */
	public $capabilities;

	/**
	 * The TLDs that this registrar supports.
	 */
	public $tlds;

	/**
	 * The response from the registrar.
	 */
	public $response;

	/**
	 * A set of default configuration parameters for all registrars (currently not in use).
	 */
	public $configParams;

	/**
	 * The constructor for a Registrar object. For the most part this constructor should not be overridden
	 * by Registrar implementations. This method is designed to take the <params> element of an MBAPI
	 * command's input XML. It uses getDBCol() and getDBXMLCol() to associate array element names with
	 * database column names, so literally when coming from an MBAPI command, no modification to the
	 * <params> element is needed. Be sure to pass in the <params> element as an array, and not raw XML.
	 *
	 * @param  params  The parameters needed by a Registrar object. All of the following parameters are
	 *                 required here, and if they are not provided, all calls to this class' methods will
	 *                 fail. Validity can be checked using the isValid() method. The following parameters
	 *                 are required:
	 *                   clientID, packageID, configID, domainID, registerTerm
	 *
	 *                   registrantFirstName, registrantLastName, registrantRole, registrantCompany,
	 *                   registrantEmail, registrantAddress, registrantAddress2, registrantCity,
	 *                   registrantState, registrantZip,
	 *                   registrantCountry, registrantPhone, registrantFax
	 */
	function Registrar($input) {
		parent::MB_Module($input);
		$this->setConfigID();

		$this->hasExecuted = $this->hasExecutedSuccessfully = 0;
		$this->status = REGISTRAR_FAILURE;
		$this->successCode = $this->valid = $this->accountID = 0;
		$this->connectionInfo = NULL;
		$this->tlds = array();
		$this->configParams = array();
		$this->response = "";
		$this->timestamp = mktime();
		$this->input = $input;

		if(!is_array($input)) {
			$this->status = REGISTRAR_PARAM_FAILURE;
		} else {

			if ($input["UID"]) {
				$this->UID = trim($input["UID"]);
			}
			if ($input["PW"]) {
				$this->PW = $input["PW"];
			}

			$subCommand = $this->input["subCommand"];
			switch ($subCommand) {
	         	// primary domain actions
				case "checkDomainAvailability":
					$this->checkDomainAvailability();
				break;
				case "checkDomainTransferAvailability":
					$this->checkDomainTransferAvailability();
				break;
				case "registerDomain":
					$this->registrarFormatPhone();
					$this->registerDomain();
				break;
				case "renewDomain":
				case "renew":
					$this->registrarFormatPhone();
					$this->renewDomain();
				break;
				case "transferDomain":
					$this->transferDomain();
				break;
				// manage contact data
				case "getDomainContactData":
					$this->getDomainContactData();
				break;
				case "setDomainContactData":
					$this->setDomainContactData();
				break;
				// manage auto-renew options
				case "getDomainRenewTypeOptions":
					$this->getdomainRenewTypeOptions();
				break;
				case "setDomainRenewTypeOptions":
					$this->setdomainRenewTypeOptions();
				break;
				// manage extended info
				case "getDomainExpDate":
					$this->getDomainExpDate();
				break;
				// manage exp date
				case "getDomainExtendedInfo":
					$this->getDomainExtendedInfo();
				break;
				// manage auto-renew options
				case "getDomainRegistrarLockOptions":
					$this->getDomainRegistrarLockOptions();
				break;
				case "setDomainRegistrarLockOptions":
					$this->setDomainRegistrarLockOptions();
				break;
				// manage access password
				case "getDomainAccessPassword":
					$this->getDomainAccessPassword();
				break;
				case "setDomainAccessPassword":
					$this->setDomainAccessPassword();
				break;
				// manage DNS
				case "getDomainDNS":
					$this->getDomainDNS();
				break;
				case "setDomainDNS":
					$this->setDomainDNS();
				break;
				case "getDomains":
					$this->getDomains();
				break;
				case "checkAccountBalance":
					$this->checkAccountBalance();
				break;
				default:
					$this->hasExecuted = 1;
					$this->numErrors ++;
					$this->errors[] = array("No subCommand supplied to Registrar.");
				break;

			} // (strtolower($this->params["subCommand"]))

		} // (!is_array($input))

	}

	/**
	 * This method will change the phone and fax number to match the format expected by the
	 * domain registrar [+] [country code] . [phone number]
	 *
	 */
	function registrarFormatPhone() {
		global $CONF;

		if (!preg_match("/\+[[:digit:]]+\.[[:digit:]]+/", $this->input['registrantPhone'])) {

			$this->input['registrantPhone'] = preg_replace("/[^[:digit:]]/", "", $this->input['registrantPhone']);

			if($this->input["registrantCountryPhoneCode"]) {
				$this->input["registrantPhone"] = "+".$this->input["registrantCountryPhoneCode"].".".$this->input["registrantPhone"];
			} else {
				$this->input["registrantPhone"] = "+1.".$this->input["registrantPhone"];
			}

		}

		if (!preg_match("/\+[[:digit:]]+\.[[:digit:]]+/", $this->input['registrantPhone'])) {

			$this->input['registrantFax'] = preg_replace("/[^[:digit:]]/", "", $this->input['registrantFax']);

			if($this->input["registrantCountryPhoneCode"]) {
				$this->input["registrantFax"] = "+".$this->input["registrantCountryPhoneCode"].".".$this->input["registrantFax"];
			} else {
				$this->input["registrantFax"] = "+1.".$this->input["registrantFax"];
			}

		}

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for checking a domain's availability for registration.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function checkDomainAvailability() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for checking a domain's availability for transfer.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function checkDomainTransferAvailability() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for registering a new domain name.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function registerDomain() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for transfering an existing domain name.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function transferDomain() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for renewing a new domain name.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function renewDomain() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's expiration date.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainExpDate() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's extended information.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainExtendedInfo() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's contact information.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainContactData() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for updating a domain's contact information.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainContactData() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's auto-renewal options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getdomainRenewTypeOptions() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's auto-renewal options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function checkAccountBalance() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for setting a domain's auto-renewal options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setdomainRenewTypeOptions() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's registrar lock options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainRegistrarLockOptions() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for setting a domain's registrar lock options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainRegistrarLockOptions() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's access password.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainAccessPassword() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for setting a domain's access password.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainAccessPassword() {

	}
	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for fetching a domain's name servers and dns setttings.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainDNS() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for setting a domain's name servers and dns settings.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainDNS() {

	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for grabbing a list of domains in registrar account.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomains() {

	}

	/**
	 * This method will set the valid name/value that are sourced from the attrobutes map.
	 *
	 * @param  var[]  array of valid fields to check
	 * @param  string  the contact type to pull.  Used when updating all
	 *
	 * @return  array An array of post fields
     */
    function getPostValues($validParams=array(), $type=null) {
        // load the attributes map
	  	$map = $this->getAttributesMap();
        // see if we have to test for valid params
        $c = count($validParams);
		// Loop the map and pull the needed fields
		$postValues = array();
		foreach($map as $k => $v) {
			if($type) {
				// if this element has a value it's part of this registrar's API, but only add it if it's set
				if($v && strlen($this->input["domainContactData"][$type][$k])>0 && (($c && in_array($v,$validParams)) || !$c)) {
					$postValues[$v] = $this->input["domainContactData"][$type][$k];
				}
			} else {
				// if this element has a value it's part of this registrar's API, but only add it if it's set
				if($v && strlen($this->input[$k])>0 && (($c && in_array($v,$validParams)) || !$c)) {
					$postValues[$v] = $this->input[$k];
				}
			}
		}

        return $postValues;
    }

	/**
	 * Get an array of capabilities that this Registrar object supports. The array is of the form:
	 *   REGISTRAR_CAPABILITY_CONSTANT => INTEGER
	 * If the INTEGER does not equal 0 (resolves to true), it can be assumed that this Registrar has
	 * the capability represented by REGISTRAR_CAPABILITY_CONSTANT, and if the REGISTRAR_CAPABILITY_CONSTANT
	 * array element is not set or is equal to 0, this Registrar object does not have that capability.
	 * The REGISTRAR_CAPABILITY_CONSTANT constants are defined at the top of this file.
	 *
	 * @return  An array of capabilities of this Registrar object.
	 */
	function getCapabilities() {
		return $this->capabilities;
	}

    /**
	 * This check for curl errors and set the proper panel settings if errors are found
	 *
	 */
	function getCurlErrors($c) {
    	if($c->numErrors>0){
		 	foreach($c->errors as $value) {
				$this->errors[] = array("cURL Error:", $value);
				$this->numErrors ++;
		 	}
		 	$this->hasExecutedSuccessfully = 0;
		 	$this->arrayData = $c->resultArray;
		}
	}

	/**
	 * This method will return the XML string with curl connection info if that data exists.  Time
	 * items will be in seconds with millisecond resolution and the size items will be in units of bytes
	 *
	 * @return  string  The XML string containing the cURL connection results.
	 */
	function getRegistrarCurlInfo() {
		$loopSpacer = " ";
	 	$connectionSets = "";
	 	$connectionSummaryData = array();
	 	$numSets = 0;
		if($this->connectionInfo){
			if(is_array($this->connectionInfo)){
				//Build the connection info XML
				$connectionSets .= "       <curlConnectionDataSets>\n";
				foreach($this->connectionInfo as $key => $value) {
				 	if (is_array($value)) {
						$connectionSets .= "          <curlConnectionDataSet>\n";
						foreach($value as $key1 => $value1) {
							$connectionSets .=  "            <$key1>".$value1."</$key1>\n";
						}
						$connectionSets .= "          </curlConnectionDataSet>\n";
						// add to summary data
						$connectionSummaryData["time_total"] += $value["time_total"];
						$connectionSummaryData["ave_time_namelookup"] += $value["time_namelookup"]; // ave
						$connectionSummaryData["ave_time_connect"] += $value["time_connect"]; // ave
						$connectionSummaryData["ave_time_pretransfer"] += $value["time_pretransfer"]; // ave
						$connectionSummaryData["ave_time_starttransfer"] += $value["time_starttransfer"]; // ave
						$connectionSummaryData["size_download"] += $value["size_download"];
						$connectionSummaryData["size_upload"] += $value["size_upload"];
						$connectionSummaryData["size_header"] += $value["size_header"];
						$connectionSummaryData["size_request"] += $value["size_request"];
						$connectionSummaryData["ave_speed_download"] += $value["speed_download"]; // ave
						$connectionSummaryData["ave_speed_upload"] += $value["speed_upload"]; // ave
						$numSets ++;
					} else {
						$connectionSets .=  "          <$key>".$value."</$key>\n";
					}
				}
				$connectionSets .= "        </curlConnectionDataSets>\n";
			}
		}
	 	$connectionSummary = "   <curlConnectionDataSummary>\n";
	 	$connectionSummary .=  "          <total_connections>".$numSets."</total_connections>\n";
		foreach($connectionSummaryData as $key => $value) {
			if (eregi("ave",$key) && $numSets != 0) {
				$value = round(($value / $numSets),4);
			}
			$connectionSummary .=  "          <$key>".$value."</$key>\n";
		}
	 	$connectionSummary .= "       </curlConnectionDataSummary>\n";
		return $connectionSummary.$connectionSets;
	}

	/**
	 * This method will return the XML string with curl connection info if that data exists.  Time
	 * items will be in seconds with millisecond resolution and the size items will be in units of bytes
	 *
	 * @return  string  The XML string containing the registrar results and cURL connection results.
	 */
	function getRegistrarReturnXML() {
		//$loopSpacer = " ";
		//return $this->getNestedXML($this->arrayData)."     ".$this->getRegistrarCurlInfo();
		return toXML($this->arrayData);
	}

	/**
	 * This method will return nested XML strings if data exists. We may move this method outside of the registrar
	 * class or it can be copied to other module classes.
	 *
	 * @return  string  The nested XML string.
	 * @author  Michael Fountain
	 */
	function getNestedXML($array) {
	 	global $loopSpacer;
	 	$currentSpacer = $loopSpacer."  ";
	 	$result = "";
		if (is_array($array)) {
	 	 	foreach($array as $key => $value) {
	 	 	 	if (is_array($value)) {
	 	 	 	 	#if (((INT) $key) || $key == 0) {
					#	$key = "response";
	 	 	 	 	#}
	 	 	 	 	$result .= $currentSpacer."      <$key>\n";
					$result .= $this->getNestedXML($value);
					$result .= $currentSpacer."      </$key>\n";
	 	 	 	} else {
					$result .= $currentSpacer."        <$key>$value</$key>\n";
				}
	 	 	}
		}
		return $result;
	}

	/**
	 * This method sets the $CONF array index value for this instance of a registrar
	 *
	 * @return  1 if the action executed successfully, and false if otherwise.
	 */
	function setConfigID() {
		//Find the CONF index for this registrar
		global $CONF;

		//Fix arrayness if only one registrar in the group
		$registrars = $CONF["domain"]["registrar"];
		if(is_array($registrars)) {
			foreach($registrars as $key => $value) {
				$temp = $value;
				//Decrypt the password
				if($temp["modulePassword"]) {
					$c = new Crypt(getPasswordHash(Crypt::ENCRYPTION_KEY), "orangefish", NULL);
					$d = $c->decrypt($temp["modulePassword"]);
					$temp["modulePassword"] = $d ? $d : $temp["modulePassword"];

				}
				if(is_array($temp)) {
					if(!$temp[0] && count($temp) > 0) {
						unset($CONF["domain"]["registrar"][$key]);
						$CONF["domain"]["registrar"][$key][$value["configGroupID"]] = $temp;
						$temp = "";
					}
				}
			}
		}

		if($CONF["domain"]["registrar"][strtolower($this->stringRep)]) {
			foreach($CONF["domain"]["registrar"][strtolower($this->stringRep)] as $key => $value) {
				if($value["configGroupID"] == (int) $this->input["configGroupID"]) {
					//Use this key to get the registrar's config options out of $CONF
					$id = $key;
				}
			}
		}
		//Push the config items onto this class if the id is found
		if($id) {
			$this->config = $CONF["domain"]["registrar"][strtolower($this->stringRep)][$id];
			if(!notNull( $this->UID )) {
				$this->UID = trim($CONF["domain"]["registrar"][strtolower($this->stringRep)][$id]["moduleUsername"]);
			}
			if(!notNull( $this->PW )) {
				$this->PW = $CONF["domain"]["registrar"][strtolower($this->stringRep)][$id]["modulePassword"];
			}
		}
		$this->configID = $id;

	}
	/**
	 * This method returns an array of Japanese prefectures
	 *
	 * @return  Array of prefectures
	 */
	function getJapanesePrefectures() {

		$validPrefectures = array(
			"Hokkaido" => 1, "Aomori" => 2, "Iwate" => 3, "Miyagi" => 4, "Akita" => 5, "Yamagata" => 6,
			"Fukushima" => 7, "Ibaragi" => 8, "Tochigi" => 9, "Gumma" => 10, "Saitama" => 11, "Chiba" => 12,
			"Tokyo" => 13, "Kanagawa" => 14, "Niigata" => 15, "Toyama" => 16, "Ishikawa" => 17, "Fukui" => 18,
			"Yamanashi" => 19, "Nagano" => 20, "Gifu" => 21, "Shizuoka" => 22, "Aichi" => 23, "Mie" => 24,
			"Shiga" => 25, "Kyoto" => 26, "Osaka" => 27, "Hyogo" => 28, "Nara" => 29, "Wakayama" => 30,
			"Tottori" => 31, "Shimane" => 32, "Okayama" => 33, "Hiroshima" => 34, "Yamaguchi" => 35, "Tokushima" => 36,
			"Kagawa" => 37, "Ehime" => 38, "Kochi" => 39, "Fukuoka" => 40, "Saga" => 41, "Nagasaki" => 42,
			"Kumamoto" => 43, "Oita" => 44, "Miyazaki" => 45, "Kagoshima" => 46, "Okinawa" => 47);

		return $validPrefectures;
	}

	/**
	 * This method returns the PUNYcode version of an IDN domain name
	 *
	 * @return  Domain SLD in PUNYcode format
	 */
	function getPUNYCode($sld){
		if (utf8_decode($sld) !== $sld){
			require_once mb_path("/lib-domain/include/idna/idna_convert.class.php");
			$idn = new Net_IDNA_php4();
			$encoded = $idn->encode($sld);
			$decoded = $idn->decode($encoded);

			// Double check that the encoding works
			if ($sld === $decoded){
				$sld = str_replace("&#45;", "-", $encoded);
			}
		}
		return $sld;
	}

	/**
	 *	Grab a list of the current TLD's
	 *
	 *	@author Brian Smith
	 */
	function getTLDs( $tld = false, $grabContents = false ) {
		global $CONF;
		$start = dirname( __FILE__).str_repeat("/..", 4);

		if ( ($dh = opendir($start.'/lib-domain/include/ccTLDs/')) == false) {
			$this->addError(TRANS_ACTIONERROR, "Failed to open or find TLD List");
			return false;
		}

		$excludeList = array('.', '..', 'CVS');
		$localeLang = $CONF["user"]["locale"]->language;
		$localeCountry = $CONF["user"]["locale"]->country;

		$localeCode = $localeLang."_".$localeCountry;

		$localeCode2='';
		if (strpos($localeLang,'_')) {
			$t = explode('_', $localeLang);
			$localeCode2 = $t[0]."_".$localeCountry;
			unset($t);
		}


		$ret = array();
		while( ($file = readdir($dh)) !== false ) {
			if (!in_array($file, $excludeList)) {
				$found = false;
				if ($tld == false) {
					// en_us.tld.us.xml
					$regex = "/^(?:$localeCode|$localeCode2)\.tld\.(.+)\.xml$/";
					if (preg_match($regex, $file, $match)) {
						if ($grabContents) {
							if ($match[1] == $grabContents) {
								$ret[ $match[1] ] = $this->_returnCCTLD( $file );
							}
						} else {
							$ret[] = $match[1];
						}
					}

					if (!$found) {
						// en.tld.us.xml
						$regex = "/^$localeLang\.tld\.(.+).xml$/";

						if (preg_match($regex, $file, $match)) {
							if ($grabContents) {
								if ($match[1] == $grabContents) {
									$ret[ $match[1] ] = $this->_returnCCTLD( $file );
								}
							} else {
								$ret[] = $match[1];
							}
						}
					}
				} else {
					$file_l = strtolower($file);
					switch( true ) {
					case ($file_l == strtolower("$localeCode.tld.$tld.xml")):
					case ($file_l == strtolower("$localeCode2.tld.$tld.xml")):
					case ($file_l == strtolower("$localeLang.tld.$tld.xml")):
						if ($grabContents) {
							$ret[ $tld ] = $this->_returnCCTLD( $file );
						} else {
							$ret[] = $tld;
						}
						break;
					}
				}

			}
		}
		return $ret;
	}

	/**
	 * This method needs to be overridden by children. When overridden, this function should contain
	 * the registrar specific code for validating an account or sub-account push.
	 *
	 * @return  string xmlData of containting results of the remote parking connection
	 */
	function validateAccount() {
		$this->arrayData["accountIsValid"] = 1;
		$this->arrayData["externalID"] = "";
		// Return
		$this->hasExecuted = 1;
		$this->xmlData = $this->getParkingReturnXML();
		return $this->xmlData;
	}

	function _returnCCTLD($file) {
		$start = dirname( __FILE__).str_repeat("/..", 4);
		$dir = $start.'/lib-domain/include/ccTLDs/';

		$fileLoc = $dir.$file;

		$xml = new MBXML(file_get_contents($fileLoc));

		$contents = $xml->toArray();

		if (isset($contents['interface-response']) && isset($contents['interface-response'][0]['attributes'])) {
			$contents = correctArray($contents);

			if (is_array($contents['interface-response'][0]['attributes'])) {
				return $contents['interface-response'][0]['attributes'];
			}
		}
		return false;
	}

	protected function getCurlObject($url = '', $fields = '', $cli = 0, $config_identity = NULL) {
		if (is_null($config_identity)) {
			$config_identity = 'Registrar_'.get_class($this);
		}
		$c = new Curl($url, $fields, $cli, $config_identity);
		return $c;
	}

} // Registrar

?>