{* $Id: ShowClientContacts.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template shows all contacts for a particular client.
 *
 * Smarty Variables:
 * $client					Array of client information
 * $contacts				Array of all associated contact information
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Ben Woolley
 *}
  
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CONTACTS"
	grandchildName="TRANS_SHOW_ALL"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/context/client.tpl" 
	client=$client suppressEditLink=1 suppressDeleteLink=1}

{assign var="clientID" value=$client.clientID}

<fieldset>
<legend>{"TRANS_PRIMARY_CONTACT"|lmsg}</legend>

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="firstTD" headerName="TRANS_CONTACT_ID"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_FIRST_NAME"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_LAST_NAME"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_COMPANY"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_EMAIL"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_STATUS"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="lastTD" headerName="TRANS_ACTIONS"}
</tr>
{section name="i" loop="$contacts"}
{assign var="clientContactID" value=$contacts[i].clientContactID}
{if $lastWasPrimary}
	{assign var="reset" value=true}
	<tbody>
	<tr>
		<td colspan="7" style="padding:0px;"><br />
			{strip}
			<fieldset>
			<legend>
				{"TRANS_ALTERNATE_CONTACTS"|lmsg}
				&nbsp;&nbsp;&nbsp;
				[&nbsp;<a href="{getHREF page="clients.php" actionName="AddClientContact" args="clientID=$clientID"}">
					{"TRANS_ADD_CONTACT"|lmsg}
				</a>&nbsp;]
			</legend>
			</fieldset>
			{/strip}
		</td>
	</tr>
	<tr class="headerRow">
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="firstTD" headerName="TRANS_CONTACT_ID"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_FIRST_NAME"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_LAST_NAME"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_COMPANY"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_EMAIL"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_STATUS"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="lastTD" headerName="TRANS_ACTIONS"}
	</tr>
	</tbody>
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2" reset=$reset}">
	<td>
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		{$clientContactID}
	</td>
	<td>{$contacts[i].contactFirstName}</td>
	<td>{$contacts[i].contactLastName}</td>
	<td>{$contacts[i].contactCompany}</td>
	<td>{$contacts[i].contactEmail}</td>
	<td>{$contacts[i].contactActive|getStatusName:"active"}</td>
	<td>
		{strip}
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			<img src="{$imageDirectory}/ico/more.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			{"TRANS_MORE"|lmsg}
		</a>
		{/strip}
	</td>
</tr>
</tbody>

{if $smarty.request.clientContactID == $contacts[i].clientContactID}
	{assign var="class" value="on"}
{else}
	{assign var="class" value="off"}
{/if}
<tbody id="row_{$clientContactID}" class="{$class}">
<tr>
	<td colspan="7" class="comments altinner">
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;
		<strong>{"TRANS_ADDITIONAL_ACTIONS"|lmsg}</strong>

		{if $contacts[i].contactActive && $client.clientActive && $client.clientStatus == "client"|getStatusID:"none"}{* client is active *}
			&nbsp;
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="clients.php"
				actionName="ForwardToClientInterface"
				args="clientID=$clientID&clientContactID=$clientContactID"
				icoImage="id_card.gif"
				altText="TRANS_LOGIN_AS_CONTACT"
				linkText="TRANS_LOGIN_AS_CONTACT"
				target="_blank"}
			&nbsp;
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="clients.php"
				actionName="ResetContactPassword"
				args="clientContactID=$clientContactID"
				icoImage="id_card_new.gif"
				altText="TRANS_RESET_RESEND_PASSWORD"
				linkText="TRANS_RESET_RESEND_PASSWORD"}
		{/if}

		&nbsp;
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="EditClientContact"
			args="clientID=$clientID&clientContactID=$clientContactID"
			icoImage="contact_edit.gif"
			altText="TRANS_EDIT"
			linkText="TRANS_EDIT"
			noSpace="0"
		}
		&nbsp;
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="RemoveClientContact"
			args="clientID=$clientID&clientContactID=$clientContactID"
			icoImage="contact_delete.gif"
			altText="TRANS_REMOVE"
			linkText="TRANS_REMOVE"
			noSpace="0"
		}

        <table width="100%" border="0" cellpadding="0" cellspacing="0">
        <tr>
            {************************** COLUMN 1 **************************}
            <td width="50%" valign="top" style="border:0px;">
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="addData">
				<tr class="alt1">
					<td><strong>{"TRANS_ADDRESS"|lmsg}</strong></td>
					<td>{$contacts[i].contactAddress1|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{$smarty.const.TRANS_ADDRESS2}:</strong></td>
					<td>{$contacts[i].contactAddress2|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt1">
					<td><strong>{"TRANS_CITY"|lmsg}</strong></td>
					<td>{$contacts[i].contactCity|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{"TRANS_STATE"|lmsg}</strong></td>
					<td>{$contacts[i].contactState|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt1">
					<td><strong>{"TRANS_ZIP"|lmsg}</strong></td>
					<td>{$contacts[i].contactZip|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{"TRANS_COUNTRY"|lmsg}</strong></td>
					<td>
						{assign var="trans_countriesISO2" value="TRANS_ISO_3166_`$contacts[i].countriesISO2`"}
						<img src="{$imageDirectory}/flags/flag-{$contacts[i].countriesISO2}.gif" style="vertical-align:middle;border-style:none;" title="{$smarty.const.$trans_countriesISO2}" alt="{$smarty.const.$trans_countriesISO2}" /> 
						{$contactCountries.$clientContactID}
					</td>
				</tr>
				</table>
			</td>
            {************************** COLUMN 2 **************************}
            <td width="50%" valign="top" style="border:0px;">
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="addData">
				<tr class="alt1">
					<td><strong>{"TRANS_PRIMARY_PHONE"|lmsg}</strong></td>
					<td>{$contacts[i].contactPhone1|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{"TRANS_SECONDARY_PHONE"|lmsg}</strong></td>
					<td>{$contacts[i].contactPhone2|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt1">
					<td><strong>{"TRANS_FAX"|lmsg}</strong></td>
					<td>{$contacts[i].contactFax|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{"TRANS_LANGUAGE"|lmsg}</strong></td>
					{assign var="languageID" value=$contacts[i].languageID}
					<td>{$languageList[$languageID]}</td>
				</tr>
				</table>
				<br />
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="addData">
				<tr class="alt1">
					<td width="35%"><strong>{"TRANS_USERNAME"|lmsg}</strong></td>
					<td>{$contacts[i].contactUsername|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
	</td>
</tr>
</tbody>
{if $contacts[i].contactPrimary}
	{assign var="lastWasPrimary" value=1}
{else}
	{assign var="lastWasPrimary" value=0}
{/if}
{sectionelse}
<tr class="alt1">
	<td colspan="7">{"TRANS_NORESULTS"|lmsg}</td>
</tr>
<tr>
	{assign var="clientID" value=$client.clientID}
	<td colspan="7"><a href="{getHREF page="clients.php" actionName="AddClientContact" args="clientID=$clientID"}">{"TRANS_ADD_CONTACT"|lmsg}</a></td>
</tr>
{/section}
</table>

</fieldset>
<br />

{include file="$tplDirectory/footer.tpl"}
