{* $Id: ShowConfigs.tpl 10464 2007-01-09 20:13:44Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of config groups and their params for editing.
 *
 * Smarty Variables:
 *	$configGroups (array of config group data)
 *
 * Author: Michael Fountain
 *}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName=$configGroups[0].configGroupTransKey
	sideNavMajor="system"
	parentConfigGroupID=$configGroups[0].parentConfigGroupID}

{if $saved}
{include
	file="$tplDirectory/widgets/showInvalidCustom.tpl"
	duration="4"
	message=$smarty.const.TRANS_SETTINGS_SAVED_SUCCESSFULLY}
{/if}
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
{section name="i" loop=$configGroups}
	{assign var="configGroupTransKey" value=$configGroups[i].configGroupTransKey}
	{assign var="parentConfigGroupID" value=$configGroups[i].parentConfigGroupID}
	{assign var="description" value=$configGroups[i].configGroupDescription}
    {******************* HEADER ROW *******************}
	<tr class="listRowNoBorders">
		<td>
            {strip}
			<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}">
				<img src="{$imageDirectory}/ico/arrow_left_blue.gif" width="16" height="16" alt="{"TRANS_PREVIOUS"|lmsg}" title="{"TRANS_PREVIOUS"|lmsg}" style="vertical-align:text-bottom;" />
			</a>
			<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}">
			{$configGroupTransKey|lmsg}
			</a>
			{if $description != ""}
			<p>{$description|lmsg}</p>
			{/if}
            {/strip}
		</td>
	</tr>
	{section name=link loop=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup}
		{* create shorter variables names for easier usage below *}
		{assign var="configChildGroupTransKey" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupTransKey}

		{if "" != $configChildGroupTransKey}
		{assign var="configChildGroupID" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupID}
		{assign var="configChildGroupActionFile" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupActionFile}
		{assign var="configChildGroupActionName" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupActionName}
		{assign var="configChildGroupDescription" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupDescription}
		{if $className=="alt1"}
			{assign var="className" value="alt2"}
		{else}
			{assign var="className" value="alt1"}
		{/if}
		<tr>
			<td>
				{assign var="linkTitle" value=$configChildGroupTransKey|lmsg}
				{assign var="icomenuone" value=$cfg_icomenu[$configChildGroupTransKey]}
				{if $configChildGroupActionFile!="" && $configChildGroupActionName!=""}
					<a href="{getHREF page=$configChildGroupActionFile actionName=$configChildGroupActionName args="configGroupID=$configChildGroupID"}" class="inner">
						<img src="{$imageDirectory}/ico/{$icomenuone}.gif" width="16" height="16" alt="{"TRANS_NEXT"|lmsg}" title="{"TRANS_NEXT"|lmsg}" style="vertical-align:text-bottom;" />
					</a>
					<a href="{getHREF page=$configChildGroupActionFile actionName=$configChildGroupActionName args="configGroupID=$configChildGroupID"}" class="inner">
					{$linkTitle}
					</a>
				{else}
					<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="configGroupID=$configChildGroupID"}" class="inner">
						<img src="{$imageDirectory}/ico/{$icomenuone}.gif" width="16" height="16" alt="{"TRANS_NEXT"|lmsg}" title="{"TRANS_NEXT"|lmsg}" style="vertical-align:text-bottom;" />
					</a>
					<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="configGroupID=$configChildGroupID"}" class="inner">
					{$linkTitle}
					</a>
					{if !is_null($configChildGroupDescription)}
						<br />
						<p>{$configChildGroupDescription|lmsg}</p>
					{/if}
				{/if}
			</td>
		</tr>
		{/if}
	{sectionelse}
        {* NO USE FOR THIS YET -- BUT DO NOT REMOVE IT -- MF
		<tr>
			<td>{"TRANS_NO_CHILDREN_FOUND"|lmsg}</td>
		</tr>
        *}
	{/section}
{/section}
</table>
<br />
<form method="post" action="configs.php" enctype="multipart/form-data">
<input type="hidden" name="action" value="{getActionID action="EditConfigParamsResponse"}" />
<input type="hidden" name="adminGroupID" value="{$adminGroup.adminGroupID}" />
<input type="hidden" name="redirectURL" value="{$fileName}" />
<input type="hidden" name="redirectAction" value="{$actionName}" />
<input type="hidden" name="redirectArgs" value="{$bookmarkArgs}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
{section name="i" loop="$configParams"}
{if $configParams[i].configParamInputType!="h"} {* type:h - hidden. *}
	{assign var="configParamID" value=$configParams[i].configParamID}
	{assign var="configParamName" value=$configParams[i].configParamName}
	{assign var="configParamTransKey" value=$configParams[i].configParamTransKey}
	{assign var="configParamDescription" value=$configParams[i].configParamDescription}
	{if !$results}
		{assign var="results" value=1}
		<thead>
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="30%" headerName="TRANS_CONFIGURATION_PARAMETERS"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="40%" headerName="TRANS_VALUES"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="30%" headerName="TRANS_DESCRIPTION"}
		</tr>
		</thead>
	{/if}
	{if $className=="alt1"}
		{assign var="className" value="alt2"}
	{else}
		{assign var="className" value="alt1"}
	{/if}
	{if $configParamTransKey!="" && defined($configParamTransKey)}
		{assign var="configTitle" value=$smarty.const.$configParamTransKey}
	{else}
		{assign var="configTitle" value=$configParamTransKey}
	{/if}
	<tr>
		<td valign="top" class="title">
			{$configTitle}:
		</td>
		<td class="nowrap">
			{* the ID must be passed as well! *}
			<input type="hidden" name="configParams[{$configParamName}][configParamID]" value="{$configParams[i].configParamID}" />
			{if !$configParams[i].configParamInputType || $configParams[i].configParamInputType=="t"}
				<input type="text" name="configParams[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{elseif $configParams[i].configParamInputType=="f"}
				<input type="file" name="{$configParamName}" value="{$configParams[i].configParamValue}" />
			{elseif $configParams[i].configParamInputType=="p"}
				<input type="password" name="configParams[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{elseif $configParams[i].configParamInputType=="a"}
				<textarea name="configParams[{$configParamName}][configParamValue]" cols="40" rows="3">{$configParams[i].configParamValue}</textarea>
			{elseif $configParams[i].configParamInputType=="s"}
				<select name="configParams[{$configParamName}][configParamValue]">
					{html_options options=$configParamValues[$configParamID] selected=$configParams[i].configParamValue}
				</select>
			{elseif $configParams[i].configParamInputType=="m"}
				<select name="configParams[{$configParamName}][configParamValue]" multiple="multiple">
					{html_options options=$configParamValues[$configParamID] selected=$configParams[i].configParamValue}
				</select>
			{elseif $configParams[i].configParamInputType=="c"}
				{html_checkboxes
					name="configParams[$configParamName][configParamValue]"
					options=$configParamValues[$configParamID]
					selected=$configParams[i].configParamValue
					separator="<br />"}
			{elseif $configParams[i].configParamInputType=="r"}
				{html_radios
					name="configParams[$configParamName][configParamValue]"
					options=$configParamValues[$configParamID]
					selected=$configParams[i].configParamValue
					separator="&nbsp;&nbsp;"}
			{elseif $configParams[i].configParamInputType=="b"}
				<input type="radio"
					name="configParams[{$configParamName}][configParamValue]"
					{if $configParams[i].configParamValue == 0}checked{/if}
					value="0">&nbsp;{"TRANS_NO"|lmsg}
				&nbsp;
				<input type="radio"
					name="configParams[{$configParamName}][configParamValue]"
					{if $configParams[i].configParamValue == 1}checked{/if}
					value="1">&nbsp;{"TRANS_YES"|lmsg}
			{else}
				<input type="text" name="configParam[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{/if}
		</td>
		<td>
		{assign var="descr" value=$configParamDescription|lmsg}
			{if "" != $descr}
				{assign var="caption" value=$smarty.const.TRANS_DESCRIPTION}
				{assign var="closetext" value=$smarty.const.TRANS_CLOSE}
				{strip}
	            <a href="javascript:void(0);" onclick="return XKol('{$descr|addslashes}','{$caption}: {$configTitle}');">
					<img src="{$imageDirectory}/ico/help.gif" width="16" height="16" style="vertical-align:text-bottom;" />
	            </a>
	            {/strip}
			{else}
				<i>{"TRANS_NONE"|lmsg}</i>
			{/if}
		</td>
	</tr>
{/if}
{sectionelse}
	{assign var="results" value=0}
	<tr>
		<td colspan="3">{"TRANS_NO_CONFIG_PARAMS_FOUND"|lmsg}</td>
	</tr>
{/section}
{if $results==1}
	<tr class="listButtons">
		<td colspan="3"><div><input class="submit" type="submit" name="submit" value="{"TRANS_SAVE_SETTINGS"|lmsg}" /></div></td>
	</tr>
{/if}
</table>

</form>

{include file="$tplDirectory/footer.tpl"}
