{* $Id: AddTLD.tpl 9605 2006-10-16 20:48:42Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to edit an existing client.
 *
 * Smarty Variables:
 *	$formValues (array of this clients data)
 *		clientID			A unique client ID
 *		clientFirstName		A client's first name
 *		clientLastName		A client's last name
 *		clientEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}








{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_PRODUCTS"
	childName="TRANS_TLDS"
	grandchildName="TRANS_ADD_TLD_TITLE"
	sideNavMajor="products"
	sideNavMinor="tlds"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form name="addTLD" method="post" action="products.php">
<input type="hidden" name="action" value="{getActionID action="AddTLDResponse"}">
<input type="hidden" name="tldID" value="{$formValues.tldID}">
<input type="hidden" name="sid" value="{$sid}">

<fieldset>
<legend>{"TRANS_TLD_LEGEND"|lmsg}</legend>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
<tbody>
<tr {if $invalid.tldName}class="highlight"{/if}>
	<td class="title"><label for="tldName">{"TRANS_NAME"|lmsg}<br />{"TRANS_TLD_NAME_DESC"|lmsg}</label></td>
	<td><input size="80"	maxlength="100" type="text" id="tldName" name="tldName" value="{$formValues.tldName}" /> {$invalid.tldName}</td>
</tr>
<tr {if $invalid.tldExtension}class="highlight"{/if}>
	<td class="title"><label for="tldExtension">{"TRANS_EXTENSION"|lmsg}</label></td>
	<td><input size="25" maxlength="25" type="text" id="tldExtension" name="tldExtension" value="{$formValues.tldExtension}" /> {$invalid.tldExtension}</td>
</tr>
<tr {if $invalid.registrarID}class="highlight"{elseif $tldNotSupported}class="highlight"{/if}>
	<td class="title"><label for="registrarID">{"TRANS_REGISTRAR_NAME_OPTION"|lmsg}</label></td>
	<td><select id="registrarID" name="registrarID"> {html_options options=$registrars selected=$formValues.registrarID} </select> {$invalid.registrarID}{if $tldNotSupported}{"TRANS_UNSUPPORTED_TLD"|lmsg}{/if}</td>
</tr>
<tr {if $invalid.tldAccepted}class="highlight"{/if}>
	<td class="title"><label for="tldActive">{"TRANS_ACTIVE"|lmsg}<br />{"TRANS_TLD_ACTIVE_DESC"|lmsg}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldActive" value="0">
		<input type="checkbox" id="tldActive" name="tldActive" value="1" {strip}
			{if $formValues.tldActive}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldActive">{"TRANS_ACTIVE"|lmsg}</label>
		{$invalid.tldActive}
	</td>
</tr>
{*
* We may already know what the whois server and response is. Only fringe cases will this need to be defined,
* otherwise it only causes confusion.
<tr {if $invalid.tldWhoisServer}class="highlight"{/if}>
	<td class="title"><label for="tldWhoisServer">{"TRANS_WHOIS_SERVER"|lmsg}<br />{"TRANS_WHOIS_SERVER_DESC"|lmsg}</label></td>
	<td><input size="80" 	maxlength="100" type="text" id="tldWhoisServer" name="tldWhoisServer" value="{$formValues.tldWhoisServer}" /> {$invalid.tldWhoisServer}</td>
</tr>
<tr {if $invalid.tldWhoisResp}class="highlight"{/if}>
	<td class="title"><label for="tldWhoisResp">{"TRANS_WHOIS_RESPONSE"|lmsg}</label></td>
	<td><input size="80" 	maxlength="100" type="text" id="tldWhoisResp" name="tldWhoisResp" value="{$formValues.tldWhoisResp}" /> {$invalid.tldWhoisResp}</td>
</tr>
*}
<tr {if $invalid.tldAutoSearch}class="highlight"{/if}>
	<td class="title"><label for="tldAutoSearch">{"TRANS_AUTO_SEARCH"|lmsg}<br />{"TRANS_AUTO_SEARCH_DESC"|lmsg}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldAutoSearch" value="0">
		<input type="checkbox" id="tldAutoSearch" name="tldAutoSearch" value="1" {strip}
			{if $formValues.tldAutoSearch}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldAutoSearch">{"TRANS_ENABLED"|lmsg}</label>
		{$invalid.tldAutoSearch}
	</td>
</tr>
<tr {if $invalid.tldIsTransferable}class="highlight"{/if}>
	<td class="title"><label for="tldIsTransferable">{"TRANS_IS_TRANSFERABLE"|lmsg}<br />{"TRANS_IS_TRANSFERABLE_DESC"|lmsg}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldIsTransferable" value="0">
		<input type="checkbox" id="tldIsTransferable" name="tldIsTransferable" value="1" {strip}
			{if $formValues.tldIsTransferable}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldIsTransferable">{"TRANS_YES"|lmsg}</label>
		{$invalid.tldIsTransferable}
	</td>
</tr>
<tr {if $invalid.tldTransferType}class="highlight"{/if}>
	<td class="title"><label for="tldTransferType">{"TRANS_TRANSFER_TYPE"|lmsg}<br />{"TRANS_TRANSFER_TYPE_DESC"|lmsg}</label></td>
	<td><select id="tldTransferType" name="tldTransferType"> {html_options options=$transferTypes selected=$formValues.tldTransferType} </select> {$invalid.tldTransferType}</td>
</tr>
<tr {if $invalid.tldTransferMinimumCycleID}class="highlight"{/if}>
	<td class="title"><label for="tldTransferMinimumCycleID">{"TRANS_TRANSFER_MINIMUM_CYCLE"|lmsg}</label></td>
	<td><select id="tldTransferMinimumCycleID" name="tldTransferMinimumCycleID"> {html_options options=$cycleList selected=$formValues.tldTransferMinimumCycleID} </select> {$invalid.tldTransferMinimumCycleID}</td>
</tr>
<tr {if $invalid.tldMinimumCycleID}class="highlight"{/if}>
	<td class="title"><label for="tldMinimumCycleID">{"TRANS_MINIMUM_TERM"|lmsg}</label></td>
	<td><select id="tldMinimumCycleID" name="tldMinimumCycleID"> {html_options options=$cycleList selected=$formValues.tldMinimumCycleID} </select> {$invalid.tldMinimumCycleID}</td>
</tr>
<tr {if $invalid.tldMaximumCycleID}class="highlight"{/if}>
	<td class="title"><label for="tldMaximumCycleID">{"TRANS_MAXIMUM_TERM"|lmsg}</label></td>
	<td><select id="tldMaximumCycleID" name="tldMaximumCycleID"> {html_options options=$cycleList selected=$formValues.tldMaximumCycleID} </select> {$invalid.tldMaximumCycleID}</td>
</tr>
<tr {if $invalid.tldRenewType}class="highlight"{/if}>
	<td class="title"><label for="tldRenewType">{"TRANS_LOCAL_RENEW_TYPE"|lmsg}</label></td>
	<td><select id="tldRenewType" name="tldRenewType"> {html_options options=$tldRenewTypes selected=$formValues.tldRenewType} </select> {$invalid.tldRenewType}</td>
</tr>
<tr {if $invalid.tldIDNSupport}class="highlight"{/if}>
	<td class="title"><label for="tldIDNSupport">{"TRANS_IDN_SUPPORT"|lmsg}<br />{"TRANS_IDN_SUPPORT_DESC"|lmsg}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldIDNSupport" value="0">
		<input type="checkbox" id="tldIDNSupport" name="tldIDNSupport" value="1" {strip}
			{if $formValues.tldIDNSupport}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldIDNSupport">{"TRANS_YES"|lmsg}</label>
		{$invalid.tldIDNSupport}
	</td>
</tr>
<tr {if $invalid.tldIDNType}class="highlight"{/if}>
	<td class="title"><label for="tldIDNType">{"TRANS_IDN_TYPE"|lmsg}</label></td>
	<td><select id="tldIDNType" name="tldIDNType"> {html_options options=$IDNTypes selected=$formValues.tldIDNType} </select> {$invalid.tldIDNType}</td>
</tr>
<tr {if $invalid.tldRemoteLockEnabled}class="highlight"{/if}>
	<td class="title"><label for="tldRemoteLockEnabled">{"TRANS_REMOTE_LOCK"|lmsg}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldRemoteLockEnabled" value="0">
		<input type="checkbox" id="tldRemoteLockEnabled" name="tldRemoteLockEnabled" value="1" {strip}
			{if $formValues.tldRemoteLockEnabled}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldRemoteLockEnabled">{"TRANS_ENABLED"|lmsg}</label>
		{$invalid.tldRemoteLockEnabled}
	</td>
</tr>

<tr class="listButtons">
	<td colspan=2>
	<div>
		<input class="submit" type="submit" name="submit" value="{"TRANS_ADD_TLD"|lmsg}" onClick="selectAllOptions(document.addTLD.elements['orderForms[]']);selectAllOptions(document.addTLD.elements['cycles[]']);" />
		<input class="reset" type="reset" value="{"TRANS_RESET"|lmsg}" />
	</div>
	</td>
</tr>
</tbody>
</table>

</fieldset>
</form>

{include file="$tplDirectory/footer.tpl"}
