{* $Id: header.tpl 10630 2007-02-04 02:16:59Z bwoolley $
 * --------------------------------------------------------------
 * This is the primary header template for the Client GUI of ModernBill. Note that this header.tpl
 * file will open several HTML tags must be closed by the footer.tpl file.
 *
 * Smarty Variables:
 *  $htmlTitle		The title of this document
 *  $htmlLang		The language this document will render
 *	$parentName		The page info parent name
 *	$childName		The page info child name
 *	$useMenu		The tab name to highlight
 *	$tabMajor		The side navigation file to include
 *	$loginName		The name of the admin user who is logged in
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *
 * Example Usage:
 *  {include file="$tplDirectory/client/header.tpl" parentName="TRANS_" childName="TRANS_" tabMajor="dashboard"}
 *
 * Author: Michael Fountain
 *}



{php}
	global $CONF;
	$clientContactID = $CONF['user']['clientContactID'];
	$this->assign('clientContactID', $clientContactID);
{/php}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$htmlLang}" lang="{$htmlLang}" dir="{"TRANS_TEXTDIRECTION"|lmsg}">
<head>
<title>{strip}
	{if $htmlTitle}
		{$htmlTitle}
	{else}
		{if $parentName}
			{translate key=$parentName}
		{/if}
		{if $childName}
			&nbsp;&raquo; {translate key=$childName}
		{/if}
		{if $grandchildName}
			&nbsp;&raquo; {translate key=$grandchildName}
		{/if}
	{/if}
{/strip}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="shortcut icon" href="{$imageDirectory}/logos/favicon.ico" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/style.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/menu.css" />
<link rel="stylesheet" type="text/css" href="{$skinDirectory}/css/billing.css" />
<!--[if lte IE 7]><link rel="stylesheet" type="text/css" href="{$skinDirectory}/css/ie.css"><![endif]-->
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/main.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/toggle.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/overlib.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/pushpull.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/lib/prototype.js"></script>
{if $includeAjaxJS}
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/../ajax/core/ajax.inc.js"></script>
{/if}

<script language="javascript" type="text/javascript" charset="utf-8">
{literal}
	function toggleSubNav(x){
		toggleobjbyid('majorNavDiv_'+x);
		var a = document.getElementById('majorNavDivZag_'+x);
		if(a.className=="lbox01m1"){
			a.className="lbox01m0";
		}else{
			a.className="lbox01m1";
		}
	}
{/literal}
</script>
{ if isset($page) && !is_int($page)}
{$page->getCSS()}
{/if}
</head>
<body id="pageLayout" onload="turnAutocompleteOff();">

{* Top logo *}
{include
	file="$commonTplDirectory/frameset/topFrame.tpl"
	profileActionScript="profile.php"
	profileActionName="EditClientContact"
	profileActionQuery="clientContactID=$clientContactID"
	loginUsername="$loginUsername"
}

{* <SPAN id="topTxtMyAccount"><a href="{getHREF page="profile.php" actionName="EditClientContact"}&clientContactID={$clientContactID}">{"TRANS_PROFILE"|lmsg}</a></SPAN> *}

<table cellspacing="0" cellpadding="0" class="top01" ondblclick="handleDoubleClick(event);">
<tbody>
<tr>
	<td id="navLayoutWrapper" class="bgl navMain" valign="top" style="height:94%;vertical-align:top;">{* see note below *}
	<div id="navArea">
	<div class="block01" id="navLayout">
	{include file="$tplDirectory/widgets/menus/tabMenu_dashboard.tpl"}
	{include file="$tplDirectory/widgets/menus/tabMenu_packages.tpl"}
	{include file="$tplDirectory/widgets/menus/tabMenu_profile.tpl"}
	{* {include file="$tplDirectory/widgets/menus/tabMenu_system.tpl"} *}
<div class="copyright">
<a target="_blank" href="http://www.parallels.com">{"TRANS_COMPANY_COPYRIGHT"|lmsg}</a>
</div>
	</div>{* block01 *}
	</div>
	</td>
	<td class="LeftFrameSwitcher"><img width="1" height="1" border="0" src="{$skinDirectory}/images/1x1.gif"></td>
	<td class="MainFrameBody" valign="top" style="height:94%;vertical-align:top;">
<div style="vertical-align:top;">

{if $parentName==""}
	{assign var="parentName" value=$sideNavMajor}
{/if}

{if $showScreenTitle}
	{include file="$commonTplDirectory/widgets/pageInfo.tpl" parentName=$parentName childName=$childName assign="screenTitle"}
	{include file="$commonTplDirectory/widgets/screenTitle.tpl" screenTitle=$screenTitle parentName=$parentName childName=$childName}
{/if}

{if ! isset($page)}
	<div class="block02" id="main">{* required open div -- do not remove or close *}
		<div class="block03" id="contents">{* required open div -- do not remove or close *}

			{include file="$commonTplDirectory/widgets/showMessages.tpl"}
{/if}

{*
 * Note: Leave the <td> above open. It will be closed at the top of the footer.tpl file.
 * Example: "header.tpl <td>" some content "</td> footer.tpl"
 *}
