{*
 * --------------------------------------------------------------
 * This template displays the ledger accounts management page.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Kris Bailey
 *}



<script language="JavaScript" type="text/javascript" charset="utf-8">
// <![CDATA[
{literal}
function initiateLogin(){
	document.getElementById('innerlogindiv').innerHTML = document.getElementById('loginHTML').innerHTML;
	XKsmoothSize('outerlogindiv', 'innerlogindiv');
}

function cancelLogin(){
	document.getElementById('innerlogindiv').innerHTML = '<span style="font-size: 1pt;">&nbsp;</span>';
	XKsmoothSize('outerlogindiv', 'innerlogindiv');
}

function initiateForgotPassword(){
	XKdelayedContent = document.getElementById('forgotPasswordHTML').innerHTML;
	document.getElementById('innerlogindiv').innerHTML = "<span style='font-size: 1pt;'>&nbsp;</span>";
	XKsmoothSize('outerlogindiv', 'innerlogindiv');
}

function cancelForgotPassword(){
	XKsmoothCallback = "initiateLogin();";
	document.getElementById('innerlogindiv').innerHTML = "<span style='font-size: 1pt;'>&nbsp;</span>";
	XKsmoothSize('outerlogindiv', 'innerlogindiv');
}

{/literal}
// ]]>
</script>

{assign var="orderTotal" value=0}

<div class="st01 st03 box07" style="margin-right: 10px; margin-top: 10px; margin-bottom: 10px; margin-left: 10px;">
<div style="text-align: left; margin-bottom: 2px;">
<h1>{"TRANS_CART_SUMMARY"|lmsg}&nbsp;
{if isset($price_include_tax)}
 	({$price_include_tax})
{/if}
</h1>
<div style="padding: 5px; background-color: #fff; text-align: center;">

<table border="0" width="100%" class="tab01">

{if !$suppressLoginHeader}
	<tr>
		<td>
			<div class="rm" style="float: right; margin-right: 5px; margin-top: 5px;"><a href="{$continueShoppingURL}">{"TRANS_CONTINUE_SHOPPING"|lmsg}</a></div>
			{if $userShoppingSession}
				<div><div style="text-align: left; margin-bottom: 2px;" class="st03"><h1 class="box07"><span style="font-weight: normal;">{"TRANS_SIGNED_IN_AS"|lmsg}</span> {$userShoppingSession.firstName} {$userShoppingSession.lastName}, <em><a href="cart.php?sid={$sid}&action={getActionID action="ProcessCartLoginResponse"}&logout=1">{"TRANS_SIGNOUT"|lmsg}</a></em></h1></div></div>
			{else}
				<div><div style="text-align: left;" class="st03"><h1 class="box07"><span style="font-weight: normal;">{"TRANS_NOT_SIGNED_IN"|lmsg},</span> <em><a href="#" onclick="initiateLogin();">{"TRANS_SIGN_IN_NOW"|lmsg}</a></em></h1></div></div>
				<div align="left" id="outerlogindiv" style="padding: 2px; {if $incorrectLogin=="yes" OR $smarty.request.forgotSuccess}height: 50px;{else}height: 1px;{/if} overflow: hidden;">
					<div align="left" id="innerlogindiv">
					{if $incorrectLogin=="yes"}
						<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr class="highlight"><td>{"TRANS_LOGIN_INCORRECT"|lmsg}</td></tr></table>
					{elseif $smarty.request.forgotSuccess}
						<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr class="highlight"><td>{if $smarty.request.forgotSuccess=='true'}{"TRANS_NEW_PASSWORD_SEND_SUCCESSFULLY"|lmsg}{else}{"TRANS_RESET_PASSWORD_ERROR"|lmsg}{/if}</td></tr></table>
					{else}
						<span style="font-size: 1pt;">&nbsp;</span>
					{/if}</div>
				</div>
			{/if}
		</td>
	</tr>
{/if}

{if $shoppingItems.0.shoppingItemID}

	<tr>
		<td align="left">
		<div id="cartcontentdiv"><div id="innercartcontentdiv">
		<table border="0" width="100%" cellpadding="3" cellspacing="0" class="tab01">
			<tr>
				<th>{"TRANS_ITEM_NAME"|lmsg}</th>
				<th>{"TRANS_CYCLE"|lmsg}</th>
				<th>{"TRANS_PRICE"|lmsg}</th>
				{if $show_vat == true}
					<th align="right">{"TRANS_VAT"|lmsg}</th>
				{/if}
				<th>{"TRANS_DISCOUNT_PRICE"|lmsg}</th>
			</tr>

		{section name="i" loop=$shoppingItems}

			{assign var="productID" value=$shoppingItems[i].productID}
			{assign var="productVariantID" value=$shoppingItems[i].productVariantID}
			{assign var="shoppingItemID" value=$shoppingItems[i].shoppingItemID}
			{assign var="cycleID" value=$shoppingItems[i].cycleID}
			{assign var="thisdomains" value=$shoppingItems[i].domains}

			{if $thisdomains.0.shoppingItemsDomainsRelID || $shoppingItems[i].shoppingItemSLD!="" || $shoppingItems[i].children.0.shoppingItemID>0}
				{assign var="rowspan" value="2"}
			{else}
				{assign var="rowspan" value="1"}
			{/if}

			<tr class="{if $smarty.section.i.index%2==0}alt1{else}alt2{/if}">
				<td valign="top" align="left">
					<strong>{$products.$productID.productName|constant}</strong> <!-- <small>({"TRANS_ID"|lmsg} {$shoppingItems[i].productID})</small> -->
					{if $keyedVariants.$productVariantID.productVariantDisplayName!=$products.$productID.productName}
						<br />
						<strong><em>{$keyedVariants.$productVariantID.productVariantDisplayName}</em></strong>
					{/if}
					<br />{$products.$productID.productComments|constant}
				</td>
				<td valign="top" align="left">
					{if $products.$productID.numCycles<2 && $products.$productID.productStopNumCycles==1}
					{else}
						{$cycleList.$cycleID}
					{/if}
				</td>
				<td rowspan="{$rowspan}" valign="top" align="right" style="border-bottom: 1px solid #999;">
					<div align="right" style="white-space: nowrap;"><strong>
					{if $shoppingItems[i].originalPrice}
						<strike>{$shoppingItems[i].originalPrice|getAmount:$shoppingItems[i].currencyID}</strike>
						{$shoppingItems[i].shoppingItemPrice|getAmount:$shoppingItems[i].currencyID}
					{else}
						{$shoppingItems[i].shoppingItemPrice|getAmount:$shoppingItems[i].currencyID}
					{/if}
					</strong></div>
					{if $shoppingItems[i].shoppingItemSetupPrice>0}
						<div align="right" style="white-space: nowrap;">{"TRANS_PLUS_SETUP"|lmsg} <strong>{$shoppingItems[i].shoppingItemSetupPrice|getAmount:$shoppingItems[i].currencyID}</strong></div>
					{/if}
					{if $shoppingItems[i].appliedCoupons.0.couponID>0}
						{section name="c" loop=$shoppingItems[i].appliedCoupons}
							{if $shoppingItems[i].appliedCoupons[c].shoppingCouponType}
								{assign var="mcp" value=$shoppingItems[i].appliedCoupons[c].discount}
								<div align="right" style="white-space: nowrap;">{"TRANS_DISCOUNT"|lmsg} <strong>-{$mcp|getAmount:$shoppingItems[i].currencyID}</strong></div>
							{else}
								{assign var="mcp" value=$shoppingItems[i].appliedCoupons[c].discount}
								<div align="right" style="white-space: nowrap;">{"TRANS_COUPON"|lmsg} <strong>-{$mcp|getAmount:$shoppingItems[i].currencyID}</strong><br /><em>({$shoppingItems[i].appliedCoupons[c].couponCode})</em></div>
							{/if}
						{/section}
					{/if}

				</td>
				{if $show_vat == true}
					<td valign="top" align="right">
						<div align="right" style="white-space: nowrap;"><strong>{$shoppingItems[i].shoppingItemTaxes|getAmount:$shoppingItems[i].currencyID}</strong></div>
					</td>
				{/if}
				<td valign="top" align="right">
					{assign var="orderTotal" value=$orderTotal+$shoppingItems[i].shoppingItemTaxes+$shoppingItems[i].shoppingItemPrice+$shoppingItems[i].shoppingItemSetupPrice-$shoppingItems[i].couponTotal}
					<strong>{$shoppingItems[i].shoppingItemPrice+$shoppingItems[i].shoppingItemTaxes+$shoppingItems[i].shoppingItemSetupPrice-$shoppingItems[i].couponTotal|getAmount:$shoppingItems[i].currencyID}</strong>
				</td>

			</tr>
            {if $thisdomains.0.shoppingItemsDomainsRelID || $shoppingItems[i].shoppingItemSLD!="" || $shoppingItems[i].children.0.shoppingItemID>0}
			<tr class="{if $smarty.section.i.index%2==0}alt1{else}alt2{/if}">
				<td colspan="{if $show_vat == true}5{else}4{/if}" style="border-bottom: 1px solid #999;">
					<table border="0" cellspacing="0" width="95%" class="tab04">
            {/if}
					{if $thisdomains.0.shoppingItemsDomainsRelID && "products"|getTypeID:"domain" != $products.$productID.productType}
						{foreach item="currentDomain" key="dk" from=$thisdomains}
							<tr id="domainrow{$currentDomain.shoppingItemsDomainsRelID}">
								<td>
									{"TRANS_DOMAIN"|lmsg} <strong>{$currentDomain.domainSLD}.{$currentDomain.domainTLD}</strong>
									{if $currentDomain.shoppingItemsDomainsRelID==$shoppingItems[i].shoppingItemPrimaryDomainID}
										<small>({"TRANS_PRIMARY"|lmsg})</small>
									{/if}
								</td>
							</tr>
						{/foreach}
					{/if}
					{if $shoppingItems[i].shoppingItemSLD!=""}
						<tr><td colspan="2"> {"TRANS_DOMAIN"|lmsg} <strong>{$shoppingItems[i].shoppingItemSLD}.{$shoppingItems[i].shoppingItemTLD}</strong></td></tr>
					{/if}


            {if $thisdomains.0.shoppingItemsDomainsRelID || $shoppingItems[i].shoppingItemSLD!="" || $shoppingItems[i].children.0.shoppingItemID>0}
					</table>
				</td>
			</tr>
            {/if}
		{if $shoppingItems[i].children.0.shoppingItemID>0}
			{section name="j" loop=$shoppingItems[i].children}
								{assign var="addon" value=$shoppingItems[i].children[j]}
								{assign var="addonID" value=$addon.productID}
				<tr >
					<td valign="top" align="left" style="padding-left:30px;">{$products.$addonID.productName|constant}</td>
					<td valign="top" align="left">&nbsp;</td>
					<td valign="top" align="right">
						<div align="right"><strong>
									{if $addon.originalPrice}
										<strike>{$addon.originalPrice|getAmount:$currencyID}</strike>
										{$addon.shoppingItemPrice|getAmount:$currencyID}
									{else}
										{$addon.shoppingItemPrice|getAmount:$currencyID}
									{/if}
									</strong></div>
									{if $addon.shoppingItemSetupPrice>0}
										<div align="right"><strong>{"TRANS_PLUS_SETUP"|lmsg} {$addon.shoppingItemSetupPrice|getAmount:$currencyID}</strong></div>
									{/if}
									{if $addon.appliedCoupons.0.couponID>0}
										{section name="c" loop=$addon.appliedCoupons}
											{if $addon.appliedCoupons[c].shoppingCouponType}
												{assign var="mcp" value=$addon.appliedCoupons[c].discount}
												<div align="right" style="white-space: nowrap;">{"TRANS_DISCOUNT"|lmsg} <strong>-{$mcp|getAmount:$currencyID}</strong></div>
											{else}
												{assign var="mcp" value=$addon.appliedCoupons[c].discount}
												<div align="right" style="white-space: nowrap;">{"TRANS_COUPON"|lmsg} <strong>-{$mcp|getAmount:$currencyID}</strong><br /><em>({$addon.appliedCoupons[c].couponCode})</em></div>
											{/if}
										{/section}
									{/if}
					</td>
					{if $show_vat == true}
						<td valign="top" align="right">
							<div align="right" style="white-space: nowrap;"><strong>{$addon.shoppingItemTaxes|getAmount:$currencyID}</strong></div>
						</td>
					{/if}
					<td valign="top" align="right">
					{assign var="orderTotal" value=$orderTotal+$addon.shoppingItemTaxes+$addon.shoppingItemPrice+$addon.shoppingItemSetupPrice-$addon.couponTotal}
					<strong>{$addon.shoppingItemPrice+$addon.shoppingItemTaxes+$addon.shoppingItemSetupPrice-$addon.couponTotal|getAmount:$currencyID}</strong>
					</td>
				</tr>
				{/section}
			{/if}

		{/section}
			<tr class="alt1">
				<th colspan="{if $show_vat == true}5{else}4{/if}" style="text-align: right; font-weight: normal;">
					{"TRANS_SUB_TOTAL"|lmsg} <strong>{$orderSubtotal|getAmount:$currencyID}</strong><br />
					{if $show_vat == true}
						{"TRANS_VAT"|lmsg} <strong>{$orderTax|getAmount:$currencyID}</strong><br />
					{/if}
					{"TRANS_ORDER_TOTAL"|lmsg} <strong>{$orderTotal|getAmount:$currencyID}</strong><br />
					{"TRANS_TAX_WILL_BE_CALCULATED_NEXT"|lmsg}
			</tr>
{*
			<tr class="alt1">
				<td colspan="{if $show_vat == true}5{else}4{/if}">

					<div align="left">
					<table border="0" width="95%" class="tab01">

						{if $coupons.0.couponID>0}
							<tr>
								<th>{"TRANS_COUPON_CODE"|lmsg}</th>
								<th>{"TRANS_DISCOUNT"|lmsg}</th>
								<th>{"TRANS_COUPON_SAVINGS"|lmsg}</th>
							</tr>
						{/if}

						{section name="i" loop=$coupons}
							<tr class="{cycle values="alt1,alt2"}">
								<td>{$coupons[i].couponCode}</td>
								<td><strong>{if $coupons[i].couponType==0}
										{$coupons[i].couponDiscount}%
									{else}
										{$coupons[i].couponDiscount|getAmount:$currencyID}
									{/if}</strong>
									</td>
								<td align="right"><strong>{$coupons[i].discountTotal|getAmount:$currencyID}</strong></td>
							</tr>
						{/section}
					</table>
					</div>

				</td>
			</tr> *}

		</table></div></div>
		</td>
	</tr>
{else}
			<tr><td><div class="alt2"><strong>{"TRANS_NO_ITEMS_IN_CART"|lmsg}</strong></div></td></tr>
{/if}
</table>
</div></div></div>

{if !$suppressLoginHeader}

<div id="loginHTML" class="off">
	<form method="post" action="cart.php">
	<input type="hidden" name="sid" value="{$sid}" />
	<input type="hidden" name="action" value="{getActionID action="ProcessCartLoginResponse"}" />
	<input type="hidden" name="gotoCheckout" value="1" />
	<table width="95%" class="tab01">
		<tbody>
		<tr>
			<th>{"TRANS_USERNAME"|lmsg} </th>
			<td><input type="text" name="contactUsername" size="10" /></td>
		</tr>
		<tr>
			<th>{"TRANS_PASSWORD"|lmsg}</th>
			<td><input type="password" name="contactPassword" size="10" />
			<a href="javascript:;" onclick="initiateForgotPassword();">{"TRANS_FORGOT_PASSWORD"|lmsg}</a>
			</td>
		</tr>
		<tr>
			<td></td>
			<td><input class="submit" type="submit" value="{"TRANS_LOGIN"|lmsg}" /> <input class="button" type="button" value="{"TRANS_CANCEL"|lmsg}" onclick="cancelLogin();" /></td>
		</tr>
		</tbody>
	</table>
	</form>
</div>

<div id="forgotPasswordHTML" class="off">
	<form method="post" action="cart.php">
	<input type="hidden" name="sid" value="{$sid}" />
	<input type="hidden" name="action" value="{getActionID action="ProcessCartForgotPasswordResponse"}" />
	<input type="hidden" name="gotoCheckout" value="1" />
	<table width="95%" class="tab01">
		<tbody>
		<tr>
			<th>{"TRANS_EMAIL_ADDRESS"|lmsg} </th>
			<td><input type="text" name="contactEmail" size="25" /><br />
			{"TRANS_WE_WILL_CREATE_A_TEMP_PASSWORD_AND_RESEND"|lmsg}</td>
		</tr>
		<tr>
			<td></td>
			<td><input class="submit" type="submit" value="{"TRANS_SUBMIT"|lmsg}" /> <input class="button" type="button" value="{"TRANS_CANCEL"|lmsg}" onclick="cancelForgotPassword();" /></td>
		</tr>
		</tbody>
	</table>
	</form>
</div>


{/if}
