{php}

define('SIZE_GB', 1073741824);
define('SIZE_MB', 1048576);
define('SIZE_INPUT_UNIT', 'iu');
define('SIZE_OTHER', 1);

function getDetailedAttributes($productInfo)
{
	$map_size_name = array(
		SIZE_GB => 'GB',
		SIZE_MB => 'MB',
		SIZE_INPUT_UNIT => '',
		SIZE_OTHER => ''
	);
	$attrs = $productInfo['keyedAttributes'];
	$result = array(
		'TRANS_PLESK_ATTR_GROUP__DISK_SPACE_TRAFFIC' => array(
			array(
				'name' => ("" != $attrs['clientDiskSpace'] ? 'clientDiskSpace' : 'domainDiskSpace'),
				'unit_size' => SIZE_INPUT_UNIT,
				'unit_name' => '',
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___DISK_SPACE'
			),
			array(
				'name' => ("" != $attrs['clientMaxTraffic'] ? 'clientMaxTraffic' : 'domainMaxTraffic'),
				'unit_size' => SIZE_INPUT_UNIT,
				'unit_name' => '',
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___TRAFFIC'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__DOMAINS' => array(
			array(
				'name' => ("" != $attrs['clientMaxDomains'] ? 'clientMaxDomains' : 'domainMaxSites'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___DOMAINS'
			),
			array(
				'name' => ("" != $attrs['clientMaxSubdomains'] ? 'clientMaxSubdomains' : 'domainMaxSubdomains'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___SUBDOMAINS'
			),
			array(
				'name' => ("" != $attrs['clientMaxDomainAliases'] ? 'clientMaxDomainAliases' : 'domainMaxDomainAliases'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___DOMAINALIASES'
			),
			array(
				'name' => ("" != $attrs['clientMaxWebusers'] ? 'clientMaxWebusers' : 'domainMaxWebusers'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___WEBUSERS'
			),
			array(
				'name' => ("" != $attrs['clientMaxFTPAccounts'] ? 'clientMaxFTPAccounts' : 'domainMaxSubFTPUsers'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___FTPACCOUNTS'
			),
			array(
				'name' => ("" != $attrs['clientMaxFPAccounts'] ? 'clientMaxFPAccounts' : 'domainMaxFPSEUsers'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___FPACCOUNTS'
			),
			array(
				'name' => 'max_site_builder',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___SITEBUILDERSITES'
			),
			array(
				'name' => 'max_unity_mobile_sites',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___UNITYMOBILESITES'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__MAIL' => array(
			array(
				'name' => ("" != $attrs['clientMaxMailbox'] ? 'clientMaxMailbox' : 'domainMaxMailbox'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILBOXES'
			),
			array(
				'name' => ("" != $attrs['clientMailBoxQuota'] ? 'clientMailBoxQuota' : 'domainMailboxQuota'),
				'unit_size' => SIZE_INPUT_UNIT,
				'unit_name' => $map_size_name[SIZE_MB],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILBOXQUOTA'
			),
			array(
				'name' => ("" != $attrs['clientTotalMailBoxQuota'] ? 'clientTotalMailBoxQuota' : 'domainTotalMailboxQuota'),
				'unit_size' => SIZE_INPUT_UNIT,
				'unit_name' => $map_size_name[SIZE_MB],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___TOTAL_MAILBOXQUOTA'
			),
			array(
				'name' => ("" != $attrs['clientMaxMaillists'] ? 'clientMaxMaillists' : 'domainMaxMaillists'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILLISTS'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__DATABASES' => array(
			array(
				'name' => ("" != $attrs['clientMaxMSSQLDB'] ? 'clientMaxMSSQLDB' : 'domainMaxMSSQLDB'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MSSQLDB'
			),
			array(
				'name' => ("" != $attrs['clientMaxMYSQLDB'] ? 'clientMaxMYSQLDB' : 'domainMaxMYSQLDB'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MYSQLDB'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__SECURITY' => array(
			array(
				'name' => ("" != $attrs['clientMaxSharedSSLLinks'] ? 'clientMaxSharedSSLLinks' : 'domainMaxSharedSSLLinks'),
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___SHAREDSSLLINKS'
			),
		)
	);
	foreach (array_keys($result) as $group_id) {
		foreach (array_keys($result[$group_id]) as $attr_id) {
			$result[$group_id][$attr_id]['data'] = $productInfo['keyedAttributes'][$result[$group_id][$attr_id]['name']];
		}
	}
	return $result;
}

{/php}
