<?php

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/order/include/order/order.php");

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class AddCartDomain extends MB_Action {
	/**
	 * The main method of this class that executes the AddCartDomain action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		dbg("inside add cart domain");

		$this->smartyVars = array();

		if ($_REQUEST["wwid"]){

			$url_str = ("http" == $CONF["secureURLProtocol"]) ? $CONF["standardURL"] : $CONF["secureURL"];

			$this->smartyVars["cartURL"] = $CONF["secureURLProtocol"]."://".$url_str.mb_path_convert_path("/order")."/cart.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["whoisURL"] = $CONF["secureURLProtocol"]."://".$url_str.mb_path_convert_path("/order")."/remotewhois.php?sid=".$_REQUEST["sid"];

			$url = parse_url($this->smartyVars["whoisURL"]);
			$this->smartyVars["baseURL"] = $CONF["secureURLProtocol"]."://".$url["host"];

			$wwXML = "	<mbapi>
					<command>GetWebsiteWidgets</command>
					<params>
						<websiteWidgetID>".((int)$_REQUEST["wwid"])."</websiteWidgetID>
						<getProductInformation>1</getProductInformation>
						<getOrderFormData>1</getOrderFormData>
					</params>
					</mbapi>";
			$wwInfo = dispatchMBAPI($wwXML, 1);
			dbg("website widget info we got back:");
			dbg($wwInfo);

			dbg("at the top of website widget show action. 4");

			$wwInfo = grabSimpleMBAPIResults($wwInfo);
			$wwInfo = $wwInfo[0];
			$orderFormID = $this->smartyVars["orderFormID"] = $wwInfo["orderFormID"];
		}


		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $orderFormID);

		$orderObjectParams = array(
			"ofid" => ($orderFormID)?$orderFormID:$shoppingSessionData["orderFormID"],
			"sid" => $shoppingSessionData["shoppingSessionID"],
			"set_locale" => $_REQUEST["set_locale"],
		);
		$order = new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["IDN"] = $this->createJSArray($this->smartyVars["domainInfo"]["idn"]);

		$getItemsXML = "	<mbapi>
								<command>GetShoppingItems</command>
								<params>
									<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
									<getDomainsRelData>1</getDomainsRelData>
								</params>
							</mbapi>";
		$items = correctArray(grabResultsFromMBAPIArray($getItemsXML));
		dbg("items:");
		dbg($items);
		
		$usedDomains = array();
		foreach ($items as $row){
			if ($row["shoppingItemID"]==$_REQUEST["shoppingItemID"]){
				foreach ((array)$row["domains"] as $d){
					$usedDomains[$d["domainShoppingItemID"]] = 1;
				}
			}
		}
		$availableDomains = array();
		foreach ($items as $row){
			if ($row["shoppingItemTLD"]!="" && !$usedDomains[$row["shoppingItemID"]]){
				$availableDomains[] = array('id'=>$row["shoppingItemID"], 'sld'=>$row["shoppingItemSLD"], 'tld'=>$row["shoppingItemTLD"]);
			}
		}

		$this->smartyVars["availableDomains"] = $availableDomains;
		$this->smartyVars["shoppingItemID"] = (int)$_REQUEST["shoppingItemID"];
		if (!(int)$_REQUEST["shoppingItemID"]){
			$this->smartyVars["suppressAvailable"] = 1;
		}

		if ((int)$_REQUEST["whoisWidget"]){
			$this->smartyVars["widgetCall"] = (int)$_REQUEST["whoisWidget"];
		}

		dbg("Smarty Vars:");
		dbg($this->smartyVars);

		$this->addTemplate("shopping/AddDomainCart", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
