<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");
require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-billing/include/config/internal/cycles.php");
require_once("object_managers/TaxZoneManager.php");

class AddCartStepAction extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if ( is_null($orderFormID = bgpc("storeID")) ) {
			// save capability with old order widget templates
			$orderFormID = bgpc("orderFormID");
		}

		$this->smartyVars = array();
		$this->shoppingSessionData = $this->updateShoppingSession(bgpc("sid"), $orderFormID);

		if ( !is_null($widgetTemplate = bgpc("widgetTemplate")) ) {
			$shopping_session = Factory()->ShoppingSession($this->shoppingSessionData["shoppingSessionID"]);
			$shopping_session->widget_template = $widgetTemplate;
			$shopping_session->website_widget_id = bgpc("wwid");
			require_once("object_managers/ShoppingSessionManager.php");
			ShoppingSessionManager::update($shopping_session);
		}

		$this->smartyVars["shoppingSession"] = $this->shoppingSessionData;
		$this->mergeCycleData();

		$this->smartyVars["cartURL"] = "cart.php?sid=".$_REQUEST["sid"];
		$this->smartyVars["remoteURL"] = "remote.php?sid=".$_REQUEST["sid"];
		$this->smartyVars["whoisURL"] = "remotewhois.php?multiDomain=1&sid=".$_REQUEST["sid"];

		global $CONF;
		if ($CONF["secureURLProtocol"]=="http"){
			$this->smartyVars["fullCartURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/order")."/cart.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullTransferURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/order")."/remote.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullWhoisURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/order")."/remotewhois.php?multiDomain=1&sid=".$_REQUEST["sid"];
		} else {
			$this->smartyVars["fullCartURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/order")."/cart.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullTransferURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/order")."/remote.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullWhoisURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/order")."/remotewhois.php?multiDomain=1&sid=".$_REQUEST["sid"];
		}

		$url = parse_url($this->smartyVars["whoisURL"]);
		$this->smartyVars["baseURL"] = $CONF["secureURLProtocol"]."://".$url["host"];


		switch ($this->stringRep){
			case "ShowMultiDomainWhoisStep":
				if ($_REQUEST["source"]=="addons"){
					$this->smartyVars["nextActionName"] = "AddCartProductResponse";
				} else {
					$this->smartyVars["nextActionName"] = "ShowCartProductAddonsStep";
				}
			break;
			case "ShowCartProductAddonsStep":
				if ($_REQUEST["source"]=="domains"){
					$this->smartyVars["nextActionName"] = "AddCartProductResponse";
				} else {
					$this->smartyVars["nextActionName"] = "ShowMultiDomainWhoisStep";
				}
			break;
		}

	}

	protected function mergeMultiDomainData($orderFormID, $domainSLD, $domainTLD)
	{
		global $CONF;
		$orderFormData = ($this->smartyVars["orderFormInfo"]["orderFormID"]==$orderFormID) ? $this->smartyVars["orderFormInfo"] : oneByID(":orderForms", $orderFormID);
		$this->smartyVars["currencyID"] = $currencyID = $orderFormData["currencyID"];

		$order_form = Factory()->OrderForm($orderFormID);
		$tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);
		if ($domainSLD){
			$this->smartyVars["domainSLD"] = str_replace(array("http://", "https://", "www."), "", strtolower($domainSLD));
			if (strpos($this->smartyVars["domainSLD"], ".")!==false){
				$this->smartyVars["domainSLD"] = substr($this->smartyVars["domainSLD"], 0, strpos($this->smartyVars["domainSLD"], "."));
			}
			$this->smartyVars["selectedTLD"] = $domainTLD;
		}

		$domainProducts = arrayFor("products", array(
			"getProductVariantData" => 1,
			"productType" => getAPITypeID("products", "domain"),
			"productActive" => 1,
		));
		$keyedProducts = array();
		foreach ((array)$domainProducts as $product){
			$keyedProducts[$product["productID"]] = $product;
		}
		$productIDs = array_keys($keyedProducts);

		dbg($keyedProducts);

		$orderFormItems = arrayFor(":orderFormItems", array(
			"orderFormID" => $orderFormID,
			"productID" => $productIDs,
		));

		dbg($orderFormItems);

		if (!count($orderFormItems)){
			$this->smartyVars["noDomainProductFound"] = 1;
		} else {
			$this->mergeCycleDiscountGroups();
			$this->smartyVars["productID"] = $domainProductID = $orderFormItems[0]["productID"];
			$domainProduct =& $keyedProducts[$domainProductID];

			if (!$domainProduct){
				$this->smartyVars["noDomainProductFound"] = 1;
			} else {
				$tldIDs = array();

				$variants = $domainProduct["productVariants"];
				$tldPrices = array();
				$tldHasTransferPrice = array();
				$variants2tlds = array();
				$cycleDiscountGroupIDs = array();
				foreach ((array)$variants as $v){
					if ($v["productVariantActive"]){
						if (0 < $v['cycleDiscountGroupID'])
							$cycleDiscountGroupIDs[$v['productVariantID']] = $v['cycleDiscountGroupID'];
						$tldIDs[] = $v["tldID"];
						$variants2tlds[$v["productVariantID"]] = $v["tldID"];
					}
				}

				$tlds2variants = array_flip($variants2tlds);

				$domainProductPrices = oneByID("products", $domainProduct["productID"], array(
					"getProductVariantPriceData" => 1,
				));

				$variantPrices = $domainProductPrices["productVariantPrices"];
				foreach ((array)$variantPrices as $price){
					if ($price["currencyID"]==$currencyID && $price["productVariantPriceAmount"]>0) {
						if ($price["productVariantPriceType"]==getAPITypeID("price", "transfer")){
							$tldHasTransferPrice[$variants2tlds[$price["productVariantID"]]] = true;
						}

						if (0 == $price['productVariantPriceType'] && isset($cycleDiscountGroupIDs[$price['productVariantID']])) {
							$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupIDs[$price['productVariantID']]]['discounts'][$price['cycleID']];
							if (0 < $discount) {
								$price['discountAmount'] = round($price['productVariantPriceAmount'] * $discount / 100, 2);
								$price['discountPrice'] = TaxZoneManager::getProductGrossPrice(round($price['productVariantPriceAmount'] - $price['discountAmount']), array($tax_zone));
							}
						}
						$price["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($price["productVariantPriceAmount"], array($tax_zone));
						$tldPrices[$variants2tlds[$price["productVariantID"]]][$price["cycleID"]][$price["productVariantPriceType"]] = $CONF["user"]["locale"]->getLocaleCurrency($price["productVariantPriceAmount"], $currencyID);
					}
				}

				$tlds = arrayFor(":TLDs", array(
					"sortColumn" => "tldDisplayOrder",
					"sortDir" => "ASC",
					"tldActive" => 1,
					"tldID" => $tldIDs,
				));
				$this->smartyVars["cycleInfo"] = getCyclesArray();
				$this->smartyVars["cycleValues"] = array();
				foreach ($this->smartyVars["cycleInfo"] as $cycleID=>$cycleName){
					$this->smartyVars["cycleValues"][$cycleID] = getNextBillingTimestamp(0, $cycleID);
				}
				$this->smartyVars["tlds"] = array();
				foreach ($tlds as $tld){
					$tld["productID"] = $domainProductID;
					$tld["productVariantID"] = $tlds2variants[$tld["tldID"]];
					$tld["prices"] = $tldPrices[$tld["tldID"]];
					$tld["hasTransferPrice"] = $tldHasTransferPrice[$tld["tldID"]];
					$this->smartyVars["tlds"][$tld["tldExtension"]] = $tld;
				}
			}

		}
		$this->smartyVars["showDomainBox"] = 1;
	}

	protected function mergeProductData($productID, $productVariantID, $orderFormID, $cycleID=false, $allowRedirect=true)
	{
		$this->smartyVars["orderFormInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetOrderForms",
				"params" => array(
					"orderFormID" => $orderFormID,
					"getCouponData" => 1,
				),
			),
		)));
		$order_form = Factory()->OrderForm($orderFormID);
		$tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);
		if (!is_null($tax_zone)) {
			require_once("BillingLocale.php");
			$this->smartyVars["price_include_tax"] = blmsg("TRANS_INCLUDE_VAT_TO_PRODUCT_PRICES", array("number" => BillingLocale::getPercentNumber(floatval($tax_zone->tax_zone_amount))));
		}

		$this->smartyVars["orderFormID"] = $orderFormID;
		$this->smartyVars["currencyID"] = $this->smartyVars["orderFormInfo"]["currencyID"];

		$this->allowedCoupons = array();

		foreach ((array)$this->smartyVars["orderFormInfo"]["coupons"] as $coupon){
			$this->allowedCoupons[$coupon["productID"]][$coupon["couponID"]] = $coupon;
		}

		dbg("getting ready to get product $productID.");

		$productInfo = oneByID("products", $productID, array(
			"productActive" => 1,
			// "getProductAttributeData" => 1,
			"getCouponData" => 1,
			"getPreCouponData" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getCycleData" => 1,
			"getCycleGhostIDs" => 1,
		));

		dbg("redirecting?");
		if ($allowRedirect){
			dbg("possibly...");
			switch ($this->stringRep){
				case "ShowMultiDomainWhoisStep":
					if ($productInfo["productDomainRequired"]==getAPIStatusID("productdependencyrules", "cannot")){
						dbg("on the whois set and product domain required is: ".$productInfo["productDomainRequired"]);
						if ($_REQUEST["source"]=="addons"){
							$url = $this->smartyVars["cartURL"]."&action=".getActionID("AddCartProductResponse")."&".makeRequestQueryString();
							dbg("sending to cart url:");
							dbg($url);
							header("Location: $url");
							exit;
						} else {
							unset($_REQUEST["source"]);
							$url = $this->smartyVars["cartURL"]."&source=domains&action=".getActionID("ShowCartProductAddonsStep")."&".makeRequestQueryString();
							dbg("sending to domain url:");
							dbg($url);
							header("Location: $url");
							exit;
						}
					}
				break;
				case "ShowCartProductAddonsStep":
					if ($productInfo["productAddonRequired"]==getAPIStatusID("productdependencyrules", "cannot")){

						$product = Factory()->Product($productID);

						if (Product::TYPE_SSL_CERT == $product->product_type) {
							$url = $this->smartyVars["cartURL"]."&action=".getActionID("ShowSSLCertificatePurchase")."&".makeRequestQueryString();
						} else if ($_REQUEST["source"]=="domains"){
							$url = $this->smartyVars["cartURL"]."&action=".getActionID("AddCartProductResponse")."&".makeRequestQueryString();
						} else {
							unset($_REQUEST["source"]);
							$url = $this->smartyVars["cartURL"]."&source=addons&action=".getActionID("ShowMultiDomainWhoisStep")."&".makeRequestQueryString();
						}
						redirect($url);
					}
				break;
			}
		}

		$this->mergeCycleDiscountGroups();

		if ($productInfo["preappliedCoupons"] && $productInfo["preappliedCoupons"][0] && $productInfo["preappliedCoupons"][0]["couponID"]){
			$preappliedCouponID = $productInfo["preappliedCoupons"][0]["couponID"];
			if ($this->allowedCoupons[$productInfo["productID"]][$preappliedCouponID]){
				$preappliedCoupon = $this->allowedCoupons[$productInfo["productID"]][$preappliedCouponID];
			} else {
				$preappliedCoupon = 0;
			}
		} else {
			$preappliedCoupon = 0;
		}

		foreach ((array)$productInfo["productVariants"] as $k=>$v){
			$keyedVariants[$v["productVariantID"]] =& $productInfo["productVariants"][$k];
		}

		$validCycles = array();
		if (!(int)$_REQUEST["cycleID"]){
			foreach ((array)$productInfo["ghostCycles"] as $cycle){
				$validCycles[] = $cycle["cycleID"];
			}
		} else {
			$validCycles[] = (int)$_REQUEST["cycleID"];
		}

		$prices = array();
		if (isset($productInfo["productVariantPrices"])){
			foreach ($productInfo["productVariantPrices"] as $price){
				if (in_array($price["cycleID"], $validCycles) && $price["productVariantID"]==$productVariantID){
					$prices[$price["currencyID"]][$price["cycleID"]][$price["productVariantPriceType"]] = $price;
				}
			}
		} else {
			dbg("didnt find prices");
		}

		// for each of the prices we have we need to apply coupons, then apply
		// cycle discount amounts from there.
		foreach ($prices as $currency => $rows){
			$productPrice = array_values($rows);
			foreach ((array)$productPrice as $k=>$tempprice){
				if ($preappliedCoupon){
					$productPrice[$k][0]["discountAmount"] = $this->getCouponAmount($productPrice[$k][0], $preappliedCoupon);
					$productPrice[$k][0]["discountPrice"] = $productPrice[$k][0]["productVariantPriceAmount"]-$productPrice[$k][0]["discountAmount"];
				}
				$cycleDiscountGroupID = $keyedVariants[$tempprice[0]['productVariantID']]['cycleDiscountGroupID'];
				if (isset($this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']])) {
					$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']];
					// if there was a coupon applied already, use the post-coupon
					// amount to calculate the cycle base discount amount
					if (isset($productPrice[$k][0]["discountPrice"])) {
						$discountableAmount = $productPrice[$k][0]["discountPrice"];
					} else {
						$discountableAmount = $productPrice[$k][0]['productVariantPriceAmount'];
					}
					$productPrice[$k][0]["discountAmount"] += round($discountableAmount * ($discount / 100), 2);
				}
				$productPrice[$k][0]["discountPrice"] = TaxZoneManager::getProductGrossPrice($productPrice[$k][0]["productVariantPriceAmount"]-$productPrice[$k][0]["discountAmount"], array($tax_zone));
				$productPrice[$k][0]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($tempprice[0]["productVariantPriceAmount"], array($tax_zone));
				$productPrice[$k][1]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($tempprice[1]["productVariantPriceAmount"], array($tax_zone));
			}
			$productInfo["prices"][$currency] = $productPrice;
		}
		$productInfo["productComments"] = utf8_html_entity_decode($productInfo["productComments"]);
		unset($productInfo["productVariantPrices"]);

		$productInfo["productVariantID"] = $productVariantID;
		$productInfo["cycleID"] = $cycleID;

		$this->smartyVars["product"] = $productInfo;

	}

	protected function mergeProductAddonsData($productID, $cycleID, $productVariantID)
	{
		$this->smartyVars["productID"] = $productID;
		$this->smartyVars["cycleID"] = $cycleID;
		$this->smartyVars["productVariantID"] = $productVariantID;


		$tempProductsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI(array(
			'mbapi' => array(
				'command' => 'GetProducts',
				'params' => array(
					'parentProductID' => $this->smartyVars["productID"],
					'cycleID' => $this->smartyVars["cycleID"],
					'orderFormID' => $this->smartyVars["orderFormID"],
					'productActive' => 1,
					'getCouponData' => 1,
					'getPreCouponData' => 1,
					'getProductVariantData' => 1,
					'getProductVariantPriceData' => 1,
					'getCycleData' => 1,
				),
			),
		), 1)));

		$productsInfo = array();
		require_once("object_managers/ProductManager.php");
		foreach ($tempProductsInfo as $key => $product) {
			$currentProduct = Factory()->Product($product["productID"]);
			if (ProductManager::isValidStoreHostingProduct($currentProduct)) {
				$productsInfo[] = $product;
			}
		}

		$order_form = Factory()->OrderForm($this->smartyVars["orderFormID"]);
		$tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);

		foreach ($productsInfo as $addon){
			$groups[$addon["productAddonGroupID"]] = 1;
		}
		$groups = array_keys((array)$groups);
		$groups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"getGroupsByProductID" => $this->smartyVars["productID"]
				)
			)
		)));

		$this->smartyVars["addonGroups"] = array();
		foreach ((array)$groups as $group){
			if (1 == $group["productAddonGroupActive"]) {
				$this->smartyVars["addonGroups"][$group["productAddonGroupID"]] = $group;
			}
		}

		dbg("prods:");
		dbg($productsInfo);

		foreach ((array)$productsInfo as $k=>$product){
			if (!isset($this->smartyVars["addonGroups"][$product["productAddonGroupID"]]) && (int)$product["productAddonGroupID"]){
				unset($productsInfo[$k]);
			}
		}

		if (!is_array($productsInfo)){
		 	$productsInfo = array();
		}

		$mainProducts = array();
		$keyedVariants = array();

		foreach ($productsInfo as $k=>$v){

			if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
				$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
				if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
					$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
				} else {
					$preappliedCoupon = 0;
				}
			} else {
				$preappliedCoupon = 0;
			}

			foreach ($productsInfo[$k]["productVariants"] as $kv => $vv) {
				$keyedVariants[$vv['productVariantID']] =& $productsInfo[$k]["productVariants"][$kv];
			}

			$prices = array();
			if (isset($productsInfo[$k]["productVariantPrices"])){
				if ($v["productIsAddon"]){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("cycle id: ".$price["cycleID"]);
						dbg("match to cycle: ".$this->smartyVars["cycleID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"] && $price["cycleID"]==$this->smartyVars["cycleID"]){
							$prices[$price["productVariantPriceType"]] = $price;
						}
					}
					if ($preappliedCoupon){
						$prices[0]["discountAmount"] = $this->getCouponAmount($prices[0], $preappliedCoupon);
						$prices[0]["discountPrice"] = $prices[0]["productVariantPriceAmount"]-$prices[0]["discountAmount"];
					}
					$cycleDiscountGroupID = $keyedVariants[$prices[0]['productVariantID']]['cycleDiscountGroupID'];
					if (isset($this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$prices[0]['cycleID']])) {
						$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$prices[0]['cycleID']];
						if (isset($prices[0]["discountPrice"])) {
							$discountableAmount = $prices[0]["discountPrice"];
						} else {
							$discountableAmount = $prices[0]['productVariantPriceAmount'];
						}
						$prices[0]["discountAmount"] += round($discountableAmount * ($discount / 100), 2);
					}
					if (0 < $prices[0]["discountAmount"]) {
						$prices[0]["discountPrice"] = TaxZoneManager::getProductGrossPrice($prices[0]["productVariantPriceAmount"]-$prices[0]["discountAmount"], array($tax_zone));
					}
					$prices[0]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($prices[0]["productVariantPriceAmount"], array($tax_zone));
					$prices[1]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($prices[1]["productVariantPriceAmount"], array($tax_zone));
				} else {
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"]){
							$prices[$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
					foreach ($prices as $cycleID => $tempprice) {
						if ($preappliedCoupon){
							$prices[$cycleID][0]["discountAmount"] = $this->getCouponAmount($prices[$cycleID][0], $preappliedCoupon);
						}
						$cycleDiscountGroupID = $keyedVariants[$tempprice[0]['productVariantID']]['cycleDiscountGroupID'];
						if (isset($this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']])) {
							$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']];
							$prices[$cycleID][0]["discountAmount"] += round($tempprice[0]['productVariantPriceAmount'] * ($discount / 100), 2);
						}
						if (0 < $prices[$cycleID][0]["discountAmount"]) {
							$prices[$cycleID][0]["discountPrice"] = TaxZoneManager::getProductGrossPrice($prices[$cycleID][0]["productVariantPriceAmount"]-$prices[$cycleID][0]["discountAmount"], array($tax_zone));
						}
						$prices[$cycleID][0]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($tempprice[0]["productVariantPriceAmount"], array($tax_zone));
						$prices[$cycleID][1]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($tempprice[1]["productVariantPriceAmount"], array($tax_zone));
					}
				}
			} else {
				dbg("variant price not set");
			}
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
				foreach ($productsInfo[$k]["prices"] as $currency => $row){
				//	$productInfo["prices"][$currency] = $productPrice;
				}
			} else {
				unset($productsInfo[$k]);
			}

		}

		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
		}

		$this->smartyVars["addonproducts"] = $keyedAddons;
		$this->mergeCycleData();
	}

	protected function addCartProduct($productData)
	{
		if (!$productData["productID"] &&
			$productData["addType"]!="associateDomain" &&
			$productData["addType"]!="addons" &&
			!$productData["existsld"]){
			dbg("aparently this isn't a valid product:");
			dbg($productData);
			return;
		}

		if ($productData["parentID"] && !$productData["parentShoppingItemID"]){
			$productData["parentShoppingItemID"] = $this->idMap[$productData["parentID"]];
		}

		dbg("ADDING PRODUCT");
		dbg($productData);
		dbg($this->idMap);

		if ($productData["addType"]=="domain"){

			if ($productData["existsld"]){ // existing
				$type = getAPITypeID("shoppingdomains", "manual");

				$productData["existsld"] = eregi_replace("^www\.|http://|https://", "", trim($productData["existsld"]));

				if ($productData["existtld"]=="" && strpos($productData["existsld"], ".")){
					$pp = explode(".", $productData["existsld"]);
					$productData["existtld"] = $pp[count($pp)-1];
					unset($pp[count($pp)-1]);
					$productData["existsld"] = implode(".", $pp);
				}

				if ($productData["existsld"][strlen($productData["existsld"])-1]=="."){
					$productData["existsld"] = substr($productData["existsld"], 0, -1);
				}

				$setRelXML = "
					<mbapi>
						<command>SetShoppingItemsDomain</command>
						<subCommand>insert</subCommand>
						<params>
							<shoppingItemID>".(int)$productData["parentShoppingItemID"]."</shoppingItemID>
							<shoppingItemsDomainsType>".$type."</shoppingItemsDomainsType>
							<domainSLD>".secureInput($productData["existsld"])."</domainSLD>
							<domainTLD>".secureInput($productData["existtld"])."</domainTLD>
						</params>
					</mbapi>";
				dbg($results = dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...

				if ($results["mbapi"][0]["header"][0]["lastInsertID"]){
					$domainRelID = $results["mbapi"][0]["header"][0]["lastInsertID"][0];
				}

			} else {

				$variantXML = "
						<mbapi>
							<command>GetProductVariants</command>
							<params>
								<productVariantID>".(int)$productData["productVariantID"]."</productVariantID>
								<getProductVariantPriceData>1</getProductVariantPriceData>
								<getTLDData>1</getTLDData>
							</params>
						</mbapi>";
				$variantInfo = dispatchMBAPI($variantXML, 1);
				if (isset($variantInfo["mbapi"][0]["results"][0]["productVariants"][0]["productVariant"][0])){
					$variantInfo = correctArray($variantInfo["mbapi"][0]["results"][0]["productVariants"][0]["productVariant"][0]);

					if ($productData["cycleID"]=="-2"){
						$type = 1;
						$priceType = 2;
						dbg($productData["cycleID"] = $variantInfo["tldTransferMinimumCycleID"]);
					} else {
						dbg("not a transfer");
						$priceType = 0;
						$type = 0;
					}


					$priceInfo = array();
					foreach ($variantInfo["productVariantPrices"] as $price){
						if ($price["currencyID"]==$this->currencyID && $price["cycleID"]==(int)$productData["cycleID"]){
							$priceInfo[$price["productVariantPriceType"]] = $price;
						} else {
							dbg("currency: ".$price["currencyID"]."=".$this->currencyID." -- cycle: ".$price["cycleID"]."=".$productData["cycleID"]);
						}
					}
					dbg($priceInfo);

					if (count($priceInfo)){

						$backLen = strlen($variantInfo["tldExtension"])+1;

						$domainSLD = substr($productData["domain"], 0, -$backLen);
						$domainTLD = $variantInfo["tldExtension"];

						$setItemXML = "
								<mbapi>
									<command>SetShoppingItem</command>
									<subCommand>insert</subCommand>
									<params>
										<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
										<productID>".(int)$productData["productID"]."</productID>
										<productVariantID>".(int)$productData["productVariantID"]."</productVariantID>
										<cycleID>".(int)$productData["cycleID"]."</cycleID>
										<currencyID>".$this->currencyID."</currencyID>
										<shoppingItemQuantity>1</shoppingItemQuantity>
										<shoppingItemTransferKey>".secureInput($productData["domainTransferKey"])."</shoppingItemTransferKey>
										<shoppingItemSLD>".secureInput($domainSLD)."</shoppingItemSLD>
										<shoppingItemTLD>".secureInput($domainTLD)."</shoppingItemTLD>
										<shoppingItemDomainLanguage>".secureInput($productData["domainLanguage"])."</shoppingItemDomainLanguage>
										<shoppingItemDomainType>".$type."</shoppingItemDomainType>
										<shoppingItemPrice>".doubleval($priceInfo[$priceType]["productVariantPriceAmount"])."</shoppingItemPrice>
										<shoppingItemSetupPrice>".doubleval($priceInfo[1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
										<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
									</params>
								</mbapi>";
						$setItem = dispatchMBAPI($setItemXML, 1);
						if (isset($setItem["mbapi"][0]["header"][0]["lastInsertID"])) {
							$shoppingItemID = $setItem["mbapi"][0]["header"][0]["lastInsertID"][0];
							if (0 < $productData["parentShoppingItemID"]) {
								$parentShoppingItemID = $productData["parentShoppingItemID"];
								$domainShoppingItemIDTag = "<domainShoppingItemID>{$shoppingItemID}</domainShoppingItemID>";
							} else {
								$parentShoppingItemID = $shoppingItemID;
								$domainShoppingItemIDTag = "";
							}
							$setRelXML = "
								<mbapi>
									<command>SetShoppingItemsDomain</command>
									<subCommand>insert</subCommand>
									<params>
										<shoppingItemID>".$parentShoppingItemID."</shoppingItemID>
										<shoppingItemsDomainsType>".$type."</shoppingItemsDomainsType>
										<domainSLD>".secureInput($domainSLD)."</domainSLD>
										<domainTLD>".secureInput($domainTLD)."</domainTLD>
										{$domainShoppingItemIDTag}
									</params>
								</mbapi>";
							$results = dispatchMBAPI($setRelXML, 1); // run it, dont worry about if we fail or not, we can't do anything even if we did...

							if ($results["mbapi"][0]["header"][0]["lastInsertID"]){
								$domainRelID = $results["mbapi"][0]["header"][0]["lastInsertID"][0];
							}

							if ($productData["ID"] && $setItem["mbapi"][0]["header"][0]["lastInsertID"]){
								$this->idMap[$productData["ID"]] = $setItem["mbapi"][0]["header"][0]["lastInsertID"][0];
							}
						}

						$productsInfo = dispatchMBAPI(array(
							'mbapi' => array(
								'command' => 'GetProducts',
								'params' => array(
									'productID' => (int)$productData["productID"],
									'getCouponData' => 1,
									'getPreCouponData' => 1,
									'getCouponIDs' => 1,
								),
							),
						), 1);
						$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);

						$priceInfo = array();

						foreach ($productsInfo as $k=>$v){
							if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
								$this->preappliedCoupons[] = $v["preappliedCoupons"][0]["couponID"];
							}
						}
					} else {
						dbg("couldn't find the price info");
					}

				} else {
					dbg("do nothing since we couldnt find the variant");
				}

			}

			if ($domainRelID && $productData["parentShoppingItemID"] && (int)$productData["primaryDomain"]){
				updateForKey(":shoppingItems", $productData["parentShoppingItemID"], array(
					"shoppingItemPrimaryDomainID" => $domainRelID,
				));
			}

		} elseif ($productData["addType"]=="associateDomain"){

			$setRelXML = "
				<mbapi>
					<command>SetShoppingItemsDomain</command>
					<subCommand>insert</subCommand>
					<params>
						<shoppingItemID>".(int)$productData["parentShoppingItemID"]."</shoppingItemID>
						<shoppingItemsDomainsType>0</shoppingItemsDomainsType>
						<domainSLD>".secureInput($productData["domainSLD"])."</domainSLD>
						<domainTLD>".secureInput($productData["domainTLD"])."</domainTLD>
						<domainShoppingItemID>".(int)$productData["domainShoppingItemID"]."</domainShoppingItemID>
					</params>
				</mbapi>";
			dbg($setRelXML);
			dbg(dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...


		} elseif ($productData["addType"]=="addons"){

			if ($productData["parentShoppingItemID"] && !$productData["shoppingItemID"]){
				$productData["shoppingItemID"] = $productData["parentShoppingItemID"];
			}

			$productIDs = (array)$productData["addonID"];
			$cycleMap = array();
			foreach ($productIDs as $k=>$v){
				if (count(explode("|", $v))>1){
					$v = explode("|", $v);
					$cycleMap[$v[0]] = $v[1];
					$v = (int)$v[0];
				} else {
					$v = (int)$v;
				}
				$productIDs[$k] = $v;
			}

			dbg("product ids of the addons we chose:");
			dbg($productIDs);

			$shoppingItemInfoXML = "<mbapi>
										<command>GetShoppingItems</command>
										<params>
											<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
											<shoppingItemID>".(int)$productData["shoppingItemID"]."</shoppingItemID>
										</params>
									</mbapi>";
			$shoppingItemInfo = dispatchMBAPI($shoppingItemInfoXML, 1);

			if (isset($shoppingItemInfo["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){

				$shoppingItemInfo = correctArray($shoppingItemInfo["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0]);

				$children = Factory()->ShoppingItemList(array('parent_shopping_item_id' => $productData["shoppingItemID"]));
				require_once('object_managers/ShoppingItemManager.php');
				foreach ($children as $shoppingItem)
					ShoppingItemManager::delete($shoppingItem);

				$this->smartyVars["shoppingItemID"] = (int)$productData["shoppingItemID"];
				$this->smartyVars["productID"] = $shoppingItemInfo["productID"];
				$this->smartyVars["cycleID"] = $shoppingItemInfo["cycleID"];
				$this->smartyVars["productVariantID"] = $shoppingItemInfo["productVariantID"];
				dbg("smarty vars");
				dbg($this->smartyVars);

				$productsInfo = dispatchMBAPI(array(
					'mbapi' => array(
						'command' => 'GetProducts',
						'params' => array(
							'parentProductID' => $this->smartyVars["productID"],
							'getCouponData' => 1,
							'getPreCouponData' => 1,
							'getProductVariantData' => 1,
							'getProductVariantPriceData' => 1,
							'getCycleData' => 1,
						),
					),
				), 1);
				$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);

				dbg("prods:");
				dbg($productsInfo);

				foreach ($productsInfo as $k=>$v){

					if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
						$this->preappliedCoupons[] = $v["preappliedCoupons"][0]["couponID"];
					}

					$prices = array();
					$cycleID = (isset($cycleMap[$v["productID"]]))?$cycleMap[$v["productID"]]:$this->smartyVars["cycleID"];
					if (in_array($v["productID"], $productIDs)){
					 	if (isset($productsInfo[$k]["productVariantPrices"])){
						 	foreach ($productsInfo[$k]["productVariantPrices"] as $price){
								if ($price["currencyID"]==$this->currencyID && $price["cycleID"]==$cycleID){
									$prices[$price["productVariantPriceType"]] = $price;
									$productsInfo[$k]["productVariantID"] = $price["productVariantID"];
								}
							}
						} else {
							dbg("variant price not set");
						}
						dbg("prices:");
						dbg($prices);
						$productsInfo[$k]["prices"] = $prices;
						if (count($productsInfo[$k]["prices"])){
							unset($productsInfo[$k]["productVariantPrices"]);
						} else {
					 		unset($productsInfo[$k]);
						}
					} else {
					 	dbg("product id: ".$v["productID"]." not in: ");
					 	dbg($productIDs);
					 	unset($productsInfo[$k]);
					}
				}

				dbg("products info after filtering");

				foreach ($productsInfo as $k=>$v){
					// add each to cart
					$setItemXML = "
							<mbapi>
								<command>SetShoppingItem</command>
								<subCommand>insert</subCommand>
								<params>
									<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
									<productID>".(int)$v["productID"]."</productID>
									<productVariantID>".(int)$v["productVariantID"]."</productVariantID>
									<cycleID>".(int)$v["prices"][0]["cycleID"]."</cycleID>
									<currencyID>".$this->smartyVars["currencyID"]."</currencyID>
									<shoppingItemQuantity>1</shoppingItemQuantity>
									<shoppingItemSLD></shoppingItemSLD>
									<shoppingItemPrice>".doubleval($v["prices"][0]["productVariantPriceAmount"])."</shoppingItemPrice>
									<shoppingItemSetupPrice>".doubleval($v["prices"][1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
									<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
									<parentShoppingItemID>".(int)$productData["shoppingItemID"]."</parentShoppingItemID>
								</params>
							</mbapi>";
					if ($v["prices"][0]){
						$setItem = dispatchMBAPI($setItemXML, 1);
					}
					dbg("result:");
					dbg($setItem);
				}
			} else {
				// do nothing, we didn't get a valid shoppingItemID
			}
		} else {
			if ("certificate" == $productData["addType"])
				$csr_opts = $this->generateCSR();

			$productsInfo = dispatchMBAPI(array(
				'mbapi' => array(
					'command' => 'GetProducts',
					'params' => array(
						'productID' => (int)$productData["productID"],
						'getCouponData' => 1,
						'getPreCouponData' => 1,
						'getCouponIDs' => 1,
						'getProductVariantData' => 1,
						'getProductVariantPriceData' => 1,
					),
				),
			), 1);
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);

			foreach ($productsInfo as $k=>$v){
				$priceInfo = array();
				if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
					$this->preappliedCoupons[] = $v["preappliedCoupons"][0]["couponID"];
				}
				$prices = array();
				dbg($v);

				$validVariants = array();
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					$validVariants[] = $price["productVariantID"];
				}

				if (!(int)$productData["productVariantID"] || !in_array((int)$productData["productVariantID"], $validVariants)){
					$productData["productVariantID"] = $validVariants[0];
				}


				if (isset($productsInfo[$k]["productVariantPrices"])){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						if ($price["currencyID"]==$this->currencyID && $price["cycleID"]==(int)$productData["cycleID"] && $price["productVariantID"]==(int)$productData["productVariantID"]){
							$priceInfo[$price["productVariantPriceType"]] = $price;
						}
					}
				}
			}

			dbg($priceInfo);

			if ($priceInfo[0]){

				$setItemXML = "
						<mbapi>
							<command>SetShoppingItem</command>
							<subCommand>insert</subCommand>
							<params>
								<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
								<productID>".(int)$productData["productID"]."</productID>
								<productVariantID>".(int)$productData["productVariantID"]."</productVariantID>
								<cycleID>".(int)$productData["cycleID"]."</cycleID>
								<currencyID>".$this->currencyID."</currencyID>
								<shoppingItemQuantity>1</shoppingItemQuantity>
								<shoppingItemSLD></shoppingItemSLD>
								<shoppingItemPrice>".doubleval($priceInfo[0]["productVariantPriceAmount"])."</shoppingItemPrice>
								<shoppingItemSetupPrice>".doubleval($priceInfo[1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
								<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
							</params>
						</mbapi>";
				$setItem = dispatchMBAPI($setItemXML, 1);
				dbg("result:");
				dbg($setItem);

				$shopping_item_id = $setItem["mbapi"][0]["header"][0]["lastInsertID"][0];

				if ($productData["ID"] && isset($shopping_item_id) ){
					$this->idMap[$productData["ID"]] = $shopping_item_id;
				}

				if ("certificate" == $productData["addType"])
					$this->saveCSR($shopping_item_id, $csr_opts["csr"], $csr_opts["pkey"], $csr_opts["dn"]);

			} else {
				// no prices....
			}

		} // end adding non domain product
	}

	private function generateCSR()
	{
		// Otherwise CSR creation method: creationmethod
		if ("upload" == bgpc("creationmethod"))
		{
			$csr = bgpc('csr');
			if (false === openssl_csr_get_subject($csr))
				return $this->opensslError(blmsg("TRANS_ORDER_CERT_PURCH_ERROR__INVALID_CSR"), array("csr" => $csr));

			return array(
				"csr" => $csr,
				"pkey" => NULL,
				"dn" => NULL,
			);
		}

		// Otherwise CSR creation method: generation

		$filter = array_flip(array("countryName", "stateOrProvinceName", "localityName", "organizationName", "organizationalUnitName", "commonName", "emailAddress"));
		$dn = array_intersect_key($_REQUEST, $filter);
		foreach ($dn as $name => $value)
			if ("" == $value)
				unset($dn[$name]);

		$r_pkey = openssl_pkey_new(array("private_key_bits" => 2048));
		if (false === $r_pkey)
			return $this->opensslError(blmsg("TRANS_ORDER_CERT_PURCH_ERROR__INTERNAL_ERROR", array("ERROR" => "openssl_pkey_new() failed")), $dn);

		$r_csr = openssl_csr_new($dn, $r_pkey);
		if (false === $r_csr)
			return $this->opensslError(blmsg("TRANS_ORDER_CERT_PURCH_ERROR__INTERNAL_ERROR", array("ERROR" => "openssl_csr_new() failed")), $dn);

		if (false == openssl_pkey_export($r_pkey, $pkey))
			return $this->opensslError(blmsg("TRANS_ORDER_CERT_PURCH_ERROR__INTERNAL_ERROR", array("ERROR" => "openssl_pkey_export() failed")), $dn);

		if (false == openssl_csr_export($r_csr, $csr))
			return $this->opensslError(blmsg("TRANS_ORDER_CERT_PURCH_ERROR__INTERNAL_ERROR", array("ERROR" => "openssl_csr_export() failed")), $dn);

		return array(
			"csr" => $csr,
			"pkey" => $pkey,
			"dn" => $dn,
		);
	}

	private function saveCSR($shopping_item_id, $csr, $pkey = NULL, $dn = NULL)
	{
		$params = Factory()->ShoppingItem($shopping_item_id)->ShoppingItemParams;
		foreach ($dn as $key => $val)
			$params[$key]->value = $val;

		if (! is_null($pkey))
			$params['PVT']->value = $pkey;

		$params['CSR']->value = $csr;
		$params['WebServerType']->value = bgpc('webServerType', 0);
		$params->update();

		unset(getCurrentSession()->Storage->order_errored_csr);
	}

	private function opensslError($title, $dn)
	{
		$sess = getCurrentSession();
		foreach ($dn as $key => $val)
			$sess->Storage->order_errored_csr[$key] = $val;

		$err_msg = "";
		while (($e = openssl_error_string()) !== false)
    		$err_msg .= $e . "\n";
		$sess->Storage->errorMessages[] = "" != $err_msg ? "{$title}: {$err_msg}" : $title;

		redirect(action_url("cart", "ShowSSLCertificatePurchase", array(
			"storeID" => bgpc("storeID"),
			"widgetTemplate" => bgpc("widgetTemplate"),
			"productID" => bgpc("productID"),
			"productVariantPriceID" => bgpc("productVariantPriceID"),
			"productVariantID" => bgpc("productVariantID"),
			"cycleID" => bgpc("cycleID"),
			"sid" => bgpc("sid"))));
	}

	protected function mergeWidgetData($websiteWidgetID=0)
	{
		$productIDs = array();
		if ((int)$websiteWidgetID){
			$websiteWidgetInfo = oneByID(":websiteWidgets", $websiteWidgetID);
			if ($websiteWidgetInfo["websiteWidgetID"]){
				$hadWidget = 1;
				$productIDsArray = arrayFor(":websiteWidgetsProductsRels", array(
					"websiteWidgetID" => $websiteWidgetInfo["websiteWidgetID"],
					"sortColumn" => "websiteWidgetOrder",
					"sortDir" => "ASC",
				));
				foreach ($productIDsArray as $par){
					$productIDs[] = $par["productID"];
				}
			}
		}
		if (!$productIDs && $this->smartyVars["shoppingSession"]["orderFormID"] && !$hadWidget){
			$productIDsArray = arrayFor(":orderFormItems", array(
				"orderFormID" => $this->smartyVars["shoppingSession"]["orderFormID"],
			));
			foreach ($productIDsArray as $par){
				$productIDs[] = $par["productID"];
			}
		}

		if ($productIDs){

////////////////////////////////////////////////////////////////////////////
			$this->smartyVars["orderFormID"] = $this->smartyVars["shoppingSession"]["orderFormID"];
			$this->smartyVars["orderFormInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetOrderForms",
					"params" => array(
						"orderFormID" => $this->smartyVars["shoppingSession"]["orderFormID"],
						"getCouponData" => 1,
					),
				),
			)));

			$this->currencyID = $this->smartyVars["currencyID"] = $this->smartyVars["orderFormInfo"]["currencyID"];

			dbg($this->smartyVars["orderFormInfo"]);

			$this->allowedCoupons = array();

			foreach ((array)$this->smartyVars["orderFormInfo"]["coupons"] as $coupon){
				$this->allowedCoupons[$coupon["productID"]][$coupon["couponID"]] = $coupon;
			}

			$productsInfo = getMBAPIArray("GetProducts", array(
				"productID" => $productIDs,
				"productActive" => 1,
				"getProductAttributeData" => 1,
				"getCouponData" => 1,
				"getPreCouponData" => 1,
				"getAllOrderFormItemData" => 1,
				"getProductVariantData" => 1,
				"getProductVariantPriceData" => 1,
				"getTLDData" => 1,
				"getCycleData" => 1,
				"getCycleGhostIDs" => 1,
			));
			dbg($productsInfo);

			foreach ($productsInfo as $k=>$product){
				if ($product["productDomainRequired"]==getAPIStatusID("productdependencyrules", "cannot")){
					unset($productsInfo[$k]);
				}
			}
			$productsInfo = array_values($productsInfo);

			$keyedProducts = array();
			$this->smartyVars["keyedVariants"] = array();
			$numVariants = 0;
			$numCycles = 0;
			foreach ($productsInfo as $k=>$v){

				if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
					$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
					if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
						$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
					} else {
						$preappliedCoupon = 0;
					}
				} else {
					$preappliedCoupon = 0;
				}

				$keyedProducts[$v["productID"]] =& $productsInfo[$k];

				foreach ((array)$productsInfo[$k]["productVariants"] as $vk=>$vv){
					$numVariants++;
					$this->smartyVars["keyedVariants"][$vv["productVariantID"]] =& $productsInfo[$k]["productVariants"][$vk];
				}

				$validCycles = array();
				foreach ((array)$v["ghostCycles"] as $cycle){
					$numCycles++;
					$validCycles[] = $cycle["cycleID"];
				}

				dbg("testing product: ".$v["productID"]);
				$prices = array();
				if (isset($productsInfo[$k]["productVariantPrices"])){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						if (in_array($price["cycleID"], $validCycles)){
							$prices[$price["currencyID"]][$price["productVariantID"]."-".$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
				} else {
					dbg("didnt find prices");
				}
				foreach ($prices as $currency => $rows){
					$productPrice = array_values($rows);
					if ($preappliedCoupon){
						foreach ((array)$productPrice as $xk=>$tempprice){
							$productPrice[$xk][0]["discountAmount"] = $this->getCouponAmount($tempprice[0], $preappliedCoupon);
							$productPrice[$xk][0]["discountPrice"] = $productPrice[$xk][0]["productVariantPriceAmount"]-$productPrice[$xk][0]["discountAmount"];
						}
					}
					$productsInfo[$k]["prices"][$currency] = $productPrice;
				}
				$productsInfo[ $k ]["productComments"] = utf8_html_entity_decode($productsInfo[$k]["productComments"]);
				unset($productsInfo[$k]["productVariantPrices"]);
			}

			$this->smartyVars["products"] = array();

			foreach ($productIDs as $id){
				if ($keyedProducts[$id]){
					$this->smartyVars["products"][] = $keyedProducts[$id];
				}
			}

			dbg("smarty vars:");
			dbg($this->smartyVars);

			// count the number of products to help display differeny type of widgets
			$c = count($this->smartyVars["products"]);
			$this->smartyVars["numProducts"] = $c;

////////////////////////////////////////////////////////////////////////////

		}

	}

	protected function addPreappliedCoupons($ids)
	{
		$ids = array_unique((array)$ids);

		$coupons = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetShoppingCoupons",
				"params" => array(
					"shoppingSessionID" => $this->shoppingSessionData["shoppingSessionID"],
				),
			),
		));

		$skip = array();
		foreach ((array)$coupons as $coupon){
			$skip[] = $coupon["couponID"];
		}
		foreach ($ids as $cid){
			if (!in_array($cid, $skip)){
				dispatchMBAPI(array(
					"mbapi" => array(
						"command" => "SetShoppingCoupon",
						"subCommand" => "insert",
						"params" => array(
							"shoppingSessionID" => $this->shoppingSessionData["shoppingSessionID"],
							"couponID" => $cid,
							"shoppingCouponType" => 1,
						),
					),
				));
			}
		}

	}

	private function getCouponAmount($price, $coupon)
	{
		if ((int)$coupon["couponType"]){
			return $coupon["couponDiscount"];
		} else {
			return round(($coupon["couponDiscount"]/100)*$price["productVariantPriceAmount"], 2);
		}

	}

	protected $shoppingSessionData;
	protected $currencyID;
}
