<?php

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/order/include/order/order.php");

class ShowCart extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$this->smartyVars = array();

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		$this->mergeCycleData();

		$order_form = Factory()->OrderForm($shoppingSessionData["orderFormID"]);
		require_once("object_managers/TaxZoneManager.php");
		$default_tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);

		$apply_vat_taxes = (0 == $shoppingSessionData["clientID"]) ? false : TaxZoneManager::isAppliesVatToClient($shoppingSessionData["clientID"]);
		$this->smartyVars["show_vat"] = $apply_vat_taxes;
		if (!is_null($default_tax_zone) && 0 == $shoppingSessionData["clientContactID"]) {
		    require_once("BillingLocale.php");
		    $this->smartyVars["show_vat"] = true;
		    $this->smartyVars["price_include_tax"] = blmsg("TRANS_INCLUDE_VAT_TO_PRODUCT_PRICES", array("number" => BillingLocale::getPercentNumber(floatval($default_tax_zone->tax_zone_amount))));
		}

		$orderObjectParams = array(
			"ofid" => $shoppingSessionData["orderFormID"],
			"sid" => $shoppingSessionData["shoppingSessionID"],
			"set_locale" => $_REQUEST["set_locale"],
		);
		$order = new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;

		$this->smartyVars["skipDomain"] = (in_array("dom_skip", (array)$order->domainOptions))?1:0;

		$this->smartyVars["continueShoppingURL"] = str_replace("%SID%", $_REQUEST["sid"], $order->continueShoppingURL);

		$shoppingCouponsXML = "	<mbapi>
									<command>GetShoppingCoupons</command>
									<params>
										<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
										<getCouponsData>1</getCouponsData>
									</params>
								</mbapi>";
		$shoppingCoupons = (array)correctArray(grabSimpleMBAPIResults(dispatchMBAPI($shoppingCouponsXML, 1)));

		$this->smartyVars["coupons"] = $shoppingCoupons;

		$shoppingItemsXML = "
				<mbapi>
					<command>GetShoppingItems</command>
					<params>
						<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
						<getDomainsRelData>1</getDomainsRelData>
					</params>
				</mbapi>";

		$shoppingItems = dispatchMBAPI($shoppingItemsXML, 1);

		dbg("shopping items:");
		dbg($shoppingItems);

		if (is_array($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0])){
			$shoppingItems = correctArray($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"]);
		} else {
			$shoppingItems = array();
		}


		$getProductIDs = array();
		$getProductVariantIDs = array();
		$getProductIDs[0] = 1;
		foreach ($shoppingItems as $row){
			$getProductIDs[$row["productID"]] = 1;
			$getProductVariantIDs[$row["productVariantID"]] = 1;
		}

////////////////////////////////////////
		// get products info here:
   		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", array_keys($getProductIDs))."</productID>
									<filterVariants>
										<productVariantID>".@implode("</productVariantID><productVariantID>", array_keys($getProductVariantIDs))."</productVariantID>
									</filterVariants>
									<getCouponData>1</getCouponData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getCycleData>1</getCycleData>
									<getCycleGhostIDs>1</getCycleGhostIDs>
							</params>
						</mbapi>";
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		if (isset($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0])){
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);
		} else {
			$productsInfo = array();
		}

		dbg("products info");
		dbg($productsInfo);

		$this->mergeCycleDiscountGroups();

		$this->smartyVars["products"] = array();
		$this->smartyVars["keyedVariants"] = array();
		foreach ($productsInfo as $row){
			$coupons = array();

			if (isset($row["coupons"])){
				foreach ($row["coupons"] as $coupon){
					$coupons[$coupon["couponID"]] = $coupon;
				}
			}
			$row["coupons"] = $coupons;
			$validCycles = array();
			foreach ((array)$row["ghostCycles"] as $cycle){
				$numCycles++;
				$_REQUEST["onlyCycleID"] = $cycle["cycleID"];
				$validCycles[] = $cycle["cycleID"];
			}
			$row["numCycles"] = count($validCycles);

			foreach ((array)$row["productVariants"] as $vk=>$vv){
				$this->smartyVars["keyedVariants"][$vv["productVariantID"]] =& $row["productVariants"][$vk];
			}
			$row["productComments"] = utf8_html_entity_decode( $row["productComments"] );
			$this->smartyVars["products"][$row["productID"]] = $row;
		}

		$keyedItems = array();
		$keyedDomains = array();
		$domainProducts = array();

		$order_tax = $order_subtotal = $order_total = 0;
		foreach ($shoppingItems as $row){
			if ($row["shoppingItemSLD"]){
				$domainProducts[$row["shoppingItemID"]] = $row;
			}
			if (isset($row["domains"])){
				dbg("DOMAIN EXISTED!");
				foreach ($row["domains"] as $row2){
					$keyedDomains[$row2["domainShoppingItemID"]] = $row2;
				}
			} else {
				$row["domains"] = array();
			}
			$appliedCoupons = array();
			$couponTotal = 0;
			foreach ($this->smartyVars["coupons"] as $k=>$coupon){
				if ((int)$this->smartyVars["products"][$row["productID"]]["coupons"][$coupon["couponID"]]["couponID"]
				 && !count($appliedCoupons)
				 && ($coupon["couponApplyNumber"]==0 || $coupon["applied"]<1)){
					if ((int)$coupon["couponType"]){
					 	$coupon["discount"] = $coupon["couponDiscount"];
					} else {
						$coupon["discount"] = round(($coupon["couponDiscount"]/100)*$row["shoppingItemPrice"], 2);
					}
					$coupon["negdiscount"] = 0-$coupon["discount"];
					$appliedCoupons[] = $coupon;
					$this->smartyVars["coupons"][$k]["discountTotal"] = round($this->smartyVars["coupons"][$k]["discountTotal"]+$coupon["discount"], 2);
					$this->smartyVars["coupons"][$k]["applied"]++;
					$couponTotal = round($coupon["discount"]+$couponTotal, 2);
				}
			}
			$row["appliedCoupons"] = $appliedCoupons;
			$row["couponTotal"] = $couponTotal;

			$cycleDiscountGroupID = $this->smartyVars['keyedVariants'][$row['productVariantID']]['cycleDiscountGroupID'];
			if (0 < $cycleDiscountGroupID && $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$row['cycleID']]) {
				$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$row['cycleID']];
				if (0 < $discount) {
					$discountableAmount = round($row['shoppingItemPrice'] - $row['couponTotal'], 2);
					$row['originalPrice'] = $row['shoppingItemPrice'];
					$cycleDiscount = round($discountableAmount * $discount / 100, 2);
					$row['shoppingItemPrice'] = round($row['originalPrice'] - $cycleDiscount, 2);
				}
			}

			if (0 != $shoppingSessionData["clientID"]) {
				$tax_zones = ($apply_vat_taxes) ? TaxZoneManager::getVatTaxZones($row["productVariantID"], $shoppingSessionData["clientID"]): array();
			} else {
				$tax_zones = (is_null($default_tax_zone)) ? array() : array($default_tax_zone);
			}
			$taxable_amount = $row["shoppingItemPrice"]-$row["couponTotal"]+$row["shoppingItemSetupPrice"];
			$row["shoppingItemTaxes"] = TaxZoneManager::getProductTaxAmount($taxable_amount, $tax_zones);

			$order_tax += $row["shoppingItemTaxes"];
			$order_subtotal += $taxable_amount;
			$order_total += $taxable_amount + $row["shoppingItemTaxes"];

			$key = (int)$row["parentShoppingItemID"];

			if (!$this->smartyVars["products"][$row["productID"]]["productIsAddon"]){
				if ($key>0){
					$row["domains"][] = array(
						"shoppingItemsDomainsRelID" => 0,
						"shoppingItemsDomainsType" => 0,
						"domainID" => 0,
						"domainSLD" => $domainProducts[$key]["shoppingItemSLD"],
						"domainTLD" => $domainProducts[$key]["shoppingItemTLD"],
						"domainShoppingItemID" => $key,
					);
				}

				$key = 0; // uncomment to make it show as its own line item instead of a child entry
			}

			$keyedItems[$key][] = $row;
		}

		$this->smartyVars["orderSubtotal"] = $order_subtotal;
		$this->smartyVars["orderTax"] = $order_tax;
		$this->smartyVars["orderTotal"] = $order_total;
		$this->smartyVars["shoppingItems"] = (array)$keyedItems[0];

		foreach ($this->smartyVars["shoppingItems"] as $k=>$v){
		 	$this->smartyVars["shoppingItems"][$k]["children"] = $keyedItems[$v["shoppingItemID"]];
		}

		$this->smartyVars["incorrectLogin"] = secureInput($_REQUEST["incorrectLogin"]);

		dbg("Smarty Vars:");
		dbg($this->smartyVars);
		$this->addTemplate("shopping/ShowCart", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
