<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");
require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("order/include/order/order.php");
require_once("lib-action/include/wizard/Wizard.php");

/**
 * This Action object displays a form for a person to register as a client and submit
 * payment information, or just submit payment information if they are already a client.
 */
class ShowCartCheckoutForm extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();
		loadConfigs("payment");

		$this->smartyVars["hasDomain"] = 0;
		// all the stuff necessary to get info for the cart summary display here:

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		$this->mergeCycleData();

		$order_form = Factory()->OrderForm($shoppingSessionData["orderFormID"]);
		require_once("object_managers/TaxZoneManager.php");
		$default_tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);
		$apply_vat_taxes = (0 == $shoppingSessionData["clientID"]) ? false : TaxZoneManager::isAppliesVatToClient($shoppingSessionData["clientID"]);
		$this->smartyVars["show_vat"] = $apply_vat_taxes;
		if (!is_null($default_tax_zone) && 0 == $shoppingSessionData["clientContactID"]) {
		    require_once("BillingLocale.php");
		    $this->smartyVars["show_vat"] = true;
		    $this->smartyVars["price_include_tax"] = blmsg("TRANS_INCLUDE_VAT_TO_PRODUCT_PRICES", array("number" => BillingLocale::getPercentNumber(floatval($default_tax_zone->tax_zone_amount))));
		}

		$orderObjectParams = array(
			"ofid" => $shoppingSessionData["orderFormID"],
			"sid" => $shoppingSessionData["shoppingSessionID"],
			"set_locale" => $_REQUEST["set_locale"],
		);
		$order = new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;
		$this->smartyVars["orderParams"] = $order->getOrderParams();
		$languagesArray = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetLanguages</command><params><languageISO2>".$CONF["user"]["locale"]->language."</languageISO2></params></mbapi>", 1)));
		dbg("languages:");
		dbg($languagesArray);
		foreach ($languagesArray as $language) {
			$order->orderFormLanguageID = $language["languageID"];
		}

		$this->smartyVars["continueShoppingURL"] = str_replace("%SID%", $_REQUEST["sid"], $order->continueShoppingURL);

		$shoppingCouponsXML = "	<mbapi>
						<command>GetShoppingCoupons</command>
						<params>
							<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
							<getCouponsData>1</getCouponsData>
						</params>
					</mbapi>";
		$shoppingCoupons = (array)correctArray(grabSimpleMBAPIResults(dispatchMBAPI($shoppingCouponsXML, 1)));

		$this->smartyVars["coupons"] = $shoppingCoupons;

		$shoppingItemsXML = "
				<mbapi>
					<command>GetShoppingItems</command>
					<params>
						<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
						<getDomainsRelData>1</getDomainsRelData>
					</params>
				</mbapi>";
		$shoppingItems = dispatchMBAPI($shoppingItemsXML, 1);

		if (isset($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
			$shoppingItems = correctArray($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"]);
		} else {
			$shoppingItems = array();
		}

		dbg("shopping items:");
		dbg($shoppingItems);


		$getProductIDs = array();
		$getProductVariantIDs = array();
		$getProductIDs[0] = 1;
		foreach ($shoppingItems as $row){
		 	$getProductIDs[$row["productID"]] = 1;
		 	$getProductVariantIDs[$row["productVariantID"]] = 1;
		}

////////////////////////////////////////
		// get products info here:
   		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", array_keys($getProductIDs))."</productID>
									<filterVariants>
										<productVariantID>".@implode("</productVariantID><productVariantID>", array_keys($getProductVariantIDs))."</productVariantID>
									</filterVariants>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getCycleData>1</getCycleData>
									<getGhostCycleIDs>1</getGhostCycleIDs>
							</params>
						</mbapi>";
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		if (isset($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0])){
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);
		} else {
			$productsInfo = array();
		}
		dbg("products info");
		dbg($productsInfo);

		$this->smartyVars["products"] = array();
		$this->smartyVars["keyedVariants"] = array();
		foreach ($productsInfo as $row){
			$coupons = array();
			if (isset($row["coupons"])){
				foreach ($row["coupons"] as $coupon){
					$coupons[$coupon["couponID"]] = $coupon;
				}
			}
			$row["productComments"] = utf8_html_entity_decode( $row["productComments"] );
			$row["coupons"] = $coupons;
			$row["numCycles"] = count($row["ghostCycles"]);
			$this->smartyVars["products"][$row["productID"]] = $row;
			foreach ((array)$row["productVariants"] as $vk=>$vv){
				$this->smartyVars["keyedVariants"][$vv["productVariantID"]] =& $row["productVariants"][$vk];
			}
		}

////////////////////////////////////////

		$this->mergeCycleDiscountGroups();

		$keyedItems = array();
		$keyedDomains = array();
		$this->smartyVars["domainsExtraInfo"] = array();
		$this->smartyVars["wizardShoppingItems"] = array();

		$order_tax = $order_subtotal = $order_total = 0;
		foreach ($shoppingItems as $row){

			$this->smartyVars["wizardShoppingItems"][$row["shoppingItemID"]] = $row["productID"];
			if ($this->smartyVars["products"][$row["productID"]]["productType"]==getAPITypeID("products", "domain")){
 				$this->smartyVars["hasDomain"] = 1;
 				dbg("is a domain");
 				if ($row["shoppingItemDomainType"]==0){
 					dbg("getting extra info");
					$domdata = getTLDParamsData($row["shoppingItemSLD"].".".$row["shoppingItemTLD"]);
					dbg("extra info was");
					dbg($domdata);
					if ($domdata){
						dbg("added it to smarty");
						$this->smartyVars["domainsExtraInfo"][$row["shoppingItemSLD"].".".$row["shoppingItemTLD"]] = correctArray($domdata);
						$domdata = NULL;
					} else {
						dbg("didn't add it to smarty");
					}
				}
			} else {
				dbg("NOT a domain.");
			}
		 	if (isset($row["domains"])){
		 		dbg("DOMAIN EXISTED!");
				foreach ($row["domains"] as $row2){
				 	$keyedDomains[$row2["domainShoppingItemID"]] = $row2;
				}
			} else {
				$row["domains"] = array();
			}
			$appliedCoupons = array();
			$couponTotal = 0;
			foreach ($this->smartyVars["coupons"] as $k=>$coupon){
				if ((int)$this->smartyVars["products"][$row["productID"]]["coupons"][$coupon["couponID"]]["couponID"]
				 && !count($appliedCoupons)
				 && ($coupon["couponApplyNumber"]==0 || $coupon["applied"]<1)){
					if ((int)$coupon["couponType"]){
					 	$coupon["discount"] = $coupon["couponDiscount"];
					} else {
						$coupon["discount"] = round(($coupon["couponDiscount"]/100)*$row["shoppingItemPrice"], 2);
					}
					$coupon["negdiscount"] = 0-$coupon["discount"];
					$appliedCoupons[] = $coupon;
					$this->smartyVars["coupons"][$k]["discountTotal"] = round($this->smartyVars["coupons"][$k]["discountTotal"]+$coupon["discount"], 2);
					$this->smartyVars["coupons"][$k]["applied"]++;
					$couponTotal = round($coupon["discount"]+$couponTotal, 2);
				}
			}
			$row["appliedCoupons"] = $appliedCoupons;
			$row["couponTotal"] = $couponTotal;

			$cycleDiscountGroupID = $this->smartyVars['keyedVariants'][$row['productVariantID']]['cycleDiscountGroupID'];
			if (0 < $cycleDiscountGroupID && $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$row['cycleID']]) {
				$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$row['cycleID']];
				if (0 < $discount) {
					$discountableAmount = round($row['shoppingItemPrice'] - $row['couponTotal'], 2);
					$row['originalPrice'] = $row['shoppingItemPrice'];
					$cycleDiscount = round($discountableAmount * $discount / 100, 2);
					$row['shoppingItemPrice'] = round($row['originalPrice'] - $cycleDiscount, 2);
				}
			}

			if (0 != $shoppingSessionData["clientID"]) {
				$tax_zones = ($apply_vat_taxes) ? TaxZoneManager::getVatTaxZones($row["productVariantID"], $shoppingSessionData["clientID"]): array();
			} else {
				$tax_zones = (is_null($default_tax_zone)) ? array() : array($default_tax_zone);
			}
			$taxable_amount = $row["shoppingItemPrice"]-$row["couponTotal"]+$row["shoppingItemSetupPrice"];
			$row["shoppingItemTaxes"] = TaxZoneManager::getProductTaxAmount($taxable_amount, $tax_zones) ;

			$order_tax += $row["shoppingItemTaxes"];
			$order_subtotal += $taxable_amount;
			$order_total += $taxable_amount + $row["shoppingItemTaxes"];

			$key = (int)$row["parentShoppingItemID"];

			if (!$this->smartyVars["products"][$row["productID"]]["productIsAddon"]){
				//$key = 0;
			}

			$keyedItems[$key][] = $row;
		}

		$this->smartyVars["orderSubtotal"] = $order_subtotal;
		$this->smartyVars["orderTax"] = $order_tax;
		$this->smartyVars["orderTotal"] = $order_total;


		$this->smartyVars["shoppingItems"] = (array)$keyedItems[0];

		foreach ($this->smartyVars["shoppingItems"] as $k=>$v){
		 	$this->smartyVars["shoppingItems"][$k]["children"] = $keyedItems[$v["shoppingItemID"]];
		}

		$this->smartyVars["incorrectLogin"] = secureInput($_REQUEST["incorrectLogin"]);

		dbg("Smarty Vars:");
		dbg($this->smartyVars);

		$this->smartyVars["paymentOptions"] = $order->getPaymentOptions();
		$this->smartyVars["accounttypes"] = $CONF["types"]["bankAccount"];
		for ($i=date("Y"); $i<date("Y")+21; $i++){
			$this->smartyVars["cardYears"][$i] = $i;
		}

		if (!$this->smartyVars["paymentOptions"]["cc"] && !$this->smartyVars["paymentType"]){
			if ($this->smartyVars["paymentOptions"]["check"]){
				$this->smartyVars["paymentType"] = 3;
			} elseif ($this->smartyVars["paymentOptions"]["invoice"]){
				$this->smartyVars["paymentType"] = 50;
			} elseif ($this->smartyVars["paymentOptions"]["secondary"]){
				$this->smartyVars["paymentType"] = "2|".key($this->smartyVars["paymentOptions"]["secondary"]);
			} elseif ($this->smartyVars["paymentOptions"]["echeck"]){
				$this->smartyVars["paymentType"] = 4;
			}
		}

		if (! is_null($this->smartyVars["paymentOptions"]["hspc_bank_transfer_gateway_id"]))
		{
			require_once("ModuleTool.php");
			$client_contact_id = NULL;

			if ((int)$shoppingSessionData["clientID"])
			{
				$client = Factory()->Client((int)$shoppingSessionData["clientID"]);
				$client_contact_id = $client->PrimaryContact->client_contact_id;
			}
			$hspc_pp_plugin = ModuleTool::getModuleInstance("gateway", "HSPCBankTransfer", array(
				"gateway_id" => $this->smartyVars["paymentOptions"]["hspc_bank_transfer_gateway_id"],
				"client_contact_id" => $client_contact_id,
			));
			$form = $hspc_pp_plugin->getPaymentMethodForm("add");
			$this->smartyVars["paymentOptions"]["hspc_payment_method"] = $form["payment_method"];
			$this->smartyVars["paymentOptions"]["hspc_payment_method_form"] = $form["form_content"];
		}

		$this->smartyVars["billingAccounts"] = array();
		require_once("objects/Client.php");
		$client_types = Client::types();
		$this->smartyVars["commercialCompanyCustomerType"] = Client::TYPE_COMMERCIAL_COMPANY;
		// end cart item information getting
		if ((int)$shoppingSessionData["clientID"]){

			$results = dispatchMBAPI("
				<mbapi>
					<command>GetClients</command>
					<params>
						<clientID>".(int)$shoppingSessionData["clientID"]."</clientID>
						<getContactData>1</getContactData>
						<getBillingData>1</getBillingData>
					</params>
				</mbapi>", 1);
			$clientInfo = collapsePluralsAndSingulars(grabSimpleMBAPIResults($results));
			$clientInfo = $clientInfo[0];
			$contactInfo = $clientInfo["contacts"][0];
			dbg($clientInfo);

			switch ($clientInfo["clientStatus"]){
				case getAPIStatusID("client", "fraudulent"):
				case getAPIStatusID("client", "suspended"):
				case getAPIStatusID("client", "inactive"):
					$this->smartyVars["cantCheckout"] = 1;
				break;
			}

			$clientInfo["billingAccounts"] = (array)$clientInfo["billingAccounts"];
			require_once("objects/ClientBillingAccount.php");
			foreach ( $clientInfo["billingAccounts"] as $acct ) {
				switch ( $acct["billingAccountType"] ) {
				case ClientBillingAccount::TYPE_CREDIT_CARD:
					require_once("object_managers/CryptManager.php");
					if ( !$this->smartyVars["paymentOptions"]["cc"] || !array_key_exists($acct["billingCardType"], $this->smartyVars["paymentOptions"]["cardTypes"]) || !CryptManager::isLekEnabled() ) {
						break;
					}
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".getTypeName("card", $acct["billingCardType"])." - Last 4 Digits: ".$acct["billingAccountNumLastFour"]." - ".$acct["billingCardNameOnCard"];
					break;
				case ClientBillingAccount::TYPE_ECHECK:
					if ( !$this->smartyVars["paymentOptions"]["echeck"] ) {
						break;
					}
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".$acct["billingBankName"]." - Last 4 Digits: ".$acct["billingAccountNumLastFour"];
					break;
				case ClientBillingAccount::TYPE_HSPC_BANK_TRANSFER:
					if ( is_null($this->smartyVars["paymentOptions"]["hspc_bank_transfer_gateway_id"]) ) {
						break;
					}
					require_once("ModuleTool.php");
					$hspc_pp_plugin = ModuleTool::getModuleInstance("gateway", "HSPCBankTransfer", array(
						"gateway_id" => $this->smartyVars["paymentOptions"]["hspc_bank_transfer_gateway_id"],
						"billing_account_id" => $acct["billingAccountID"],
					));
					$public_number = $hspc_pp_plugin->getPublicNumber();
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - Last 4 Digits: ".$public_number;
					break;
				}
			}

			$this->smartyVars["suppressFields"] = $clientInfo["clientActive"];
			$this->smartyVars["checkoutFormInfo"] = array(
				"taxIDNumber" => $clientInfo["taxIDNumber"],
				"clientType" => blmsg($client_types[$clientInfo["clientType"]]),
				"clientFirstName" => $contactInfo["contactFirstName"],
				"registrantFirstName" => $contactInfo["contactFirstName"],
				"clientLastName" => $contactInfo["contactLastName"],
				"registrantLastName" => $contactInfo["contactLastName"],
				"clientCompany" => $contactInfo["contactCompany"],
				"registrantOrganizationName" => $contactInfo["contactCompany"],
				"contactAddress1" => $contactInfo["contactAddress1"],
				"registrantAddress1" => $contactInfo["contactAddress1"],
				"contactAddress2" => $contactInfo["contactAddress2"],
				"registrantAddress2" => $contactInfo["contactAddress2"],
				"contactCity" => $contactInfo["contactCity"],
				"registrantCity" => $contactInfo["contactCity"],
				"contactState" => $contactInfo["contactState"],
				"registrantStateProvince" => $contactInfo["contactState"],
				"countriesID" => $contactInfo["countriesID"],
				"languageID" => $contactInfo["languageID"],
				"registrantCountry" => $contactInfo["countriesID"],
				"contactZip" => $contactInfo["contactZip"],
				"registrantPostalCode" => $contactInfo["contactZip"],
				"clientEmail" => $contactInfo["contactEmail"],
				"registrantEmail" => $contactInfo["contactEmail"],
				"contactPhone1" => $contactInfo["contactPhone1"],
				"registrantPhone" => $contactInfo["contactPhone1"],
				"contactFax" => $contactInfo["contactFax"],
				"registrantFax" => $contactInfo["contactFax"],
				"requestTaxVatID" => $productsInfo[0]["orderForms"][0]["requestTaxVatID"],
			);
		} else {
			$this->smartyVars["checkoutFormInfo"] = array();
			foreach ($client_types as $key => $type) {
				$this->smartyVars["clientTypes"][$key] = blmsg($type);
			}
			if (0 == $productsInfo[0]["orderForms"][0]["enableIndividualEnterpreneurType"]) {
				unset($this->smartyVars["clientTypes"][Client::TYPE_INDIVIDUAL_ENTERPRENEUR]);
			}
			$this->smartyVars["checkoutFormInfo"]["requestTaxVatID"] = $productsInfo[0]["orderForms"][0]["requestTaxVatID"];
		}

		if ( empty($this->smartyVars["billingAccounts"]) &&
			!$this->smartyVars["paymentOptions"]["cc"] &&
			!$this->smartyVars["paymentOptions"]["echeck"] &&
			empty($this->smartyVars["paymentOptions"]["secondary"]) &&
			is_null($this->smartyVars["paymentOptions"]["hspc_bank_transfer_gateway_id"]) &&
			1 != $this->smartyVars["paymentOptions"]["check"] &&
			1 != $this->smartyVars["paymentOptions"]["draft"] &&
			1 != $this->smartyVars["paymentOptions"]["invoice"]
		) {
			// no available payment methods, we can not checkout form
			$this->smartyVars["cantCheckout"] = 1;
		}

		if ($_REQUEST["mb_domain_info"]){
			$regInfo = unserialize(base64_decode($_REQUEST["mb_domain_info"]));
			dbg("reg info:");
			dbg($regInfo);
			if ($regInfo["registrantFirstName"]){
//			if (is_array($regInfo)){
				$this->smartyVars["checkoutFormInfo"]["registrantFirstName"] = $regInfo["registrantFirstName"];
				$this->smartyVars["checkoutFormInfo"]["registrantLastName"] = $regInfo["registrantLastName"];
				$this->smartyVars["checkoutFormInfo"]["registrantOrganizationName"] = $regInfo["registrantOrganizationName"];
				$this->smartyVars["checkoutFormInfo"]["registrantAddress1"] = $regInfo["registrantAddress1"];
				$this->smartyVars["checkoutFormInfo"]["registrantAddress2"] = $regInfo["registrantAddress2"];
				$this->smartyVars["checkoutFormInfo"]["registrantCity"] = $regInfo["registrantCity"];
				$this->smartyVars["checkoutFormInfo"]["registrantStateProvince"] = $regInfo["registrantStateProvince"];
				$this->smartyVars["checkoutFormInfo"]["registrantCountry"] = $regInfo["registrantCountry"];
				$this->smartyVars["checkoutFormInfo"]["registrantPostalCode"] = $regInfo["registrantPostalCode"];
				$this->smartyVars["checkoutFormInfo"]["registrantEmail"] = $regInfo["registrantEmail"];
				$this->smartyVars["checkoutFormInfo"]["registrantPhone"] = $regInfo["registrantPhone"];
				$this->smartyVars["checkoutFormInfo"]["registrantFax"] = $regInfo["registrantFax"];
				$this->smartyVars["checkoutFormInfo"]["registrantJobTitle"] = $regInfo["registrantJobTitle"];
			}
		}

		$this->mergeCountryData();
		$this->mergeLanguageData();
		if (is_null($this->smartyVars["checkoutFormInfo"]["languageID"])){
			$this->smartyVars["checkoutFormInfo"]["languageID"] = $order->orderFormData["languageID"][0];
		}
		if (!$this->smartyVars["checkoutFormInfo"]["countriesID"]){
			$this->smartyVars["checkoutFormInfo"]["countriesID"] = $order->orderFormData["countriesID"][0];
		}
		if (!$this->smartyVars["checkoutFormInfo"]["registrantCountry"]){
			$this->smartyVars["checkoutFormInfo"]["registrantCountry"] = $order->orderFormData["countriesID"][0];
		}

		dbg($CONF["shoppingSession"]);

		define("WIZARD_CART_DISPLAY", 1);


		$pidar = array_keys($getProductIDs);
		if (!count($pidar))$pidar = array(0);

		// get order form based attributes
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"orderFormID" => $shoppingSessionData["orderFormID"]
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		$keyed_product_attributes = array();
		$all_question_ids = array();
		foreach ((array)$attributes as $attribute){
			// we key these on 0 because they are for the order form not a product.
			$keyed_product_attributes[0][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
		}

		// get products attributes stuff
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"productID" => $pidar
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		foreach ((array)$attributes as $attribute){
			$keyed_product_attributes[(int)$attribute["productID"]][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
		}
		dbg("keyed attributes");
		dbg($keyed_product_attributes);


#################################################################################################
#################################################################################################


		$this->smartyVars["shoppingItemQuestions"] = array();


		$questions = new MBQuery("GetWizardQuestions", "", array("questionID"=>$all_question_ids));
		if ($this->addErrorsFromResult($r =& $questions->getResult())){
			$s =& $r->getSubjectFrom(array("mbapi", "results", "questions", "question"));
			$t =& $s->getTable("questionID");
			$questionsByID = $t->getAssociatedBy("questionID");

			$questionParams = new MBQuery("GetWizardQuestionParams", "", array("questionID" => $all_question_ids, "getParamValues" => 1));
			if ($this->addErrorsFromResult($r =& $questionParams->getResult())){
				$s =& $r->getSubjectFrom(array("mbapi", "results", "questionParams", "questionParam"));
				$t =& $s->getTable("questionParamID");
				$questionParamTablesByID = $t->getAssociatedTablesBy("questionID");

				$questionParamValueSubjectsByID =& $s->getAdditionalDataBy("questionParamID", "questionParamValues", "questionParamValue");
				$questionParamValuesByID = array();
				foreach($questionParamValueSubjectsByID as $questionParamID => $paramSubject) {
					$questionParamValuesByID[$questionParamID] = $paramSubject->getStructure();
				}

				dbg("question objects and stuff");
				dbg($questionsByID);
				dbg($questionParamTablesByID);
				dbg($questionParamValuesByID);


				$this->smartyVars["showShoppingItemQuestions"] = 0;
				$this->smartyVars["showCustomerQuestions"] = 0;
				$this->smartyVars["wizardShoppingItems"][0] = 0; // for order form attributes

				foreach ($this->smartyVars["wizardShoppingItems"] as $shoppingItemID=>$productID){

					$questionIDs = $keyed_product_attributes[$productID];

					if (count($questionIDs)){

						$w = new Wizard(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
						$w->setID($shoppingItemID);
						$w->cached = true;

						$s = new WizardStep(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
						$s->setID($shoppingItemID);

						foreach ($questionIDs as $questionID){
							if (isset($questionParamTablesByID[$questionID])){
								$q = new WizardQuestion(QUESTION_INPUT_HIDDEN, "");
								$q->setID($questionID);
								$params = $questionParamTablesByID[$questionID]->getTable();
								foreach($params as $param) {
									if ($param["questionParamName"]=="setType"){
										$valueArray =& $questionParamValuesByID[$param["questionParamID"]];
										if ($valueArray[0]=="QUESTION_INPUT_HIDDEN"){
										} else {
											if ($shoppingItemID){
												$this->smartyVars["showShoppingItemQuestions"] = 1;
											} else {
												$this->smartyVars["showCustomerQuestions"] = 1;
											}
										}
									}
									call_user_func_array(
										array(&$q, $param["questionParamName"]),
										array_map(
											array('ShowCartCheckoutForm', 'constantize'),
											$questionParamValuesByID[$param["questionParamID"]]
										)
									);
								}
								$s->addQuestion($q);
							}
						}
						$w->addSteps($s);
						$w->fetch = true;
						$this->smartyVars["shoppingItemQuestion"][$shoppingItemID] = str_replace("&amp;", "&", $w->displayNextStep());

					}

				}
			}
		}

#################################################################################################
#################################################################################################

		dbg("SMARTY VAHS!");
		dbg($this->smartyVars);

		$this->addTemplate("shopping/ShowCartCheckoutForm", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	/**
	 * if a value is a constant, resolve it
	 *
	 * @param  string  value
	 * @return  string|constant  value or resolved value
	 */
	private function constantize($value)
	{
		return defined($value) ? constant($value) : $value;
	}
}
