<?php
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/order/include/order/order.php");

/**
 * This Action object collects information on a products associated addon children products and displays it.
 *
 * @author  Kris Bailey
 */
class ShowCartProductAddons extends MB_Action {
	/**
	 * The constructor for a ShowCartProductAddons action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowCartProductAddons() {
		parent::MB_Action();
		$this->stringRep = "ShowCartProductAddons";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the AddCartDomain action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		dbg("request:");
		dbg($_REQUEST);

		$this->smartyVars = array();
//		$this->smartyVars["orderThemeDirectory"] = $CONF["relativeWebRoot"]."/order/include/themes/".$CONF["theme"]["name"];

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);

		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$order = new Order($orderObjectParams);
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;

		$this->smartyVars["shoppingItemID"] = (int)$_REQUEST["shoppingItemID"];
		$this->smartyVars["productID"] = (int)$_REQUEST["productID"];
		$this->smartyVars["cycleID"] = (int)$_REQUEST["cycleID"];
		$this->smartyVars["productVariantID"] = (int)$_REQUEST["productVariantID"];

		$order_form = Factory()->OrderForm($shoppingSessionData["orderFormID"]);
		require_once("object_managers/TaxZoneManager.php");
		$default_tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);
		$apply_vat_taxes = (0 == $shoppingSessionData["clientID"]) ? false : TaxZoneManager::isAppliesVatToClient($shoppingSessionData["clientID"]);

		$getSelectedAddonsXML = "<mbapi>
										<command>GetShoppingItems</command>
										<params>
											<parentShoppingItemID>".(int)$_REQUEST["shoppingItemID"]."</parentShoppingItemID>
										</params>
									</mbapi>";
		$selectedAddons = dispatchMBAPI($getSelectedAddonsXML, 1);
		dbg("selected addons");
		dbg($selectedAddons);
		$this->smartyVars["selectedAddons"] = array();
		if (is_array($selectedAddons) && is_array($selectedAddons["mbapi"][0]["results"]) && is_array($selectedAddons["mbapi"][0]["results"][0]) && is_array($selectedAddons["mbapi"][0]["results"][0]["shoppingItems"]) && is_array($selectedAddons["mbapi"][0]["results"][0]["shoppingItems"][0]) && is_array($selectedAddons["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"]) && isset($selectedAddons["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0]["shoppingItemID"][0])){
			foreach ($selectedAddons["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"] as $row){
				$this->smartyVars["selectedAddons"][$row["productID"][0]] = 1;
			}
		}

		$tempProductsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI(array(
			'mbapi' => array(
				'command' => 'GetProducts',
				'params' => array(
					'parentProductID' => $this->smartyVars["productID"],
					'cycleID' => $this->smartyVars["cycleID"],
					'orderFormID' => $order->orderFormID,
					'productActive' => 1,
					'getCouponData' => 1,
					'getPreCouponData' => 1,
					'getProductVariantData' => 1,
					'getProductVariantPriceData' => 1,
					'getCycleData' => 1,
				),
			),
		), 1)));

		$productsInfo = array();
		require_once("object_managers/ProductManager.php");
		foreach ($tempProductsInfo as $key => $product) {
			$currentProduct = Factory()->Product($product["productID"]);
			if (ProductManager::isValidStoreHostingProduct($currentProduct)) {
				$productsInfo[] = $product;
			}
		}

		foreach ($productsInfo as $addon){
			$groups[$addon["productAddonGroupID"]] = 1;
		}
		$groups = array_keys((array)$groups);
		$groups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"getGroupsByProductID" => $this->smartyVars["productID"]
				)
			)
		)));

		$this->smartyVars["addonGroups"] = array();
		foreach ((array)$groups as $group){
			if (1 == $group["productAddonGroupActive"]) {
				$this->smartyVars["addonGroups"][$group["productAddonGroupID"]] = $group;
			}
		}

		dbg("prods:");
		dbg($productsInfo);

		foreach ((array)$productsInfo as $k=>$product){
			if (!isset($this->smartyVars["addonGroups"][$product["productAddonGroupID"]])){
				unset($productsInfo[$k]);
			}
		}

		if (!is_array($productsInfo)){
		 	$productsInfo = array();
		}

		$mainProducts = array();
		$keyedVariants = array();

		$this->mergeCycleDiscountGroups();

		foreach ($productsInfo as $k=>$v){
			if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
				$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
				if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
					$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
				} else {
					$preappliedCoupon = 0;
				}
			} else {
				$preappliedCoupon = 0;
			}

			foreach ($productsInfo[$k]["productVariants"] as $kv => $vv) {
				$keyedVariants[$vv['productVariantID']] =& $productsInfo[$k]["productVariants"][$kv];
			}

			$prices = array();
			$validCycles = array();
			foreach ((array)$v["ghostCycles"] as $cycle){
				$numCycles++;
				if (!(int)$_REQUEST["cycleID"]){
					$_REQUEST["onlyCycleID"] = $cycle["cycleID"];
				}
				$validCycles[] = $cycle["cycleID"];
			}
			if (isset($productsInfo[$k]["productVariantPrices"])){
				if ($v["productIsAddon"]){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("cycle id: ".$price["cycleID"]);
						dbg("match to cycle: ".$this->smartyVars["cycleID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"] && $price["cycleID"]==$this->smartyVars["cycleID"]){
							$prices[$price["productVariantPriceType"]] = $price;
						}
					}
					if (0 != $shoppingSessionData["clientID"]) {
						$tax_zones = ($apply_vat_taxes) ? TaxZoneManager::getVatTaxZones($prices[0]["productVariantID"], $shoppingSessionData["clientID"]): array();
					} else {
						$tax_zones = (is_null($default_tax_zone)) ? array() : array($default_tax_zone);
					}
					if ($preappliedCoupon){
						$prices[0]["discountAmount"] = $this->getCouponAmount($prices[0], $preappliedCoupon);
						$prices[0]["discountPrice"] = $prices[0]["productVariantPriceAmount"]-$prices[0]["discountAmount"];
					}
					$cycleDiscountGroupID = $keyedVariants[$prices[0]['productVariantID']]['cycleDiscountGroupID'];
					if (isset($this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$prices[0]['cycleID']])) {
						$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$prices[0]['cycleID']];
						if (isset($prices[0]["discountPrice"])) {
							$discountableAmount = $prices[0]["discountPrice"];
						} else {
							$discountableAmount = $prices[0]['productVariantPriceAmount'];
						}
						$prices[0]["discountAmount"] += round($discountableAmount * ($discount / 100), 2);
					}
					if (0 < $prices[0]["discountAmount"]) {
						$prices[0]["discountPrice"] = TaxZoneManager::getProductGrossPrice($prices[0]["productVariantPriceAmount"]-$prices[0]["discountAmount"], $tax_zones) ;
					}
					$prices[0]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($prices[0]["productVariantPriceAmount"], $tax_zones);
					$prices[1]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($prices[1]["productVariantPriceAmount"], $tax_zones) ;
				} else {
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"] && in_array($price["cycleID"], $validCycles)){
							$prices[$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
					foreach ($prices as $cycleID => $tempprice) {
						if (0 != $shoppingSessionData["clientID"]) {
							$tax_zones = ($apply_vat_taxes) ? TaxZoneManager::getVatTaxZones($prices[$cycleID][0]["productVariantID"], $shoppingSessionData["clientID"]): array();
						} else {
							$tax_zones = (is_null($default_tax_zone)) ? array() : array($default_tax_zone);
						}
						if ($preappliedCoupon){
							$prices[$cycleID][0]["discountAmount"] = $this->getCouponAmount($tempprice[0], $preappliedCoupon);
						}
						$cycleDiscountGroupID = $keyedVariants[$tempprice[0]['productVariantID']]['cycleDiscountGroupID'];
						if (isset($this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']])) {
							$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']];
							$prices[$cycleID][0]["discountAmount"] += round($tempprice[0]['productVariantPriceAmount'] * ($discount / 100), 2);
						}
						if (0 < $prices[$cycleID][0]["discountAmount"]) {
							$prices[$cycleID][0]["discountPrice"] = TaxZoneManager::getProductGrossPrice($prices[$cycleID][0]["productVariantPriceAmount"]-$prices[$cycleID][0]["discountAmount"], $tax_zones) ;
						}
						$prices[$cycleID][0]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($prices[0]["productVariantPriceAmount"], $tax_zones);
						$prices[$cycleID][1]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($prices[1]["productVariantPriceAmount"], $tax_zones);
					}
				}
			} else {
				dbg("variant price not set");
			}
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
			} else {
				unset($productsInfo[$k]);
			}
		}



		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
		}

		$this->smartyVars["products"] = $keyedAddons;
		$this->mergeCycleData();

		dbg("Smarty Vars:");
		dbg($this->smartyVars);

		$this->addTemplate("shopping/ShowCartProductAddons", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
?>
