<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");
require_once("order/include/lib-action/shopping/AddCartStepAction.php");

class ShowCartProductAddonsStep extends AddCartStepAction
{
	public function execute()
	{
		parent::execute();

		if (!is_null($productVariantPriceID = bgpc("productVariantPriceID"))) {
			$productVariantPrice = Factory()->ProductVariantPrice($productVariantPriceID);
			$productVariantID = $productVariantPrice->product_variant_id;
			$cycleID = $productVariantPrice->cycle_id;
		} else {
			$productVariantID = bgpc("productVariantID");
			$cycleID = bgpc("cycleID");
		}

		$orderFormID = isset($this->shoppingSessionData["orderFormID"]) ? $this->shoppingSessionData["orderFormID"] : bgpc("orderFormID");
		$this->mergeProductData(bgpc("productID"), $productVariantID,  $orderFormID, $cycleID);
		$this->mergeProductAddonsData(bgpc("productID"), $cycleID, $productVariantID);

		if ( "domains" == bgpc("source") ) {
			$this->smartyVars["selectedDomains"] = bgpc("domains");
		}

		$this->addTemplate("shopping/ShowCartProductAddonsStep", $this->smartyVars);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
