<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");
require_once("order/include/lib-action/shopping/AddCartStepAction.php");

class ShowMultiDomainWhoisStep extends AddCartStepAction
{
	public function execute()
	{
		parent::execute();

		if (!is_null($productVariantPriceID = bgpc("productVariantPriceID"))) {
			$productVariantPrice = Factory()->ProductVariantPrice($productVariantPriceID);
			$productVariantID = $productVariantPrice->product_variant_id;
			$cycleID = $productVariantPrice->cycle_id;
		} else {
			$productVariantID = bgpc("productVariantID");
			$cycleID = bgpc("cycleID");
		}

		$this->mergeProductData(bgpc("productID"), $productVariantID, $this->shoppingSessionData["orderFormID"], $cycleID);
		$this->mergeProductAddonsData(bgpc("productID"), $cycleID, $productVariantID);
		if ( "addons" == bgpc("source") ) {
			$this->smartyVars["selectedAddons"] = array();
			foreach ((array)$_REQUEST["items"] as $item){
				foreach ((array)$item["addonID"] as $aid){
					$this->smartyVars["selectedAddons"][$aid] = 1;
				}
			}
		}

		$this->mergeMultiDomainData($this->shoppingSessionData["orderFormID"], bgpc("domainSLD"), bgpc("domainTLD"));

		$domains = getMBAPIArray("GetShoppingItemsDomains", array(
			"shoppingSessionID" => bgpc("sid"),
		));
		$this->smartyVars["domainsInCart"] = array();
		foreach ($domains as $d){
			$this->smartyVars["domainsInCart"][$d["domainSLD"].".".$d["domainTLD"]] = 1;
		}

		dbg($this->smartyVars);

		$this->addTemplate("shopping/ShowMultiDomainWhoisStep", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
