<?php
require_once dirname(__FILE__)."/AddCartStepAction.php";

class ShowOrderFormProductsStep extends AddCartStepAction
{
	public function execute()
	{
		parent::execute();

		require_once mb_path("/order/include/order/order.php");
		$orderObjectParams = array(
			"ofid" => $this->shoppingSessionData["orderFormID"],
			"sid" => $this->shoppingSessionData["shoppingSessionID"],
			"set_locale" => $_REQUEST["set_locale"],
		);
		$order = new Order($orderObjectParams);

		$this->currencyID = $order->orderFormCurrency;

		if ((int)$_REQUEST["finalStep"]){

			if (!(int)$_REQUEST["hostingProduct"]){
				$this->addCartProduct(array(
					"sid" => $this->shoppingSessionData["shoppingSessionID"],
					"productID" => $_REQUEST["productID"],
					"productVariantID" => $_REQUEST["productVariantID"],
					"addType" => "domain",
					"cycleID" => $_REQUEST["cycleID"],
					"domain" => $_REQUEST["domainSLD"].".".$_REQUEST["domainTLD"],
				));
				$this->smartyVars["domainAdded"] = 1;
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			} else {
				$hostingProductInfo = explode("|", $_REQUEST["hostingProduct"]);
				$this->addCartProduct(array(
					"sid" => $this->shoppingSessionData["shoppingSessionID"],
					"ID" => 1111,
					"productID" => $hostingProductInfo[0],
					"productVariantID" => $hostingProductInfo[1],
					"cycleID" => $hostingProductInfo[2],
					"domainTransferKey" => $_REQUEST["domainTransferKey"],
				));
				$this->addCartProduct(array(
					"sid" => $this->shoppingSessionData["shoppingSessionID"],
					"parentID" => 1111,
					"productID" => $_REQUEST["productID"],
					"productVariantID" => $_REQUEST["productVariantID"],
					"cycleID" => $_REQUEST["cycleID"],
					"domainTransferKey" => $_REQUEST["domainTransferKey"],
					"addType" => "domain",
					"domain" => $_REQUEST["domainSLD"].".".$_REQUEST["domainTLD"],
				));
				$this->smartyVars["domainAdded"] = 1;
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			}
		} else {
			$this->mergeWidgetData((int)$_REQUEST["websiteWidgetID"]);
			if ($this->smartyVars["numProducts"]==0){
				$this->addCartProduct(array(
					"sid" => $this->shoppingSessionData["shoppingSessionID"],
					"productID" => $_REQUEST["productID"],
					"productVariantID" => $_REQUEST["productVariantID"],
					"addType" => "domain",
					"cycleID" => -2,
					"domain" => $_REQUEST["domainSLD"].".".$_REQUEST["domainTLD"],
					"domainTransferKey" => $_REQUEST["domainTransferKey"],
				));
				$this->smartyVars["domainAdded"] = 1;
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			} else {
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
