<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");

require_once("order/include/lib-action/shopping/AddCartStepAction.php");
class ShowSSLCertificatePurchase extends AddCartStepAction
{
	public function execute()
	{
		parent::execute();
		if (!is_null($productVariantPriceID = bgpc("productVariantPriceID"))) {
			$productVariantPrice = Factory()->ProductVariantPrice($productVariantPriceID);
			$productVariantID = $productVariantPrice->product_variant_id;
			$cycleID = $productVariantPrice->cycle_id;
		} else {
			$productVariantID = bgpc("productVariantID");
			$cycleID = bgpc("cycleID");
		}
		$orderFormID = isset($this->shoppingSessionData["orderFormID"]) ? $this->shoppingSessionData["orderFormID"] : bgpc("orderFormID");

		$product = Factory()->Product(bgpc("productID"));

		$this->mergeProductData($product->id, $productVariantID, $orderFormID, $cycleID);
		$this->mergeProductAddonsData($product->id, $cycleID, $productVariantID);
		$this->mergeMultiDomainData($orderFormID, bgpc("domainSLD"), bgpc("domainTLD"));

		$this->smartyVars["nextActionName"] = "AddCartProductResponse";

		$productAttributes = $product->ProductAttributes;
		$attributes = array();
		foreach ($productAttributes as $pattr)
			$attributes[$pattr->name] = $pattr->value;

		// Get plugin instance
		require_once('lib-mbapi/include/modules/sslmodule/sslmodule.php');
		$sslPlugin = SSLModule::getPluginInstance($productAttributes["ssl_plugin_id"]->value, array( "productID" => $product->id));

		list($defaultWebServerType, $webServerTypes) = $sslPlugin->webServerTypes($attributes);

		$webServerTypeControl = UIFactory()->InputDropDown("webServerType");
		$webServerTypeControl->value = $defaultWebServerType;

		foreach ($webServerTypes as $type_code => $type_name)
			$webServerTypeControl->addOption($type_code, $type_name);

		$this->smartyVars["webServerType"] = $webServerTypeControl->getHTML();
		$this->smartyVars["csr"] = getCurrentSession()->Storage->order_errored_csr;

		$this->addTemplate("shopping/ShowSSLCertificatePurchase", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
