<?php
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class ShowWebsiteWidget extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		if ($_GET['top_frame']) {
			$this->addTemplate("website_widgets/include/topFrame", array());
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		dbg("at the top of website widget show action.");

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();
		$this->smartyVars["shoppingSession"] = $shoppingSessionData;
		$this->mergeCycleData();

		dbg("at the top of website widget show action. 2");

		$this->smartyVars["shopURL"] = billing_base_url().mb_path_convert_path("/order")."/products.php";
		$this->smartyVars["plainCartURL"] = billing_base_url().mb_path_convert_path("/order")."/cart.php";
		$this->smartyVars["cartURL"] = $this->smartyVars["plainCartURL"]."?sid=".bgpc("sid");

		dbg("at the top of website widget show action. 3");

		$shopURLArgs = array();
		$getProductIDs = array();
		if ( !is_null($websiteWidgetID = bgpc("wwid")) ) {
			$wwInfo = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetWebsiteWidgets",
					"params" => array(
						"websiteWidgetID" => $websiteWidgetID,
						"getProductInformation" => 1,
					),
				),
			)));
			if ( !isset($wwInfo["websiteWidgetID"]) ) {
				throw new Exception("Invalid widget ID: {$websiteWidgetID}");
			}
			$order_form = Factory()->OrderForm($wwInfo["orderFormID"]);
			if ( isset($wwInfo["products"]) ) {
				foreach ( $wwInfo["products"] as $product ) {
					$getProductIDs[] = $product["productID"];
				}
			}
			$widgetTemplate = $wwInfo["websiteWidgetTpl"];
			$shopURLArgs["wwid"] = $websiteWidgetID;
		} else {
			if ( !is_null($orderFormID = bgpc("storeID")) ) {
				$order_form = Factory()->OrderForm($orderFormID);
			} else {
				require_once("object_managers/OrderFormManager.php");
                $order_form = OrderFormManager::getDefaultForm();
			}
			require_once("object_managers/ProductManager.php");
			foreach ( $order_form->ProductList() as $product ) {
				if ( 1 == $product->product_active && ProductManager::isValidStoreHostingProduct($product)) {
					$getProductIDs[] = $product->id;
				}
			}
			if ( is_null($widgetTemplate = bgpc("widgetTemplate")) ) {
				$widgetTemplate = $order_form->default_widget_template;
			}
		}

		// if gross price display then get the tax zone
		require_once("object_managers/TaxZoneManager.php");
		$tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);
		if (!is_null($tax_zone)) {
			require_once("BillingLocale.php");
			$this->smartyVars["price_include_tax"] = blmsg("TRANS_INCLUDE_VAT_TO_PRODUCT_PRICES", array("number" => BillingLocale::getPercentNumber(floatval($tax_zone->tax_zone_amount))));
		}

		$shopURLArgs["storeID"] = $order_form->id;
		$shopURLArgs["widgetTemplate"] = $widgetTemplate;
		$this->smartyVars["shopURLArgs"] = http_build_query($shopURLArgs);
		$this->smartyVars["currencyID"] = $order_form->currency_id;

		dbg("at the top of website widget show action. 4");

		$this->smartyVars["orderFormInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetOrderForms",
				"params" => array(
					"orderFormID" => $order_form->id,
					"getCouponData" => 1,
				),
			),
		)));
		dbg($this->smartyVars["orderFormInfo"]);

		$this->allowedCoupons = array();

		foreach ((array)$this->smartyVars["orderFormInfo"]["coupons"] as $coupon){
			$this->allowedCoupons[$coupon["productID"]][$coupon["couponID"]] = $coupon;
		}


		$shoppingSessionData = $this->shoppingSessionData = $this->updateShoppingSession(bgpc("sid"), $order_form->id);

		dbg("at the top of website widget show action. 5");

		if (count($getProductIDs) == 0) {
			$getProductIDs = array(0);
		}

		$getProductIDs = array_unique($getProductIDs);

		dbg("at the top of website widget show action. 6");

		dbg("ids to get:");
		dbg($getProductIDs);

		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", $getProductIDs)."</productID>
									<productActive>1</productActive>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getAllOrderFormItemData>1</getAllOrderFormItemData>
									<getOrderFormItemData>1</getOrderFormItemData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<filterVariants>
										<productVariantActive>1</productVariantActive>
									</filterVariants>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
									<getCycleGhostIDs>1</getCycleGhostIDs>
							</params>
						</mbapi>";
		dbg("SEARCH FOR ME");
		require_once mb_path("/lib-mbapi/mbapi.php");
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		$productsInfo = correctArray(grabSimpleMBAPIResults($productsInfo));

		dbg($productsInfo);

		dbg("at the top of website widget show action. 7");

        $this->smartyVars["numClients"] = (int) numClients;
        if ($this->smartyVars["numClients"] > 100) {
            $this->smartyVars["formDisabled"] = "disabled";
        }
		$this->smartyVars["configGroupID"] = $configGroupID;
		$this->smartyVars["configParams"] = $CONF["other"]["ppc"]["ppcfactory"];

		// Is PPCFactory enabled?
		loadConfigs("other");
		if ($CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]) {
			require_once mb_path("/lib-billing/include/config/internal/cycles.php");
			$monthlyCycles = getCyclesArray("monthly");
		}

		$this->mergeCycleDiscountGroups();

		$keyedProducts = array();
		$this->smartyVars["keyedVariants"] = array();
		$numVariants = 0;
		$numCycles = 0;
		foreach ($productsInfo as $k=>$v){


			$keyedAttributes = array();
			foreach ((array)$v["productAttributes"] as $attribute){
				$keyedAttributes[$attribute["productAttributeName"]] = $attribute["productAttributeValue"];
			}
			$productsInfo[$k]["keyedAttributes"] = $keyedAttributes;

			if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
				$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
				if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
					$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
				} else {
					$preappliedCoupon = 0;
				}
			} else {
				$preappliedCoupon = 0;
			}

			$keyedProducts[$v["productID"]] = & $productsInfo[$k];

			foreach ((array)$productsInfo[$k]["productVariants"] as $vk=>$vv){
				$numVariants++;
				$this->smartyVars["keyedVariants"][$vv["productVariantID"]] =& $productsInfo[$k]["productVariants"][$vk];
				if (0 < $vv['cycleDiscountGroupID'])
					$cycleDiscountGroupIDs[] = $vv['cycleDiscountGroupID'];
			}

			$validCycles = array();
			foreach ((array)$v["ghostCycles"] as $cycle){
				$numCycles++;
				if (!(int)$_REQUEST["cycleID"]){
					$_REQUEST["onlyCycleID"] = $cycle["cycleID"];
				}
				$validCycles[] = $cycle["cycleID"];
			}

			dbg("testing product: ".$v["productID"]);
			$prices = array();
			if (isset($productsInfo[$k]["productVariantPrices"])){
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					if (in_array($price["cycleID"], $validCycles)){
						$_REQUEST["onlyProductVariantID"] = $price["productVariantID"];
						$prices[$price["currencyID"]][$price["productVariantID"]."-".$price["cycleID"]][$price["productVariantPriceType"]] = $price;
					}
				}
			} else {
				dbg("didnt find prices");
			}
			foreach ($prices as $currency => $rows){
				$productPrice = array_values($rows);
				foreach ((array)$productPrice as $xk=>$tempprice){
					// if gross price display then get the price + tax

					if ($preappliedCoupon) {
						$productPrice[$xk][0]["discountAmount"] = $this->getCouponAmount($productPrice[$xk][0], $preappliedCoupon);
						$productPrice[$xk][0]["discountPrice"] = $productPrice[$xk][0]["productVariantPriceAmount"]-$productPrice[$xk][0]["discountAmount"];
					}
					$cycleDiscountGroupID = $this->smartyVars["keyedVariants"][$productPrice[$xk][0]["productVariantPriceAmount"]["productVariantID"]]['cycleDiscountGroupID'];
					if (isset($this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']])) {
						$discount = $this->smartyVars['cycleDiscountGroups'][$cycleDiscountGroupID]['discounts'][$tempprice[0]['cycleID']];
						if (isset($productPrice[$xk][0]["discountPrice"])) {
							$discountableAmount = $productPrice[$xk][0]["discountPrice"];
						} else {
							$discountableAmount = $productPrice[$xk][0]['productVariantPriceAmount'];
						}
						$productPrice[$xk][0]["discountAmount"] += round($discountableAmount * ($discount / 100), 2);
						$productPrice[$xk][0]["discountPrice"] = TaxZoneManager::getProductGrossPrice($productPrice[$xk][0]["productVariantPriceAmount"]-$productPrice[$xk][0]["discountAmount"], array($tax_zone));

					}
					$productPrice[$xk][0]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($tempprice[0]["productVariantPriceAmount"], array($tax_zone));
					$productPrice[$xk][1]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($tempprice[1]["productVariantPriceAmount"], array($tax_zone));
				}

				$productsInfo[$k]["prices"][$currency] = $productPrice;

				// only run PPC logic if enabled
				if ($CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]) {

					// only run PPC logic if hosting product in USD currency
					if ($productsInfo[$k]["productType"] == 1 && $currency == "USD") {

						// set the current package cycleID
						$cycleID = $productPrice[0][0]["cycleID"];

						// only run the PPC logic if the cycleID is in the "monthly" group
						if (array_key_exists($cycleID, $monthlyCycles)) {

							// find the multiplier for this cycle
							$cycleMultiplier = $CONF["cycles"][$cycleID][1];

							// only run if we have a valid multiplier
							if ($cycleMultiplier) {

								// ** THESE ARE HARD CODED BUSINESS RULES FOR DISPLAY PURPOSES ONLY **
								// ** DO NOT EDIT **
								$monthlyPrice = round($productPrice[0][0]["productVariantPriceAmount"] / $cycleMultiplier);
								if ($monthlyPrice <= 25) {
									$codeValue = "25.00";
								} else if ($monthlyPrice <= 100) {
									$codeValue = "50.00";
								} else if ($monthlyPrice > 100) {
									$codeValue = "75.00";
								}
								$productsInfo[$k]["adWordsCredit"] = $codeValue;
								// ** DO NOT EDIT **
								// ** THESE ARE HARD CODED BUSINESS RULES FOR DISPLAY PURPOSES ONLY **
							} // $cycleMultiplier
						} // array_key_exists
					} // productType && USD
				} // enablePPCfactory

			}
			$productsInfo[ $k ]["productComments"] = html_entity_decode( $productsInfo[ $k ]["productComments"] );
			unset($productsInfo[$k]["productVariantPrices"]);
		}

		$this->smartyVars["products"] = array();

		foreach ($getProductIDs as $id)
		{
			if(isset($keyedProducts[$id]))
			{
				$this->smartyVars["products"][] = $keyedProducts[$id];
			}
		}

		dbg("smarty vars:");
		dbg($this->smartyVars);

		dbg("at the top of website widget show action. 8");

		// count the number of products to help display differeny type of widgets
		$c = count($this->smartyVars["products"]);
		$this->smartyVars["numProducts"] = $c;
		$this->smartyVars["ceilProducts"] = ceil($c / 2);
		$this->smartyVars["evenProducts"] = ($c % 2) ? 1 : 0 ;
		$this->smartyVars["adWordsExpiresDate"] = date("m/d/Y",mktime(0,0,0,date("m"),date("d")+15,date("y")));


		if ($c==1 && ($numVariants==1 || $_REQUEST["productVariantID"]) && ($numCycles==1 || $_REQUEST["cycleID"])){
			if (!$_REQUEST["cycleID"]){
				$_REQUEST["cycleID"] = $_REQUEST["onlyCycleID"];
			}
			if (!$_REQUEST["productVariantID"]){
				$_REQUEST["productVariantID"] = $_REQUEST["onlyProductVariantID"];
			}
			$this->addAddonsDataToWidget($this->smartyVars["products"][0]["productID"], $_REQUEST["cycleID"], $_REQUEST["onlyProductVariantID"], $order_form);
		}

		$this->addTemplate("website_widgets/{$widgetTemplate}", $this->smartyVars);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function getCouponAmount($price, $coupon)
	{
		if ((int)$coupon["couponType"]){
			return $coupon["couponDiscount"];
		} else {
			return round(($coupon["couponDiscount"]/100)*$price["productVariantPriceAmount"], 2);
		}

	}

	private function addAddonsDataToWidget($productID, $cycleID, $productVariantID, $order_form)
	{
		$shoppingSessionData = $this->shoppingSessionData;
		// if gross price display then get the tax zone
		require_once("object_managers/TaxZoneManager.php");
		$tax_zone = TaxZoneManager::getDefaultTaxZone($order_form);

//		$this->smartyVars["currencyID"] = $order->orderFormCurrency;
		$this->smartyVars["productID"] = $productID;
		$this->smartyVars["cycleID"] = $cycleID;
		$this->smartyVars["productVariantID"] = $productVariantID;


		$getAddonsXML = "	<mbapi>
								<command>GetProducts</command>
								<params>
									<parentProductID>".$this->smartyVars["productID"]."</parentProductID>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getAllOrderFormItemData>1</getAllOrderFormItemData>
									<getOrderFormItemData>1</getOrderFormItemData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
								</params>
							</mbapi>";
		$productsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI($getAddonsXML, 1)));


		foreach ($productsInfo as $addon){
			$groups[$addon["productAddonGroupID"]] = 1;
		}
		$groups = array_keys((array)$groups);
		$groups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"getGroupsByProductID" => $this->smartyVars["productID"]
				)
			)
		)));

		$this->smartyVars["addonGroups"] = array();
		foreach ((array)$groups as $group){
			$this->smartyVars["addonGroups"][$group["productAddonGroupID"]] = $group;
		}

		dbg("prods:");
		dbg($productsInfo);

		foreach ((array)$productsInfo as $k=>$product){
			if (!isset($this->smartyVars["addonGroups"][$product["productAddonGroupID"]]) && (int)$product["productAddonGroupID"]){
				unset($productsInfo[$k]);
			}
		}

		if (!is_array($productsInfo)){
		 	$productsInfo = array();
		}

		$mainProducts = array();

		foreach ($productsInfo as $k=>$v){

			if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
				$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
				if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
					$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
				} else {
					$preappliedCoupon = 0;
				}
			} else {
				$preappliedCoupon = 0;
			}

			$prices = array();
			if (isset($productsInfo[$k]["productVariantPrices"])){
				if ($v["productIsAddon"]){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("cycle id: ".$price["cycleID"]);
						dbg("match to cycle: ".$this->smartyVars["cycleID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"] && $price["cycleID"]==$this->smartyVars["cycleID"]){
							$prices[$price["productVariantPriceType"]] = $price;
						}
					}
				} else {
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"]){
							$prices[$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
				}
			} else {
				dbg("variant price not set");
			}
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
				foreach ($productsInfo[$k]["prices"] as $currency => $rows){
					// if gross price display then get the price + tax
					if (!is_null($tax_zone)) {
						$productsInfo[$k]["prices"][$currency][0]["productVariantPriceAmount"] = TaxZoneManager::getProductGrossPrice($rows[0]["productVariantPriceAmount"], array($tax_zone));
					}
					if ($preappliedCoupon){
							$productsInfo[$k]["prices"][$currency][0]["discountAmount"] = $this->getCouponAmount($productsInfo[$k]["prices"][$currency][0], $preappliedCoupon);
							$productsInfo[$k]["prices"][$currency][0]["discountPrice"] = $productsInfo[$k]["prices"][$currency][0]["productVariantPriceAmount"]-$productsInfo[$k]["prices"][$currency][0]["discountAmount"];
					}
				}
			} else {
				unset($productsInfo[$k]);
			}

		}

		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
		}

		$this->smartyVars["addonproducts"] = $keyedAddons;
		$this->mergeCycleData();
	}
}
